// Map made by Rikikipu - Feb 2017
include "mercenaries.xs";
include "ypAsianInclude.xs";
include "ypKOTHInclude.xs";
//1-4 : X	5-8 : Z
float vexteriorPoint1=0.65; float vexteriorPoint2=0.25; float vexteriorPoint3=0.35; float vexteriorPoint4=0.75; 
float vexteriorPoint5=0.65; float vexteriorPoint6=0.75; float vexteriorPoint7=0.35; float vexteriorPoint8=0.25; 

float getexteriorPoint(int num=-1) {
	if(num==1) return(vexteriorPoint1); if(num==2) return(vexteriorPoint2); 
	if(num==3) return(vexteriorPoint3); if(num==4) return(vexteriorPoint4); 
	if(num==5) return(vexteriorPoint5); if(num==6) return(vexteriorPoint6); 
	if(num==7) return(vexteriorPoint7); if(num==8) return(vexteriorPoint8); 
	
	return(0);	// should never be reached
}
	
float setexteriorPoint(int num=-1, float val=0) {
if(num==1) vexteriorPoint1 = val; if(num==2) vexteriorPoint2 = val; 
	if(num==3) vexteriorPoint3 = val; if(num==4) vexteriorPoint4 = val; 
	if(num==5) vexteriorPoint5 = val; if(num==6) vexteriorPoint6 = val; 
	if(num==7) vexteriorPoint7 = val; if(num==8) vexteriorPoint8 = val; 
	
	return(0);	// should never be reached
}


//1-4 : X	5-8 : Z
float vIslandPoint1=0.5; float vIslandPoint2=0.4; float vIslandPoint3=0.5; float vIslandPoint4=0.6; 
float vIslandPoint5=0.5; float vIslandPoint6=0.6; float vIslandPoint7=0.5; float vIslandPoint8=0.4; 

float getIslandPoint(int num=-1) {
	if(num==1) return(vIslandPoint1); if(num==2) return(vIslandPoint2); 
	if(num==3) return(vIslandPoint3); if(num==4) return(vIslandPoint4); 
	if(num==5) return(vIslandPoint5); if(num==6) return(vIslandPoint6); 
	if(num==7) return(vIslandPoint7); if(num==8) return(vIslandPoint8); 
	
	return(0);	// should never be reached
}
	
float setIslandPoint(int num=-1, float val=0) {
if(num==1) vIslandPoint1 = val; if(num==2) vIslandPoint2 = val; 
	if(num==3) vIslandPoint3 = val; if(num==4) vIslandPoint4 = val; 
	if(num==5) vIslandPoint5 = val; if(num==6) vIslandPoint6 = val; 
	if(num==7) vIslandPoint7 = val; if(num==8) vIslandPoint8 = val; 
	
	return(0);	// should never be reached
}




void main(void){
// ----------------------------------------------------- Constants -----------------------------------------------------
string hunt1 = "bison";
string hunt2 = "pronghorn";
string mineType = "mine";
string forestType = "z87 Australian Woodland";
string oceanType = "Texas Pond";
string groundType = "great_plains\ground5_gp";
string groundIsland = "sonora\ground2_son";
string lightsetType = "Great Plains";

int subCiv0=-1;
int subCiv1=-1;
int subCiv2=-1;
int subCiv3=-1;
if (rmAllocateSubCivs(2) == true)
{
	subCiv0=rmGetCivID("Incas");
	rmEchoInfo("subCiv0 is Incas "+subCiv0);
	if (subCiv0 >= 0)
		rmSetSubCiv(0, "Incas");

	subCiv1=rmGetCivID("Lakota");
	rmEchoInfo("subCiv1 is Tupi "+subCiv1);
	if (subCiv1 >= 0)
		rmSetSubCiv(1, "Lakota");
			subCiv2=rmGetCivID("Lakota");
	rmEchoInfo("subCiv2 is Lakota "+subCiv2);
	if (subCiv2 >= 0)
		rmSetSubCiv(2, "Lakota");
	
	subCiv3=rmGetCivID("Incas");
	rmEchoInfo("subCiv3 is Incas "+subCiv3);
	if (subCiv3 >= 0)
		rmSetSubCiv(3, "Incas");
}

// ----------------------------------------------------- Defining the map ----------------------------------------------
int	playerTiles = 12500;
if (cNumberNonGaiaPlayers>2)
	playerTiles=12000;
else if (cNumberNonGaiaPlayers>4)
	playerTiles=11000;
int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
rmSetMapSize(size, size);

rmSetMapElevationParameters(cElevTurbulence, 0.07, 2, 0.1, 5.0);
rmTerrainInitialize(groundType, 2.0);
rmSetSeaLevel(2.0);
rmSetMapType("newEngland");
rmSetMapType("land");
rmSetMapType("grass");
rmSetLightingSet(lightsetType);
rmSetWorldCircleConstraint(true);
rmSetWindMagnitude(2.0); 

// ----------------------------------------------------- Constraints ---------------------------------------------------
	int numTries = -1;
	int classPlayer=rmDefineClass("player");
	int classIsland=rmDefineClass("island");
	rmDefineClass("classForest");
	rmDefineClass("importantItem");
	rmDefineClass("natives");
	rmDefineClass("classSocket");
	rmDefineClass("canyon");
	rmDefineClass("classCliff");
	rmDefineClass("startingUnit");
	rmDefineClass("pond");
	rmDefineClass("northCoin");
	rmDefineClass("southCoin");
	rmDefineClass("southFood");
	rmDefineClass("northFood");

   // -------------Define constraints----------------------------------------


// Player area constraint.
int avoidTCShort=rmCreateTypeDistanceConstraint("stay away from TC short", "TownCenter", 30.0);
int avoidTCMedium=rmCreateTypeDistanceConstraint("stay away from TC Medium", "TownCenter", 40.0);
int avoidTCFar=rmCreateTypeDistanceConstraint("stay away from TC Far", "TownCenter", 60.0);
int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 8.0);

// Ressources Constraint
int avoidCoin = rmCreateTypeDistanceConstraint("avoid coin", mineType, 60.0);
int avoidSouthCoin=rmCreateClassDistanceConstraint("avoid south coin", rmClassID("southCoin"), 55.0);
int avoidNorthCoin=rmCreateClassDistanceConstraint("avoid north coin", rmClassID("northCoin"), 55.0);
int avoidCoinStart = rmCreateTypeDistanceConstraint("avoid coin 2", mineType, 20.0);
int avoidRandomTurkeys=rmCreateTypeDistanceConstraint("avoid random turkeys", "turkey", 50.0);
int avoidforestshort=rmCreateClassDistanceConstraint("avoid forest short", rmClassID("classForest"), 8.0);
int forestID = -1;
int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 30.0);
int avoidSouthFood=rmCreateClassDistanceConstraint("avoid south food", rmClassID("southFood"), 45.0);
int avoidNorthFood=rmCreateClassDistanceConstraint("avoid north food", rmClassID("northFood"), 45.0);
int avoidHunt1Far = rmCreateTypeDistanceConstraint("avoid hunt1 far", hunt1, 50.0);
int avoidHunt1Short = rmCreateTypeDistanceConstraint("avoid hunt1 short", hunt1, 20.0);
int avoidHunt2Far = rmCreateTypeDistanceConstraint("avoid hunt2 far", hunt2, 50.0);
int avoidHunt2Short = rmCreateTypeDistanceConstraint("avoid hunt2 short", hunt2, 20.0);
int avoidCoinShort=rmCreateTypeDistanceConstraint("avoids coin short", "gold", 8.0);

// Generic Contraints
int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 5.0);
int avoidImpassableLandShort = rmCreateTerrainDistanceConstraint("short avoid impassable land like Arkansas for tree", "Land", false, 3.0);
int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 6.0);
int avoidSocket = rmCreateClassDistanceConstraint("avoid socket", rmClassID("classSocket"), 8.0);
int avoidImportantItem = rmCreateClassDistanceConstraint("secrets etc avoid each other", rmClassID("importantItem"), 50.0);
int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 4.0);
int avoidCliffsShort=rmCreateClassDistanceConstraint("avoid Cliffs short", rmClassID("classCliff"), 4.0);
int avoidCliffs=rmCreateClassDistanceConstraint("avoid Cliffs", rmClassID("classCliff"), 10.0);
int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "AbstractNugget", 35.0);
int avoidNuggetStart=rmCreateTypeDistanceConstraint("nugget avoid nugget start", "AbstractNugget", 20.0);

// Custom Contraints
int avoidEdge = rmCreatePieConstraint("Avoid Edge",0.5,0.5, rmXFractionToMeters(0.0),rmXFractionToMeters(0.46), rmDegreesToRadians(0),rmDegreesToRadians(360));
int staySouth = rmCreatePieConstraint("Stay South",0.47,0.47, rmXFractionToMeters(0.2),rmXFractionToMeters(0.5), rmDegreesToRadians(135),rmDegreesToRadians(315));
int stayNorth = rmCreatePieConstraint("Stay North",0.53,0.53, rmXFractionToMeters(0.2),rmXFractionToMeters(0.5), rmDegreesToRadians(315),rmDegreesToRadians(135));
	
// Choose Mercs
chooseMercs();

// ----------------------------------------------------- Trade Route -----------------------------------------------------
int tradeRouteID = rmCreateTradeRoute();
int socketID=rmCreateObjectDef("sockets to dock Trade Posts");
rmSetObjectDefTradeRouteID(socketID, tradeRouteID);
rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
rmSetObjectDefAllowOverlap(socketID, true);
rmAddObjectDefToClass(socketID, rmClassID("classSocket"));
rmSetObjectDefMinDistance(socketID, 0.0);
rmSetObjectDefMaxDistance(socketID, 6.0);
rmAddTradeRouteWaypoint(tradeRouteID, 0.9, 0.1);
rmAddTradeRouteWaypoint(tradeRouteID, 0.50, 0.50);
rmAddTradeRouteWaypoint(tradeRouteID, 0.1, 0.9);

bool placedTradeRoute = rmBuildTradeRoute(tradeRouteID, "dirt");


// ----------------------------------------------------- Designing the map ---------------------------------------------

int centralPond=rmCreateArea("central pond");
rmSetAreaSize(centralPond, 0.14, 0.14);
rmSetAreaLocation(centralPond, 0.5, 0.5);
rmAddAreaInfluenceSegment(centralPond, 0.4, 0.6, 0.6, 0.4);
rmSetAreaWaterType(centralPond, oceanType);
rmSetAreaCoherence(centralPond, 0.65);
rmSetAreaSmoothDistance(centralPond, 7);
rmAddAreaToClass(centralPond, rmClassID("pond"));
rmBuildArea(centralPond);

int island_do_not_touch_pond = rmCreateEdgeDistanceConstraint("constraint for island not touching pound edge", centralPond, 22);
int avoid_pond =rmCreateClassDistanceConstraint("avoid center pond", rmClassID("pond"), 5.0);

int centralIsland=rmCreateArea("central island");
rmSetAreaSize(centralIsland, 0.08, 0.08);
rmSetAreaLocation(centralIsland, 0.5, 0.5);
rmSetAreaSmoothDistance(centralIsland, 5);
rmSetAreaBaseHeight(centralIsland, 0);
rmSetAreaTerrainType(centralIsland, groundIsland);
rmAddAreaConstraint(centralIsland, island_do_not_touch_pond);
rmBuildArea(centralIsland);


for (i=1;<5)
{
	int mapWithoutPond = rmCreateArea("all map without pond"+i);
	rmSetAreaSize(mapWithoutPond, 0.01, 0.01);
	rmSetAreaLocation(mapWithoutPond,getexteriorPoint(i),getexteriorPoint(i+4));
	rmAddAreaConstraint(mapWithoutPond,avoid_pond);
	rmBuildArea(mapWithoutPond);
	
	int islandPoint = rmCreateArea("islandPoint"+i);
	rmSetAreaSize(islandPoint, 0.01, 0.01);
	rmSetAreaLocation(islandPoint,getIslandPoint(i),getIslandPoint(i+4));
	rmAddAreaConstraint(islandPoint,avoid_pond);
	rmBuildArea(islandPoint);

	int connectionTest = rmCreateConnection("connection test"+i);
	rmSetConnectionType(connectionTest, cConnectAreas, true, 0.5);
	rmAddConnectionArea(connectionTest, mapWithoutPond);
	rmAddConnectionArea(connectionTest, islandPoint);
	rmSetConnectionCoherence(connectionTest,0.3);
	rmSetConnectionSmoothDistance(connectionTest,3);
	rmSetConnectionWidth(connectionTest, 10, 1);
	rmAddConnectionTerrainReplacement(connectionTest,"carolinas\ground_shoreline1_car",groundIsland);
	rmSetConnectionBaseHeight(connectionTest,0);
	rmBuildConnection(connectionTest);
}

vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.15);
rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.5);
rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.85);
rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

for(i=0; <cNumberNonGaiaPlayers*5)
{
int newGrass = rmCreateArea("new grass"+i);
rmSetAreaLocation(newGrass, rmRandFloat(0.05,0.95), rmRandFloat(0.05,0.95)); 
rmSetAreaWarnFailure(newGrass, false);
rmSetAreaSize(newGrass,0.01, 0.01);
rmSetAreaCoherence(newGrass, 0);
rmSetAreaSmoothDistance(newGrass, 1);
rmSetAreaObeyWorldCircleConstraint(newGrass, false);
rmAddAreaToClass(newGrass, rmClassID("classPatch")); 
rmSetAreaTerrainType(newGrass, "great_plains\ground8_gp");
rmAddAreaConstraint(newGrass,avoid_pond);
rmBuildArea(newGrass);
}

// ----------------------------------------------------- Natives ---------------------------------------------
if (subCiv0 == rmGetCivID("Incas"))
{  
  int IncasVillageAID = -1;
  IncasVillageAID = rmCreateGrouping("incan village A", "native inca village "+4);
  rmSetGroupingMinDistance(IncasVillageAID, 0.00);
  rmSetGroupingMaxDistance(IncasVillageAID, 0.00);
  rmAddGroupingConstraint(IncasVillageAID, avoidImpassableLand);
  rmAddGroupingToClass(IncasVillageAID, rmClassID("natives"));
  rmPlaceGroupingAtLoc(IncasVillageAID, 0, 0.15, 0.65);
}

if (subCiv1 == rmGetCivID("Lakota"))
{   
  int LakotaVillageAID = -1;
  LakotaVillageAID = rmCreateGrouping("Lakota village A", "native Lakota village "+2);
  rmSetGroupingMinDistance(LakotaVillageAID, 0.0);
 rmSetGroupingMaxDistance(LakotaVillageAID, 0.00);
  rmAddGroupingConstraint(LakotaVillageAID, avoidImpassableLand);
  rmAddGroupingToClass(LakotaVillageAID, rmClassID("natives"));
  rmPlaceGroupingAtLoc(LakotaVillageAID, 0, 0.65, 0.15); 
}
if(subCiv2 == rmGetCivID("Lakota"))
{   
  int LakotaVillageID = -1;
  LakotaVillageID = rmCreateGrouping("Lakota village", "native Lakota village "+2);
  rmSetGroupingMinDistance(LakotaVillageID, 0.0);
  rmSetGroupingMaxDistance(LakotaVillageID, 4);
  rmAddGroupingConstraint(LakotaVillageID, avoidImpassableLand);
  rmAddGroupingToClass(LakotaVillageID, rmClassID("natives"));
  rmPlaceGroupingAtLoc(LakotaVillageID, 0, 0.35, 0.85);
}

if(subCiv3 == rmGetCivID("Incas"))
{   
  int IncasVillageBID = -1;
  IncasVillageBID = rmCreateGrouping("incan village B", "native inca village "+4);
  rmSetGroupingMinDistance(IncasVillageBID, 0.0);
  rmSetGroupingMaxDistance(IncasVillageBID, 4);
  rmAddGroupingConstraint(IncasVillageBID, avoidImpassableLand);
  rmAddGroupingToClass(IncasVillageBID, rmClassID("natives"));
  rmPlaceGroupingAtLoc(IncasVillageBID, 0, 0.85, 0.35);
}
// ----------------------------------------------------- Players ---------------------------------------------
if (cNumberNonGaiaPlayers==2)
{	
	rmPlacePlayer(1,0.75,0.75);
	rmPlacePlayer(2,0.25,0.25);
}
else 
{
   rmSetPlacementTeam(0);
   rmSetPlacementSection(0.02, 0.24);
   rmPlacePlayersCircular(0.37, 0.38, 0);

   rmSetPlacementTeam(1);
   rmSetPlacementSection(0.52, 0.74);
   rmPlacePlayersCircular(0.37, 0.38, 0);	
}
	
int startingUnits = rmCreateStartingUnitsObjectDef(5.0);

int startingTCID = rmCreateObjectDef("startingTC");
if ( rmGetNomadStart())
{
	rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
}
else
{
	rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0);
}
rmAddObjectDefToClass(startingTCID, rmClassID("startingUnit"));
rmSetObjectDefMinDistance(startingTCID, 0.0);
rmSetObjectDefMaxDistance(startingTCID, 0.0);

int StartCaribou=rmCreateObjectDef("starting caribou");
rmAddObjectDefItem(StartCaribou, hunt1, rmRandInt(7,8), 6.0);
rmSetObjectDefMinDistance(StartCaribou, 10.0);
rmSetObjectDefMaxDistance(StartCaribou, 14.0);
rmSetObjectDefCreateHerd(StartCaribou, true);
rmAddObjectDefConstraint(StartCaribou, avoidImpassableLand);
rmAddObjectDefConstraint(StartCaribou, avoidStartingUnits);
rmAddObjectDefConstraint(StartCaribou, avoidSocket);

int StartMoose=rmCreateObjectDef("starting moose");
rmAddObjectDefItem(StartMoose, hunt2, rmRandInt(8,9), 9.0);
rmAddObjectDefToClass(StartMoose, rmClassID("startingUnit"));
rmSetObjectDefMinDistance(StartMoose, 32.0);
rmSetObjectDefMaxDistance(StartMoose, 35.0);
rmSetObjectDefCreateHerd(StartMoose, true);
rmAddObjectDefConstraint(StartMoose, avoidImpassableLand);
rmAddObjectDefConstraint(StartMoose, avoidStartingUnits);
rmAddObjectDefConstraint(StartMoose, avoidHunt1Short);
rmAddObjectDefConstraint(StartMoose, avoidSocket);

int startSilverID = rmCreateObjectDef("first mine");
rmAddObjectDefItem(startSilverID, mineType, 1, 5.0);
rmAddObjectDefToClass(startSilverID, rmClassID("startingUnit"));
rmSetObjectDefMinDistance(startSilverID, 14.0);
rmSetObjectDefMaxDistance(startSilverID, 16.0);

int startsilvermid = rmCreateObjectDef("first mine2");
rmAddObjectDefItem(startsilvermid, mineType, 1, 5.0);
rmAddObjectDefToClass(startsilvermid, rmClassID("startingUnit"));
rmAddObjectDefConstraint(startsilvermid, avoidCoinStart);
rmSetObjectDefMinDistance(startsilvermid, 22.0);
rmSetObjectDefMaxDistance(startsilvermid, 23.0);


int StartAreaTreeID=rmCreateObjectDef("starting trees");
rmAddObjectDefItem(StartAreaTreeID, "TreeGreatPlains", 2, 4.0);
rmSetObjectDefMinDistance(StartAreaTreeID, 11);
rmSetObjectDefMaxDistance(StartAreaTreeID, 18);
rmAddObjectDefToClass(StartAreaTreeID, rmClassID("startingUnit"));
rmAddObjectDefConstraint(StartAreaTreeID, avoidImpassableLand);
rmAddObjectDefConstraint(StartAreaTreeID, avoidStartingUnits);
rmAddObjectDefConstraint(StartAreaTreeID, avoidSocket);

int playerNuggetID=rmCreateObjectDef("player nugget");
rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
rmAddObjectDefToClass(playerNuggetID, rmClassID("startingUnit"));
rmSetObjectDefMinDistance(playerNuggetID, 23.0);
rmSetObjectDefMaxDistance(playerNuggetID, 28.0);
rmAddObjectDefConstraint(playerNuggetID, avoidNuggetStart);
rmAddObjectDefConstraint(playerNuggetID, avoidTradeRoute);
rmAddObjectDefConstraint(playerNuggetID, avoidSocket);
rmAddObjectDefConstraint(playerNuggetID, avoidStartingUnits);
rmAddObjectDefConstraint(playerNuggetID, avoidAll);

	for(i=1; <=cNumberNonGaiaPlayers)
{
	rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

	if(ypIsAsian(i) && rmGetNomadStart() == false){
      	rmPlaceObjectDefAtLoc(ypMonasteryBuilder(i, 1), i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	}
	rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	rmPlaceObjectDefAtLoc(startSilverID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	rmPlaceObjectDefAtLoc(startsilvermid, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	rmPlaceObjectDefAtLoc(StartCaribou, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	rmPlaceObjectDefAtLoc(StartMoose, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	
	rmPlaceObjectDefAtLoc(StartAreaTreeID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	rmPlaceObjectDefAtLoc(StartAreaTreeID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	rmPlaceObjectDefAtLoc(StartAreaTreeID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	rmPlaceObjectDefAtLoc(StartAreaTreeID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	rmPlaceObjectDefAtLoc(StartAreaTreeID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	rmSetNuggetDifficulty(1,1);
	rmPlaceObjectDefAtLoc(playerNuggetID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	rmPlaceObjectDefAtLoc(playerNuggetID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));		
}

// -------------------------------------------- Resources ------------------------------------------------
int goldCount = 3*cNumberNonGaiaPlayers/2;  // 3,3 
for(i=0; < goldCount)
{
	int southGold = rmCreateObjectDef("south gold"+i);
	rmAddObjectDefItem(southGold, "Mine", 1, 0.0);
	rmAddObjectDefToClass(southGold, rmClassID("southCoin"));
	rmSetObjectDefMinDistance(southGold, rmXFractionToMeters(0.0));
	rmSetObjectDefMaxDistance(southGold, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(southGold, avoidSocket);
	rmAddObjectDefConstraint(southGold, avoidTradeRoute);
	rmAddObjectDefConstraint(southGold, avoidImpassableLand);
	rmAddObjectDefConstraint(southGold, avoidAll);
	rmAddObjectDefConstraint(southGold, staySouth);
	rmAddObjectDefConstraint(southGold, avoidSouthCoin);
	rmAddObjectDefConstraint(southGold, avoidTCFar);
	rmAddObjectDefConstraint(southGold, avoidEdge);
	rmPlaceObjectDefAtLoc(southGold, 0, 0.50, 0.50);
}
for(i=0; < goldCount)
{
	int northGold = rmCreateObjectDef("north gold"+i);
	rmAddObjectDefItem(northGold, "Mine", 1, 0.0);
	rmAddObjectDefToClass(northGold, rmClassID("northCoin"));
	rmSetObjectDefMinDistance(northGold, rmXFractionToMeters(0.0));
	rmSetObjectDefMaxDistance(northGold, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(northGold, avoidSocket);
	rmAddObjectDefConstraint(northGold, avoidTradeRoute);
	rmAddObjectDefConstraint(northGold, avoidImpassableLand);
	rmAddObjectDefConstraint(northGold, avoidAll);
	rmAddObjectDefConstraint(northGold, stayNorth);
	rmAddObjectDefConstraint(northGold, avoidNorthCoin);
	rmAddObjectDefConstraint(northGold, avoidTCFar);
	rmAddObjectDefConstraint(northGold, avoidEdge);
	rmPlaceObjectDefAtLoc(northGold, 0, 0.50, 0.50);
}
int silvermid = rmCreateObjectDef("silver mid");
rmAddObjectDefItem(silvermid, "mine", 1, 0.0);
rmSetObjectDefMinDistance(silvermid, 0.0);
rmSetObjectDefMaxDistance(silvermid, rmXFractionToMeters(0.06));
rmAddObjectDefConstraint(silvermid, avoidAll);	
rmAddObjectDefConstraint(silvermid, avoidSocket);	
rmAddObjectDefConstraint(silvermid, avoidTradeRoute);
rmPlaceObjectDefAtLoc(silvermid, 0, 0.5, 0.5);

numTries=15*cNumberNonGaiaPlayers;
int failCount=0;

for (i=0; <numTries)
{   
	int forest=rmCreateArea("forest "+i);
	rmSetAreaWarnFailure(forest, false);
	rmSetAreaSize(forest, rmAreaTilesToFraction(100), rmAreaTilesToFraction(150));
	rmSetAreaForestType(forest, forestType);
	rmSetAreaTerrainType(forest, "texas\ground6_tex");
	rmSetAreaForestDensity(forest, 0.8);
	rmSetAreaForestClumpiness(forest, 0.1);
	rmSetAreaForestUnderbrush(forest, 0.5);
	rmSetAreaCoherence(forest, 0.5);
	rmAddAreaToClass(forest, rmClassID("classForest")); 
	rmAddAreaConstraint(forest, forestConstraint);
	rmAddAreaConstraint(forest, avoidTCMedium);
	rmAddAreaConstraint(forest, avoidImportantItem);
	rmAddAreaConstraint(forest, avoidImpassableLand);
	rmAddAreaConstraint(forest, avoidTradeRoute);
	rmAddAreaConstraint(forest, avoidSocket);
	//rmAddAreaConstraint(forest, avoidNatives);
	rmAddAreaConstraint(forest, avoidCoinShort);
	rmAddAreaConstraint(forest, avoidAll);
	rmAddAreaConstraint(forest,avoid_pond);
	if(rmBuildArea(forest)==false)
	{
		// Stop trying once we fail 10 times in a row.
		failCount++;
		if(failCount==10)
		break;
	}
	else
		failCount=0; 
}

for (j=0; < rmRandInt(cNumberNonGaiaPlayers*8,cNumberNonGaiaPlayers*10)) //18,20
{
	int midtree = rmCreateObjectDef("mid Tree west tree"+j);
	rmAddObjectDefItem(midtree, "treeTexas", rmRandInt(1,2), .0); // 1,2
	rmSetObjectDefMinDistance(midtree, 0);
	rmSetObjectDefMaxDistance(midtree, rmXFractionToMeters(0.1));
	rmAddObjectDefConstraint(midtree, avoidImpassableLandShort);
	rmAddObjectDefConstraint(midtree, avoidSocket);	
	rmPlaceObjectDefAtLoc(midtree, 0, 0.50, 0.50);
}

int bisoncount = 2*cNumberNonGaiaPlayers/2;
int pronghorncount = 1*cNumberNonGaiaPlayers/2;

int midBison = rmCreateObjectDef("mid bison");
rmAddObjectDefItem(midBison, "bison", rmRandInt(12,14), 10.0);
rmSetObjectDefMinDistance(midBison, rmXFractionToMeters(0.0));
rmSetObjectDefMaxDistance(midBison, rmXFractionToMeters(0.05));
rmSetObjectDefCreateHerd(midBison, true);
rmAddObjectDefConstraint(midBison, avoidImpassableLandShort);
rmAddObjectDefConstraint(midBison, avoidAll);
rmAddObjectDefConstraint(midBison, avoidSocket);
rmAddObjectDefConstraint(midBison, avoidCoinShort);
rmAddObjectDefConstraint(midBison, avoidforestshort);
rmPlaceObjectDefAtLoc(midBison, 0, 0.50, 0.50);

for(i=0; < bisoncount)
{

	//Bisons
	int southBison = rmCreateObjectDef("south bison"+i);
	rmAddObjectDefItem(southBison, "bison", rmRandInt(8,11), 10.0);
	rmAddObjectDefToClass(southBison, rmClassID("southFood"));	
	rmSetObjectDefMinDistance(southBison, rmXFractionToMeters(0.0));
	rmSetObjectDefMaxDistance(southBison, rmXFractionToMeters(0.5));
	rmSetObjectDefCreateHerd(southBison, true);
	rmAddObjectDefConstraint(southBison, avoidImpassableLandShort);
	rmAddObjectDefConstraint(southBison, avoidAll);
	rmAddObjectDefConstraint(southBison, avoidSocket);
	rmAddObjectDefConstraint(southBison, avoidCoinShort);
	rmAddObjectDefConstraint(southBison, avoidforestshort);
	rmAddObjectDefConstraint(southBison, avoidTCFar);
	rmAddObjectDefConstraint(southBison, staySouth);
	rmAddObjectDefConstraint(southBison, avoidSouthFood);  	
	rmAddObjectDefConstraint(southBison, avoidEdge); 
	rmPlaceObjectDefAtLoc(southBison, 0, 0.50, 0.50);
}

	for(i=0; < pronghorncount)
{
	//Pronghorns
	int southPronghorn = rmCreateObjectDef("south pronghorn"+i);
	rmAddObjectDefItem(southPronghorn, "pronghorn", rmRandInt(10,11), 8.0);
	rmAddObjectDefToClass(southPronghorn, rmClassID("southFood"));	
	rmSetObjectDefMinDistance(southPronghorn, rmXFractionToMeters(0.0));
	rmSetObjectDefMaxDistance(southPronghorn, rmXFractionToMeters(0.5));
	rmSetObjectDefCreateHerd(southPronghorn, true);
	rmAddObjectDefConstraint(southPronghorn, avoidImpassableLandShort);
	rmAddObjectDefConstraint(southPronghorn, avoidAll);
	rmAddObjectDefConstraint(southPronghorn, avoidSocket);
	rmAddObjectDefConstraint(southPronghorn, avoidCoinShort);
	rmAddObjectDefConstraint(southPronghorn, avoidforestshort);
	rmAddObjectDefConstraint(southPronghorn, avoidTCFar);
	rmAddObjectDefConstraint(southPronghorn, staySouth);
	rmAddObjectDefConstraint(southPronghorn, avoidSouthFood);  		
	rmAddObjectDefConstraint(southPronghorn, avoidEdge); 
	rmPlaceObjectDefAtLoc(southPronghorn, 0, 0.50, 0.50);
}
for(i=0; < bisoncount)
{

	//Bisons
	int northBison = rmCreateObjectDef("north bison"+i);
	rmAddObjectDefItem(northBison, "bison", rmRandInt(8,11), 10.0);
	rmAddObjectDefToClass(northBison, rmClassID("northFood"));	
	rmSetObjectDefMinDistance(northBison, rmXFractionToMeters(0.0));
	rmSetObjectDefMaxDistance(northBison, rmXFractionToMeters(0.5));
	rmSetObjectDefCreateHerd(northBison, true);
	rmAddObjectDefConstraint(northBison, avoidImpassableLandShort);
	rmAddObjectDefConstraint(northBison, avoidAll);
	rmAddObjectDefConstraint(northBison, avoidSocket);
	rmAddObjectDefConstraint(northBison, avoidCoinShort);
	rmAddObjectDefConstraint(northBison, avoidforestshort);
	rmAddObjectDefConstraint(northBison, avoidTCFar);
	rmAddObjectDefConstraint(northBison, stayNorth);
	rmAddObjectDefConstraint(northBison, avoidNorthFood);  	
	rmAddObjectDefConstraint(northBison, avoidEdge); 
	rmPlaceObjectDefAtLoc(northBison, 0, 0.50, 0.50);
}

	for(i=0; < pronghorncount)
{
	//Pronghorns
	int northPronghorn = rmCreateObjectDef("north pronghorn"+i);
	rmAddObjectDefItem(northPronghorn, "pronghorn", rmRandInt(10,11), 8.0);
	rmAddObjectDefToClass(northPronghorn, rmClassID("northFood"));	
	rmSetObjectDefMinDistance(northPronghorn, rmXFractionToMeters(0.0));
	rmSetObjectDefMaxDistance(northPronghorn, rmXFractionToMeters(0.5));
	rmSetObjectDefCreateHerd(northPronghorn, true);
	rmAddObjectDefConstraint(northPronghorn, avoidImpassableLandShort);
	rmAddObjectDefConstraint(northPronghorn, avoidAll);
	rmAddObjectDefConstraint(northPronghorn, avoidSocket);
	rmAddObjectDefConstraint(northPronghorn, avoidCoinShort);
	rmAddObjectDefConstraint(northPronghorn, avoidforestshort);
	rmAddObjectDefConstraint(northPronghorn, avoidTCFar);
	rmAddObjectDefConstraint(northPronghorn, stayNorth);
	rmAddObjectDefConstraint(northPronghorn, avoidNorthFood);  		
	rmAddObjectDefConstraint(northPronghorn, avoidEdge); 
	rmPlaceObjectDefAtLoc(northPronghorn, 0, 0.50, 0.50);
}

numTries=15*cNumberNonGaiaPlayers;
failCount=0;
for (i=0; <numTries)
{   
	int grassyArea=rmCreateArea("grassyArea"+i);
	rmSetAreaWarnFailure(grassyArea, false);
	rmSetAreaSize(grassyArea, rmAreaTilesToFraction(100), rmAreaTilesToFraction(150));
	rmSetAreaForestType(grassyArea, "Great Plains grass");
	rmSetAreaForestDensity(grassyArea, 0.3);
	rmAddAreaConstraint(grassyArea, avoidTradeRoute);
	rmAddAreaConstraint(grassyArea, avoidSocket);
	rmAddAreaConstraint(grassyArea, avoidAll);
	rmAddAreaConstraint(grassyArea, avoidTCShort);
	if(rmBuildArea(grassyArea)==false)
	{
		// Stop trying once we fail 5 times in a row.
		failCount++;
		if(failCount==5)
			break;
	}
	else
		failCount=0; 
}
int nuggetID1= rmCreateObjectDef("nugget1"); 
rmAddObjectDefItem(nuggetID1, "Nugget", 1, 0.0);
rmSetObjectDefMinDistance(nuggetID1, 0.0);
rmSetObjectDefMaxDistance(nuggetID1, rmXFractionToMeters(0.5));
rmAddObjectDefConstraint(nuggetID1, avoidImpassableLandShort);
rmAddObjectDefConstraint(nuggetID1, avoidTradeRoute);
rmAddObjectDefConstraint(nuggetID1, avoidSocket);
rmAddObjectDefConstraint(nuggetID1, avoidTCFar);
rmAddObjectDefConstraint(nuggetID1, avoidCoinShort);
rmAddObjectDefConstraint(nuggetID1, avoidAll);
rmAddObjectDefConstraint(nuggetID1, avoidNugget);	
rmSetNuggetDifficulty(2, 2);
rmPlaceObjectDefAtLoc(nuggetID1, 0, 0.5, 0.5, cNumberNonGaiaPlayers*4);

for (i=0;<=cNumberNonGaiaPlayers){
	rmCreateTrigger("Forbid_Dock"+i);
	rmSwitchToTrigger(rmTriggerID("Forbid_Dock"+i));
	rmSetTriggerPriority(3);
	rmSetTriggerActive(true);
	rmSetTriggerRunImmediately(true);
	rmSetTriggerLoop(false);
	rmAddTriggerCondition("Always"); 
	rmAddTriggerEffect("Forbid and Disable Unit");
	rmSetTriggerEffectParamInt("PlayerID", i);
    rmSetTriggerEffectParam("ProtoUnit", "Dock");
	rmSetTriggerEffectParamInt("PlayerID", i);
    rmSetTriggerEffectParam("ProtoUnit", "YPDockAsian");
	}
	
// ------------------------------------------------------ KOTH ---------------------------------------------------------------------

	if(rmGetIsKOTH()) {
    
		int randLoc = rmRandInt(1,3);
		float xLoc = 0.5;
		float yLoc = 0.5;
		float walk = 0.075;

		ypKingsHillPlacer(xLoc, yLoc, walk, 0);
		rmEchoInfo("XLOC = "+xLoc);
		rmEchoInfo("XLOC = "+yLoc);
	}
}