/* Durokan's  Jebel Musa - August 4 2017 Version 1.3*/

	include "mercenaries.xs";
	include "ypAsianInclude.xs";
	include "ypKOTHInclude.xs";

	void main(void) { 
		float playerTiles=12000;
			if (cNumberNonGaiaPlayers>4)
				playerTiles = 10800;
			if (cNumberNonGaiaPlayers>6)
				playerTiles = 8800;			
		int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
		rmSetMapSize(size, size);
		rmSetSeaType("Texas Pond");
		rmSetSeaLevel(-7);
		rmSetMapType("land");
		rmSetMapType("grass");
		rmSetMapType("Deccan");
		rmTerrainInitialize("water"); 
		rmSetLightingSet("Pampas");
		
		rmDefineClass("classForest");
		rmSetStatusText("",0.01);

		int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.48), rmDegreesToRadians(0), rmDegreesToRadians(360));
		int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 30.0);
		int forestConstraintShort=rmCreateClassDistanceConstraint("object vs. forest", rmClassID("classForest"), 4.0);	
		int avoidHunt=rmCreateTypeDistanceConstraint("hunts avoid hunts", "huntable", 45.0);
		int avoidHuntBase=rmCreateTypeDistanceConstraint("stuff avoid hunts", "huntable", 4.0);
		int avoidCoin=rmCreateTypeDistanceConstraint("avoid coin", "Mine", 10.0);
		int avoidCoinMed=rmCreateTypeDistanceConstraint("avoid coin medium", "Mine", 60.0);
		int avoidWaterShort = rmCreateTerrainDistanceConstraint("avoid water short", "Land", false, 6.0);
		int avoidWaterLong = rmCreateTerrainDistanceConstraint("avoid water long", "Land", false, 20.0);
		int AvoidWaterShort2 = rmCreateTerrainDistanceConstraint("avoid water short 2", "Land", false, 15.0);
		int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("objects avoid trade route", 12);
		int avoidTradeRouteFar = rmCreateTradeRouteDistanceConstraint("objects avoid trade route far", 30);
		int avoidTradeRouteSmall = rmCreateTradeRouteDistanceConstraint("objects avoid trade route small", 4.0);
		int avoidSocket=rmCreateClassDistanceConstraint("socket avoidance", rmClassID("socketClass"), 5.0);
		int avoidSocketMore=rmCreateClassDistanceConstraint("bigger socket avoidance", rmClassID("socketClass"), 15.0);
		int avoidTownCenter=rmCreateTypeDistanceConstraint("avoid Town Center", "townCenter", 35.0);
		int avoidTownCenterSmall=rmCreateTypeDistanceConstraint("avoid Town Center small", "townCenter", 15.0);
		int avoidTownCenterMedium=rmCreateTypeDistanceConstraint("avoid Town Center medium", "townCenter", 21.0);
		int avoidTownCenterMore=rmCreateTypeDistanceConstraint("avoid Town Center more", "townCenter", 40.0);	
		int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "AbstractNugget", 50.0); 
		int avoidNuggetSmall=rmCreateTypeDistanceConstraint("avoid nuggets by a little", "AbstractNugget", 10.0); 
		
		int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fishTarpon", 20.0);
		int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 8.0);
		int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "HumpbackWhale", 40.0);
		int whaleLand = rmCreateTerrainDistanceConstraint("whale land", "land", true, 7.0);

		rmDefineClass("classPlateau");
		int avoidPlateau=rmCreateClassDistanceConstraint("stuff vs. cliffs", rmClassID("classPlateau"), 5.0);
		rmDefineClass("classAnvil");
		int avoidAnvil=rmCreateClassDistanceConstraint("stuff vs. Anvil", rmClassID("classAnvil"), 5.0);
		rmDefineClass("classContinent");
		int avoidContinent=rmCreateClassDistanceConstraint("stuff vs. Continent", rmClassID("classContinent"), 5.0);
		
		int avoidAnvilFlag=rmCreateClassDistanceConstraint("stuff vs. Anvil", rmClassID("classAnvil"), 15.0);
		int avoidContinentFlag=rmCreateClassDistanceConstraint("flag vs. Continent", rmClassID("classContinent"), 15.0);

		//lighting
		//301a_malta
		//pampas
		//303a_nativevillage	

		float spawnSwitch = rmRandFloat(0,1.2);
	
		if(cNumberNonGaiaPlayers == 2){
			if (spawnSwitch<0.6) {	
			rmPlacePlayer(1, 0.2, 0.25);
			rmPlacePlayer(2, 0.8, 0.25);
			}else{
			rmPlacePlayer(1, 0.8, 0.25);
			rmPlacePlayer(2, 0.2, 0.25);
			}
		}else if (cNumberTeams == 2){
			if (spawnSwitch<0.6) {	
				rmSetPlacementTeam(1);
				rmPlacePlayersLine(0.2, 0.21, 0.2, 0.47, 0, 0);
				rmSetPlacementTeam(0);
				rmPlacePlayersLine(0.8, 0.21, 0.8, 0.47, 0, 0);
			}else{
				rmSetPlacementTeam(0);
				rmPlacePlayersLine(0.2, 0.21, 0.2, 0.47, 0, 0);
				rmSetPlacementTeam(1);
				rmPlacePlayersLine(0.8, 0.21, 0.8, 0.47, 0, 0);
			}

		}else{
			rmSetPlacementSection(0.22, 0.78);
			rmPlacePlayersCircular(0.4, 0.4, 0.02);
		}
		chooseMercs();
		rmSetStatusText("",0.1);
		
		int continent = rmCreateArea("big huge continent");
		rmAddAreaToClass(continent, rmClassID("classContinent"));
		rmSetAreaSize(continent, 0.64, 0.64);
		rmSetAreaLocation(continent, 0.5, 0.15);
		rmSetAreaTerrainType(continent, "texas\ground4_tex");
		rmSetAreaBaseHeight(continent, -4.5);
		rmSetAreaCoherence(continent, .8);
		rmAddAreaInfluenceSegment(continent, 0.0, 0.25, 1.0, 0.25); 
		rmSetAreaSmoothDistance(continent, 1);
		rmSetAreaElevationEdgeFalloffDist(continent, 10);
		rmSetAreaElevationVariation(continent, 5);
		rmSetAreaElevationPersistence(continent, 0.5);
		rmSetAreaElevationOctaves(continent, 5);
		rmSetAreaElevationMinFrequency(continent, 0.01);
		rmSetAreaElevationType(continent, cElevTurbulence);   
		rmBuildArea(continent);

		int cape = rmCreateArea("cape left");
		rmAddAreaToClass(cape, rmClassID("classAnvil"));
		rmSetAreaSize(cape, 0.02, 0.02);
		rmSetAreaSmoothDistance(cape, 1);
		rmSetAreaLocation(cape, 0.38, 0.8);
		rmSetAreaTerrainType(cape, "texas\ground4_tex");
		rmSetAreaBaseHeight(cape, -4.5);
		rmSetAreaCoherence(cape, 0.8);
		rmSetAreaElevationEdgeFalloffDist(cape, 10);
		rmSetAreaElevationVariation(cape, 5);
		rmSetAreaElevationPersistence(cape, 0.5);
		rmSetAreaElevationOctaves(cape, 5);
		rmSetAreaElevationMinFrequency(cape, 0.01);
		rmSetAreaElevationType(cape, cElevTurbulence);   
		rmBuildArea(cape); 
		
		int cape2 = rmCreateArea("cape right");
		rmAddAreaToClass(cape2, rmClassID("classAnvil"));
		rmSetAreaSmoothDistance(cape2, 1);
		rmSetAreaSize(cape2, 0.02, 0.02);
		rmSetAreaLocation(cape2, 0.62, 0.8);
		rmSetAreaTerrainType(cape2, "texas\ground4_tex");
		rmSetAreaBaseHeight(cape2, -4.5);
		rmSetAreaCoherence(cape2, 0.8);
		rmSetAreaElevationEdgeFalloffDist(cape2, 10);
		rmSetAreaElevationVariation(cape2, 5);
		rmSetAreaElevationPersistence(cape2, 0.5);
		rmSetAreaElevationOctaves(cape2, 5);
		rmSetAreaElevationMinFrequency(cape2, 0.01);
		rmSetAreaElevationType(cape2, cElevTurbulence);   
		rmBuildArea(cape2); 
		
		int cape3 = rmCreateArea("cape middle top");
		rmAddAreaToClass(cape3, rmClassID("classAnvil"));
		rmSetAreaSize(cape3, 0.03, 0.03);
		rmSetAreaLocation(cape3, 0.5, 0.83);
		rmSetAreaSmoothDistance(cape3, 1);
		rmSetAreaTerrainType(cape3, "texas\ground4_tex");
		rmSetAreaBaseHeight(cape3, -4.5);
		rmSetAreaCoherence(cape3, 0.8);
		rmSetAreaElevationEdgeFalloffDist(cape3, 10);
		rmSetAreaElevationVariation(cape3, 5);
		rmSetAreaElevationPersistence(cape3, 0.5);
		rmSetAreaElevationOctaves(cape3, 5);
		rmSetAreaElevationMinFrequency(cape3, 0.01);
		rmSetAreaElevationType(cape3, cElevTurbulence);   
		rmBuildArea(cape3); 
		
		int cape4 = rmCreateArea("cape middle bottom");
		rmAddAreaToClass(cape4, rmClassID("classAnvil"));
		rmSetAreaSize(cape4, 0.018, 0.018);
		rmSetAreaLocation(cape4, 0.5, 0.68);
		rmSetAreaTerrainType(cape4, "texas\ground4_tex");
		rmSetAreaBaseHeight(cape4, -4.5);
		rmSetAreaCoherence(cape4, 0.9);
		rmSetAreaElevationEdgeFalloffDist(cape4, 10);
		rmSetAreaElevationVariation(cape4, 5);
		rmSetAreaElevationPersistence(cape4, 0.5);
		rmSetAreaElevationOctaves(cape4, 5);
		rmSetAreaElevationMinFrequency(cape4, 0.01);
		rmSetAreaElevationType(cape4, cElevTurbulence);   
		rmBuildArea(cape4); 
/*		
		int socketID=rmCreateObjectDef("sockets to dock Trade Posts");
		rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
		rmSetObjectDefAllowOverlap(socketID, true);
		rmSetObjectDefMinDistance(socketID, 0.0);
		rmSetObjectDefMaxDistance(socketID, 6.0);
		int tradeRouteID = rmCreateTradeRoute();
		rmSetObjectDefTradeRouteID(socketID, tradeRouteID);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.5, -0.1);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.5, 0.75);
		rmBuildTradeRoute(tradeRouteID, "dirt");

		vector socketLoc1 = rmGetTradeRouteWayPoint(tradeRouteID, 0.15);
		rmPlaceObjectDefAtPoint(socketID, 0, socketLoc1);
		socketLoc1 = rmGetTradeRouteWayPoint(tradeRouteID, 0.5);
		rmPlaceObjectDefAtPoint(socketID, 0, socketLoc1);
		socketLoc1 = rmGetTradeRouteWayPoint(tradeRouteID, 0.92);
		rmPlaceObjectDefAtPoint(socketID, 0, socketLoc1);
		*/
		       	int classRight = rmDefineClass("rightHalfC");
		int classLeft = rmDefineClass("leftHalfC");
		int avoidRight = rmCreateClassDistanceConstraint("avoid right", rmClassID("rightHalfC"), 5.0);
		int avoidLeft = rmCreateClassDistanceConstraint("avoid left", rmClassID("leftHalfC"), 5.0);

		int rightHalf = rmCreateArea("rightHalf");
		rmAddAreaToClass(rightHalf, rmClassID("rightHalf"));
        rmSetAreaSize(rightHalf, .51, .51);
        rmSetAreaLocation(rightHalf, .2, 0.0);
		//rmSetAreaTerrainType(rightHalf, "Amazon\ground2_ama");
        rmSetAreaCoherence(rightHalf, 1.0);
		rmAddAreaInfluenceSegment(rightHalf, 0.2, 0.0, 0.2, 1.0);
        rmBuildArea(rightHalf);

		int leftHalf = rmCreateArea("leftHalf");
		rmAddAreaToClass(leftHalf, rmClassID("leftHalf"));
        rmSetAreaSize(leftHalf, .51, .51);
        rmSetAreaLocation(leftHalf, 0.8, .0);
        //rmSetAreaTerrainType(leftHalf, "rockies\groundsnow3_roc");
        rmSetAreaCoherence(leftHalf, 1.0);
		rmAddAreaInfluenceSegment(leftHalf, 0.8, 0.0, 0.8, 1.0);
        rmBuildArea(leftHalf);

		// Riki edit
		int tradeRouteID = rmCreateTradeRoute();
		int socketID=rmCreateObjectDef("sockets to dock Trade Posts");
		rmSetObjectDefTradeRouteID(socketID, tradeRouteID);
		rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
		rmSetObjectDefAllowOverlap(socketID, true);
		rmAddObjectDefToClass(socketID, rmClassID("socketClass"));
		rmSetObjectDefMinDistance(socketID, 0.0);
		rmSetObjectDefMaxDistance(socketID, 6.0);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.5, 0.0);
		rmAddRandomTradeRouteWaypoints(tradeRouteID, 0.5, 0.75, 0, 0);

		bool placedTradeRoute = rmBuildTradeRoute(tradeRouteID, "water");
		vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.0);
		rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
		socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.5);
		rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
		socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.92);
		rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
		// End Riki edit
		
		rmSetStatusText("",0.3);
		
		int fish2ID=rmCreateObjectDef("fish Tarpon");
		rmAddObjectDefItem(fish2ID, "FishTarpon", 1, 0.0);
		rmSetObjectDefMinDistance(fish2ID, 0.0);
		rmSetObjectDefMaxDistance(fish2ID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(fish2ID, fishVsFishID);
		rmAddObjectDefConstraint(fish2ID, fishLand);
		rmPlaceObjectDefAtLoc(fish2ID, 0, 0.5, 0.5, 8*cNumberNonGaiaPlayers);
		rmSetStatusText("",0.9);
		
		int whaleNum = 3;
		if(cNumberNonGaiaPlayers <3){
			whaleNum = 3;
		}else if(cNumberNonGaiaPlayers<5){
			whaleNum = 4;
		}else if(cNumberNonGaiaPlayers<7){ 
			whaleNum = 5;
		}else{
			whaleNum = 6;
		}
		
		int leftWhale=rmCreateObjectDef("leftWhale");
		rmAddObjectDefItem(leftWhale, "HumpbackWhale", 1, 0.0);
		rmSetObjectDefMinDistance(leftWhale, 0.0);
		rmSetObjectDefMaxDistance(leftWhale, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(leftWhale, whaleVsWhaleID);
		rmAddObjectDefConstraint(leftWhale, whaleLand);
		rmAddObjectDefConstraint(leftWhale, avoidRight);
		rmPlaceObjectDefAtLoc(leftWhale, 0, 0.5, 0.5, whaleNum);
	  
		int rightWhale=rmCreateObjectDef("rightWhale");
		rmAddObjectDefItem(rightWhale, "HumpbackWhale", 1, 0.0);
		rmSetObjectDefMinDistance(rightWhale, 0.0);
		rmSetObjectDefMaxDistance(rightWhale, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(rightWhale, whaleVsWhaleID);
		rmAddObjectDefConstraint(rightWhale, whaleLand);
		rmAddObjectDefConstraint(rightWhale, avoidRight);
		rmPlaceObjectDefAtLoc(rightWhale, 0, 0.5, 0.5, whaleNum);
		
		float zFlag = 0.85;
		float xDelta = 1.0/cNumberNonGaiaPlayers;
		float xFlag = xDelta/2;
		//float xStart;
		
		if (spawnSwitch>0.6) {
		xFlag = 1.0-xFlag;
		xDelta = xDelta * -1.0;
		}
		for(i=1; < cNumberPlayers) { 
		int waterFlag = rmCreateObjectDef("HC water flag "+i);
		rmAddObjectDefItem(waterFlag, "HomeCityWaterSpawnFlag", 1, 0.0);
		rmSetObjectDefMinDistance(waterFlag, 0);
		rmSetObjectDefMaxDistance(waterFlag, 40);

		//rmPlaceObjectDefAtLoc(waterFlag, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i), 1);
		
		//rmPlaceObjectDefAtLoc(waterFlag, i, .5, .75, 1);
		rmAddObjectDefConstraint(waterFlag, avoidContinentFlag);
		rmAddObjectDefConstraint(waterFlag, avoidAnvilFlag);
		rmAddObjectDefConstraint(waterFlag, circleConstraint);
		rmPlaceObjectDefAtLoc(waterFlag, i, xFlag, zFlag, 1);
		xFlag = xFlag + xDelta;
		}
		
		int riverGrass = rmCreateTerrainMaxDistanceConstraint("riverGrass stays near the water", "land", false, 3.0);
		// Paint some grass near the shore
		int grassPatchTop=rmCreateArea("top shore grass");
		rmSetAreaSize(grassPatchTop, .2, .2);
		rmSetAreaLocation(grassPatchTop, .75, .99);
		rmSetAreaWarnFailure(grassPatchTop, false);
		//rmSetAreaSmoothDistance(grassPatchTop, 10);
		rmSetAreaCoherence(grassPatchTop, .8);
		rmSetAreaTerrainType(grassPatchTop, "texas\cliff_top_tex");
		rmAddAreaConstraint(grassPatchTop, riverGrass);
		rmBuildArea(grassPatchTop);
		
		// Paint some grass near the shore
		int grassPatchBot=rmCreateArea("bot river grass");
		rmSetAreaSize(grassPatchBot, .2, .2);
		rmSetAreaLocation(grassPatchBot, .25, .99);
		rmSetAreaWarnFailure(grassPatchBot, false);
		//rmSetAreaSmoothDistance(grassPatchBot, 10);
		rmSetAreaCoherence(grassPatchBot, .8);
		rmSetAreaTerrainType(grassPatchBot, "texas\cliff_top_tex");
		rmAddAreaConstraint(grassPatchBot, riverGrass);
		rmBuildArea(grassPatchBot);
		
		int topRightShoreFix = rmCreateArea("fixes a water rendering bug on top right coast near cliff");
		rmSetAreaSize(topRightShoreFix, 0.019, 0.019);
		rmSetAreaLocation(topRightShoreFix, 0.95, 0.5);
		rmSetAreaTerrainType(topRightShoreFix, "texas\ground4_tex");
		rmSetAreaBaseHeight(topRightShoreFix, -4.5);
		rmSetAreaCoherence(topRightShoreFix, 0.9);
		rmSetAreaElevationEdgeFalloffDist(topRightShoreFix, 10);
		rmSetAreaElevationVariation(topRightShoreFix, 5);
		rmSetAreaElevationPersistence(topRightShoreFix, 0.5);
		rmSetAreaElevationOctaves(topRightShoreFix, 5);
		rmSetAreaElevationMinFrequency(topRightShoreFix, 0.01);
		rmSetAreaElevationType(topRightShoreFix, cElevTurbulence);   
		rmBuildArea(topRightShoreFix); 

		int classPatch = rmDefineClass("patch");
		int avoidPatch = rmCreateClassDistanceConstraint("avoid patch", rmClassID("patch"), 22.0);
		int circleConstraint2=rmCreatePieConstraint("circle Constraint2", 0.5, 0.5, 0, rmZFractionToMeters(0.48), rmDegreesToRadians(0), rmDegreesToRadians(360));
		
		int leftPlateau = rmCreateArea("plateau left");
		rmSetAreaSize(leftPlateau, 0.2, 0.2); 
		rmAddAreaToClass(leftPlateau, rmClassID("classPlateau"));
		rmAddAreaTerrainReplacement(leftPlateau, "texas\ground4_tex", "texas\ground2_tex");//great_plains\ground8_gp
		rmSetAreaCliffType(leftPlateau, "Texas Grass");
		rmSetAreaCliffEdge(leftPlateau, 1, 1, 0.0, 0.0, 1); 
		rmSetAreaCliffPainting(leftPlateau, true, true, true, 1.5, true);
		rmSetAreaCliffHeight(leftPlateau, 3, 0.1, 0.5);
		rmSetAreaCoherence(leftPlateau, .95);
		rmSetAreaLocation(leftPlateau, .05, .3);
		rmAddAreaInfluenceSegment(leftPlateau, 0.2, 0.0, 0.2, 0.4);
		rmBuildArea(leftPlateau);	
		
		int rightPlateau = rmCreateArea("plateau right");
		rmAddAreaToClass(rightPlateau, rmClassID("classPlateau"));
		rmSetAreaSize(rightPlateau, 0.2, 0.2); 
		rmAddAreaTerrainReplacement(rightPlateau, "texas\ground4_tex", "texas\ground2_tex");
		rmSetAreaCliffType(rightPlateau, "Texas Grass");
		rmSetAreaCliffEdge(rightPlateau, 1, 1, 0.0, 0.0, 1); 
		rmSetAreaCliffPainting(rightPlateau, true, true, true, 1.5, true);
		rmSetAreaCliffHeight(rightPlateau, 3, 0.1, 0.5);
		rmSetAreaCoherence(rightPlateau, .95);
		rmSetAreaLocation(rightPlateau, .85, .3);
		rmAddAreaInfluenceSegment(rightPlateau, 0.8, .0, 0.8, .4);
		rmBuildArea(rightPlateau);	
		
		int rampNumbers = 8;
				
		for(i=0; < rampNumbers) { 
		int rampLarge = rmCreateArea("top left center basin left ramp"+i);
		rmAddAreaTerrainReplacement(rampLarge, "texas\cliff_top_grass_tex", "texas\ground3_tex");
		rmSetAreaSize(rampLarge, 0.0044, 0.0044);
		rmSetAreaBaseHeight(rampLarge, -3.6);
		//rmSetAreaSmoothDistance(rampLarge, 4);
		rmSetAreaHeightBlend(rampLarge, 4);
		rmSetAreaCoherence(rampLarge, 1);
		if(i == 1){
		rmSetAreaLocation(rampLarge, 0.33, 0.5);
		}else if(i == 2){
		rmSetAreaLocation(rampLarge, 0.67, 0.5);
		}else if(i == 3){
		rmSetAreaLocation(rampLarge, 0.62, 0.12);
		}else if(i == 4){
		rmSetAreaLocation(rampLarge, 0.38, 0.12);
		}else if(i == 5){
		rmSetAreaLocation(rampLarge, 0.62, 0.35);
		}else if(i == 6){
		rmSetAreaLocation(rampLarge, 0.38, 0.35);
		}else if(i == 7){
		rmSetAreaLocation(rampLarge, 0.92, 0.525);
		}else{
		rmSetAreaLocation(rampLarge, 0.08, 0.525);
		}
		rmBuildArea(rampLarge); 
		}
		
		for (i=0; < cNumberNonGaiaPlayers*125){
			int patchID = rmCreateArea("the redder stuff"+i);
			rmSetAreaWarnFailure(patchID, false);
			rmSetAreaSize(patchID, rmAreaTilesToFraction(30), rmAreaTilesToFraction(51));
			rmAddAreaTerrainReplacement(patchID, "texas\ground4_tex", "texas\ground5_tex");
			rmPaintAreaTerrain(patchID);
			rmAddAreaToClass(patchID, rmClassID("patch"));
			rmSetAreaSmoothDistance(patchID, 1.0);
			rmAddAreaConstraint(patchID, circleConstraint2);
			rmBuildArea(patchID); 
		}
		
		for (i=0; < cNumberNonGaiaPlayers*125){
			int patchID2 = rmCreateArea("the redder stuff2"+i);
			rmSetAreaWarnFailure(patchID2, false);
			rmSetAreaSize(patchID2, rmAreaTilesToFraction(11), rmAreaTilesToFraction(17));
			rmAddAreaTerrainReplacement(patchID2, "texas\ground4_tex", "texas\ground5_tex");
			rmPaintAreaTerrain(patchID2);
			rmAddAreaToClass(patchID2, rmClassID("patch"));
			rmSetAreaSmoothDistance(patchID2, 1.0);
			rmAddAreaConstraint(patchID2, circleConstraint2);
			rmBuildArea(patchID2); 
		}
		rmSetStatusText("",0.4);
		
		for (i=0; < cNumberNonGaiaPlayers*125){
			int patchID3 = rmCreateArea("the redder stuff3"+i);
			rmSetAreaWarnFailure(patchID3, false);
			rmSetAreaSize(patchID3, rmAreaTilesToFraction(51), rmAreaTilesToFraction(75));
			rmAddAreaTerrainReplacement(patchID3, "texas\ground2_tex", "texas\ground1_tex");
			rmPaintAreaTerrain(patchID3);
			rmAddAreaToClass(patchID3, rmClassID("patch"));
			//rmSetAreaSmoothDistance(patchID3, 1.0);
			rmAddAreaConstraint(patchID3, circleConstraint2);
			rmBuildArea(patchID3); 
		}
		
		int playerStart = rmCreateStartingUnitsObjectDef(5.0);
		rmSetObjectDefMinDistance(playerStart, 7.0);
		rmSetObjectDefMaxDistance(playerStart, 12.0);
				
				
	//Natives
	int nativeSwitch = rmRandInt(0,1);
	
	int subCiv0 = -1;
	int subCiv1 = -1;
	subCiv0 = rmGetCivID("Apache");
	subCiv1= rmGetCivID("Jesuit");
	rmSetSubCiv(0, "Apache");
	rmSetSubCiv(1, "Jesuit");
	
	int nativeID0 = -1;
    int nativeID2 = -1;
				
	nativeID0 = rmCreateGrouping("Apache village", "native Apache village "+4);
    rmSetGroupingMinDistance(nativeID0, 0.00);
    rmSetGroupingMaxDistance(nativeID0, 0.00);
	rmAddGroupingToClass(nativeID0, rmClassID("natives"));
	
	nativeID2 = rmCreateGrouping("Jesuit village ", "native jesuit mission borneo 0"+5);
    rmSetGroupingMinDistance(nativeID2, 0.00);
    rmSetGroupingMaxDistance(nativeID2, 0.00);
	rmAddGroupingToClass(nativeID2, rmClassID("natives"));

	if(nativeSwitch == 0){
	rmPlaceGroupingAtLoc(nativeID0, 0, 0.62, 0.8);
	rmPlaceGroupingAtLoc(nativeID2, 0, 0.38, 0.8); 
	}else{
	rmPlaceGroupingAtLoc(nativeID0, 0, 0.38, 0.8);
	rmPlaceGroupingAtLoc(nativeID2, 0, 0.62, 0.8); 
	}
	rmSetStatusText("",0.5);

		int berryID = rmCreateObjectDef("starting berries"); 
		rmAddObjectDefItem(berryID, "BerryBush", 4, 6.0); 
		rmSetObjectDefMinDistance(berryID, 8.0); 
		rmSetObjectDefMaxDistance(berryID, 12.0); 
		rmAddObjectDefConstraint(berryID, avoidCoin);

		int treeID = rmCreateObjectDef("starting trees"); 
		rmAddObjectDefItem(treeID, "TreeTexas", rmRandInt(6,9), 10.0); 
		rmAddObjectDefItem(treeID, "UnderbrushForest", rmRandInt(8,10), 12.0);
		rmSetObjectDefMinDistance(treeID, 20.0); 
		rmSetObjectDefMaxDistance(treeID, 25.0);
		rmAddObjectDefConstraint(treeID, avoidTownCenterSmall);
		rmAddObjectDefConstraint(treeID, avoidCoin);
		rmAddObjectDefConstraint(treeID, avoidHunt);
	rmSetStatusText("",0.55);
		int foodID = rmCreateObjectDef("starting hunt1"); 
		rmAddObjectDefItem(foodID, "ypIbex", 8, 12.0); 
		rmSetObjectDefMinDistance(foodID, 10.0); 
		rmSetObjectDefMaxDistance(foodID, 10.0); 	
		rmAddObjectDefConstraint(foodID, circleConstraint);
		rmAddObjectDefConstraint(foodID, avoidWaterLong);
		rmSetObjectDefCreateHerd(foodID, true);

		int foodID2 = rmCreateObjectDef("starting hunt2"); 
		rmAddObjectDefItem(foodID2, "ypIbex", 8, 13.0); 
		rmSetObjectDefMinDistance(foodID2, 40.0); 
		rmSetObjectDefMaxDistance(foodID2, 40.0); 
		rmAddObjectDefConstraint(foodID2, circleConstraint);
		rmAddObjectDefConstraint(foodID2, avoidWaterLong);
		rmSetObjectDefCreateHerd(foodID2, true);
		
		rmSetStatusText("",0.6);

		int foodID3 = rmCreateObjectDef("starting hunt3"); 
		rmAddObjectDefItem(foodID3, "ypIbex", 8, 12.0); 
		rmSetObjectDefMinDistance(foodID3, 60.0); 
		rmSetObjectDefMaxDistance(foodID3, 60.0); 		
		rmAddObjectDefConstraint(foodID3, circleConstraint);
		rmAddObjectDefConstraint(foodID3, avoidWaterLong);
		rmSetObjectDefCreateHerd(foodID3, true);

		rmSetStatusText("",0.7);

		for(i=1; <cNumberPlayers) { 
		int id=rmCreateArea("Player"+i); 
		rmSetPlayerArea(i, id); 
		int startID = rmCreateObjectDef("object"+i); 
		rmAddObjectDefItem(startID, "TownCenter", 1, 5.0); 
		rmPlaceObjectDefAtLoc(startID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i)); 
		rmPlaceObjectDefAtLoc(berryID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(treeID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(foodID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(foodID2, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		if (cNumberNonGaiaPlayers>2){
		rmPlaceObjectDefAtLoc(foodID3, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		}
		rmPlaceObjectDefAtLoc(playerStart, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	
	  }

		int cornerMines = rmCreateObjectDef(" cornerMines");
		rmAddObjectDefItem(cornerMines, "mine", 1, 1.0);
		rmSetObjectDefMinDistance(cornerMines, 0.0);
		rmSetObjectDefMaxDistance(cornerMines, rmXFractionToMeters(0.01));
		rmAddObjectDefConstraint(cornerMines, circleConstraint);
		rmPlaceObjectDefAtLoc(cornerMines, 0, 0.09, 0.605, 1);   
		rmPlaceObjectDefAtLoc(cornerMines, 0, 0.91, 0.605, 1);   

		int cornerHunts = rmCreateObjectDef("guarenteed corner hunts");
		rmAddObjectDefItem(cornerHunts, "ypIbex", rmRandInt(8,8), 10.0);
		rmSetObjectDefCreateHerd(cornerHunts, true);
		rmSetObjectDefMinDistance(cornerHunts, 0);
		rmSetObjectDefMaxDistance(cornerHunts, rmXFractionToMeters(0.01));
		rmAddObjectDefConstraint(cornerHunts, circleConstraint);
		rmPlaceObjectDefAtLoc(cornerHunts, 0, 0.09, 0.605, 1);
		rmPlaceObjectDefAtLoc(cornerHunts, 0, 0.91, 0.605, 1);
		if (cNumberNonGaiaPlayers==2){
		rmPlaceObjectDefAtLoc(cornerHunts, 0, 0.25, 0.4, 1);
		rmPlaceObjectDefAtLoc(cornerHunts, 0, 0.75, 0.4, 1);
		}
		rmSetStatusText("",0.75);
		int cornerNugget= rmCreateObjectDef("corner nugs"); 
		rmAddObjectDefItem(cornerNugget, "Nugget", 1, 0.0); 
		rmSetObjectDefMinDistance(cornerNugget, 0.0); 
		rmSetObjectDefMaxDistance(cornerNugget, rmXFractionToMeters(0.01)); 
		rmAddObjectDefConstraint(cornerNugget, circleConstraint);
		rmSetNuggetDifficulty(3, 3); 
		rmPlaceObjectDefAtLoc(cornerNugget, 0, 0.1, 0.606, 1);   
		rmPlaceObjectDefAtLoc(cornerNugget, 0, 0.9, 0.606, 1);   
		

		int rheaxID = rmCreateObjectDef("ibex hunts");
		rmAddObjectDefItem(rheaxID, "ypIbex", rmRandInt(8,8), 10.0);
		rmSetObjectDefCreateHerd(rheaxID, true);
		rmSetObjectDefMinDistance(rheaxID, 0);
		rmSetObjectDefMaxDistance(rheaxID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(rheaxID, circleConstraint);
		rmAddObjectDefConstraint(rheaxID, avoidTownCenterMedium);
		rmAddObjectDefConstraint(rheaxID, avoidHunt);
		rmAddObjectDefConstraint(rheaxID, AvoidWaterShort2); 
		rmAddObjectDefConstraint(rheaxID, avoidPlateau); 
		rmPlaceObjectDefAtLoc(rheaxID, 0, 0.5, 0.5, 5*cNumberNonGaiaPlayers);
		rmSetStatusText("",0.8); 
		int anvilNuggets = rmCreateObjectDef("nuggets on the anvil"); 
		rmAddObjectDefItem(anvilNuggets, "Nugget", 1, 0.0); 
		rmSetObjectDefMinDistance(anvilNuggets, 0.0); 
		rmSetObjectDefMaxDistance(anvilNuggets, rmXFractionToMeters(0.2)); 
		rmAddObjectDefConstraint(anvilNuggets, avoidNugget); 
		rmAddObjectDefConstraint(anvilNuggets, circleConstraint);
		rmAddObjectDefConstraint(anvilNuggets, avoidCoin); 
		rmAddObjectDefConstraint(anvilNuggets, forestConstraintShort);
		rmAddObjectDefConstraint(anvilNuggets, avoidWaterShort); 
		rmAddObjectDefConstraint(anvilNuggets, avoidTradeRoute);
		rmAddObjectDefConstraint(anvilNuggets, avoidSocket); 
		rmAddObjectDefConstraint(anvilNuggets, avoidPlateau); 
		rmSetNuggetDifficulty(2, 2); 
		rmPlaceObjectDefAtLoc(anvilNuggets, 0, 0.5, 0.8, 2*cNumberNonGaiaPlayers); 
		
		int anvilMines = rmCreateObjectDef("anvilMines gold");
		rmAddObjectDefItem(anvilMines, "mineGold", 1, 1.0);
		rmSetObjectDefMinDistance(anvilMines, 0.0);
		rmSetObjectDefMaxDistance(anvilMines, rmXFractionToMeters(0.09));
		rmAddObjectDefConstraint(anvilMines, avoidCoinMed);
		rmAddObjectDefConstraint(anvilMines, avoidSocket);
		rmAddObjectDefConstraint(anvilMines, AvoidWaterShort2);
		rmAddObjectDefConstraint(anvilMines, forestConstraintShort);
		rmAddObjectDefConstraint(anvilMines, circleConstraint);
		rmPlaceObjectDefAtLoc(anvilMines, 0, 0.5, 0.8, .5*cNumberNonGaiaPlayers);

	  	int mines = rmCreateObjectDef(" Mines");
		rmAddObjectDefItem(mines, "mine", 1, 1.0);
		rmSetObjectDefMinDistance(mines, 0.0);
		rmSetObjectDefMaxDistance(mines, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(mines, avoidCoinMed);
		rmAddObjectDefConstraint(mines, avoidTownCenterMore);
		rmAddObjectDefConstraint(mines, avoidSocket);
		rmAddObjectDefConstraint(mines, AvoidWaterShort2);
		rmAddObjectDefConstraint(mines, forestConstraintShort);
		rmAddObjectDefConstraint(mines, circleConstraint);
		rmAddObjectDefConstraint(mines, avoidAnvil);
		rmAddObjectDefConstraint(mines, avoidPlateau);
		rmPlaceObjectDefAtLoc(mines, 0, 0.5, 0.5, 5*cNumberNonGaiaPlayers);

		int leftMines = rmCreateObjectDef("leftMines");
		rmAddObjectDefItem(leftMines, "mine", 1, 1.0);
		rmSetObjectDefMinDistance(leftMines, 0.0);
		rmSetObjectDefMaxDistance(leftMines, rmXFractionToMeters(0.35));
		rmAddObjectDefConstraint(leftMines, avoidCoinMed);
		rmAddObjectDefConstraint(leftMines, avoidTownCenterMore);
		rmAddObjectDefConstraint(leftMines, avoidSocket);
		rmAddObjectDefConstraint(leftMines, AvoidWaterShort2);
		rmAddObjectDefConstraint(leftMines, forestConstraintShort);
		rmAddObjectDefConstraint(leftMines, circleConstraint);
		rmAddObjectDefConstraint(leftMines, avoidAnvil);
		rmAddObjectDefConstraint(leftMines, avoidTradeRouteFar);
		rmPlaceObjectDefAtLoc(leftMines, 0, 0.25, 0.45, 1*cNumberNonGaiaPlayers);

		int rightMines = rmCreateObjectDef("rightMines");
		rmAddObjectDefItem(rightMines, "mine", 1, 1.0);
		rmSetObjectDefMinDistance(rightMines, 0.0);
		rmSetObjectDefMaxDistance(rightMines, rmXFractionToMeters(0.35));
		rmAddObjectDefConstraint(rightMines, avoidCoinMed);
		rmAddObjectDefConstraint(rightMines, avoidTownCenterMore);
		rmAddObjectDefConstraint(rightMines, avoidSocket);
		rmAddObjectDefConstraint(rightMines, AvoidWaterShort2);
		rmAddObjectDefConstraint(rightMines, forestConstraintShort);
		rmAddObjectDefConstraint(rightMines, circleConstraint);
		rmAddObjectDefConstraint(rightMines, avoidAnvil);
		rmAddObjectDefConstraint(rightMines, avoidTradeRouteFar);
		rmPlaceObjectDefAtLoc(rightMines, 0, 0.75, 0.45, 1*cNumberNonGaiaPlayers);

		int nuggetID= rmCreateObjectDef("nuggets small"); 
		rmAddObjectDefItem(nuggetID, "Nugget", 1, 0.0); 
		rmSetObjectDefMinDistance(nuggetID, 0.0); 
		rmSetObjectDefMaxDistance(nuggetID, rmXFractionToMeters(0.5)); 
		rmAddObjectDefConstraint(nuggetID, avoidNugget); 
		rmAddObjectDefConstraint(nuggetID, circleConstraint);
		rmAddObjectDefConstraint(nuggetID, avoidTownCenter);
		rmAddObjectDefConstraint(nuggetID, avoidCoin); 
		rmAddObjectDefConstraint(nuggetID, forestConstraintShort);
		rmAddObjectDefConstraint(nuggetID, avoidWaterShort); 
		rmAddObjectDefConstraint(nuggetID, avoidTradeRouteSmall);
		rmAddObjectDefConstraint(nuggetID, avoidSocket); 
		rmAddObjectDefConstraint(nuggetID, avoidPlateau); 
		rmAddObjectDefConstraint(nuggetID, avoidAnvil); 
		rmSetNuggetDifficulty(1, 1); 
		rmPlaceObjectDefAtLoc(nuggetID, 0, 0.5, 0.5, 3*(cNumberNonGaiaPlayers + 1));   
		rmSetStatusText("",0.85);
		
		int avoidGrass=rmCreateClassDistanceConstraint("tree vs. grasses", rmClassID("patch"), 1.0);
		
		//for (j=0; < (6*cNumberNonGaiaPlayers)) {   
			int StartAreaTree2ID=rmCreateObjectDef("plateau trees");
			rmAddObjectDefItem(StartAreaTree2ID, "TreeTexas", rmRandInt(11,12), rmRandFloat(10.0,11.0));//was 13,16 15,20
			rmAddObjectDefToClass(StartAreaTree2ID, rmClassID("classForest")); 
			rmSetObjectDefMinDistance(StartAreaTree2ID, 0);
			rmSetObjectDefMaxDistance(StartAreaTree2ID, rmXFractionToMeters(0.45));
			rmAddObjectDefConstraint(StartAreaTree2ID, avoidTradeRouteFar);
			rmAddObjectDefConstraint(StartAreaTree2ID, avoidSocket);
			rmAddObjectDefConstraint(StartAreaTree2ID, circleConstraint);
			rmAddObjectDefConstraint(StartAreaTree2ID, forestConstraint);
			rmAddObjectDefConstraint(StartAreaTree2ID, avoidTownCenterMore);	
			rmAddObjectDefConstraint(StartAreaTree2ID, avoidWaterLong);	
			rmPlaceObjectDefAtLoc(StartAreaTree2ID, 0, 0.5, 0.5, 100*cNumberNonGaiaPlayers);
		//}
		/*
		int fishID=rmCreateObjectDef("fish Mahi");
		rmAddObjectDefItem(fishID, "FishMahi", 1, 0.0);
		rmSetObjectDefMinDistance(fishID, 0.0);
		rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(fishID, fishVsFishID);
		rmAddObjectDefConstraint(fishID, fishLand);
		rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 3*cNumberNonGaiaPlayers);
*/


		int mineb=rmAddFairLoc("TownCenter", false, false, 18, 19, 12, 5); 

   if(rmPlaceFairLocs())
   {
   mineb=rmCreateObjectDef("mine behind");
   rmAddObjectDefItem(mineb, "mine", 1, 0.0);
   for(i=1; <cNumberNonGaiaPlayers+1)
      {
   for(j=0; <rmGetNumberFairLocs(i))
         {
   rmPlaceObjectDefAtLoc(mineb, i, rmFairLocXFraction(i, j), rmFairLocZFraction(i, j), 1);
         }
      }
   }

	int minef=rmAddFairLoc("TownCenter", true, true, 18, 19, 12, 5);

	if(rmPlaceFairLocs()){
		minef=rmCreateObjectDef("forward mine");
		rmAddObjectDefItem(minef, "mine", 1, 0.0);
			for(i=1; <cNumberNonGaiaPlayers+1){
				for(j=1; <rmGetNumberFairLocs(i)){
					rmPlaceObjectDefAtLoc(minef, i, rmFairLocXFraction(i, j), rmFairLocZFraction(i, j), 1);
				}
			}
	}
   
		int Durokan = rmCreateObjectDef("Durokan <3's Aiz");
        rmAddObjectDefItem(Durokan, "Alligator", 2, 6.0);
        rmSetObjectDefMinDistance(Durokan, 0);
        rmSetObjectDefMaxDistance(Durokan, 0);
		rmPlaceObjectDefAtLoc(Durokan, 0, 0.5, 0.89, 1);

		rmSetStatusText("", 1.0);
		
	  // check for KOTH game mode
	  if(rmGetIsKOTH()) {
      ypKingsHillPlacer(.5, .75, .05, 0);
	  }
	}




//new terrain
//ground5(4)>3>2(6)
//forest