// Water map hype ! Made by Rikikipu, May 2017
include "mercenaries.xs";
include "ypAsianInclude.xs";
include "ypKOTHInclude.xs";

void main(void){

// --------------------------------- Building the map ---------------------------------
int	playerTiles = 17000;
if (cNumberNonGaiaPlayers>2)
	playerTiles=13000;
else if (cNumberNonGaiaPlayers>4)
	playerTiles=11000;
int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
rmSetMapSize(size, size);

rmSetSeaType("Wadmalaw Water");
rmEnableLocalWater(false);
rmSetSeaLevel(-3.0);
rmTerrainInitialize("water");
rmSetMapType("fastTestMap");
rmSetWorldCircleConstraint(false);
rmSetMapType("grass");
rmSetLightingSet("spc14abuffalo");
rmSetOceanReveal(true);


// --------------------------------------- Class and variables -----------------------
int subCiv0=-1;
int subCiv1=-1;
subCiv0=rmGetCivID("Seminoles");
rmSetSubCiv(0, "Seminoles");
subCiv0=rmGetCivID("Cherokee");
rmSetSubCiv(0, "Cherokee");

rmDefineClass("startingUnit");
rmDefineClass("importantItem");
rmDefineClass("natives");
rmDefineClass("classCliff");
rmDefineClass("Passage");
rmDefineClass("classForest");

// ------------------------------------------- Constraints -------------------------

int avoidEdge = rmCreatePieConstraint("Avoid Edge",0.5,0.5, rmXFractionToMeters(0.0),rmXFractionToMeters(0.48), rmDegreesToRadians(0),rmDegreesToRadians(360));
int stayinMap = rmCreatePieConstraint("Avoid Edge",0.5,0.5, rmXFractionToMeters(0.0),rmXFractionToMeters(0.5), rmDegreesToRadians(0),rmDegreesToRadians(360));
int avoidEdgeBeach = rmCreatePieConstraint("Avoid Edge Beach",0.5,0.5, rmXFractionToMeters(0.0),rmXFractionToMeters(0.4), rmDegreesToRadians(0),rmDegreesToRadians(360));
int staySouth = rmCreatePieConstraint("Stay South",0.47,0.47, rmXFractionToMeters(0.15),rmXFractionToMeters(0.5), rmDegreesToRadians(135),rmDegreesToRadians(315));
int stayNorth = rmCreatePieConstraint("Stay North",0.53,0.53, rmXFractionToMeters(0.15),rmXFractionToMeters(0.5), rmDegreesToRadians(315),rmDegreesToRadians(135));
int avoidLand = rmCreateTerrainDistanceConstraint("avoid land", "Land", true, 12.0);
int avoidWaterShort = rmCreateTerrainDistanceConstraint("avoid water short", "water", true, 2.0);
int avoidWater = rmCreateTerrainDistanceConstraint("avoid water", "water", true, 7.0);
int avoidCliffs = rmCreateClassDistanceConstraint("avoid Cliffs", rmClassID("classCliff"), 4.0);
int avoidPassage = rmCreateClassDistanceConstraint("avoid passage", rmClassID("Passage"), 2.0);
int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 4.0);
int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 6.0);

int avoidTCShort=rmCreateTypeDistanceConstraint("stay away from TC short", "TownCenter", 25.0);
int avoidTCMedium=rmCreateTypeDistanceConstraint("stay away from TC Medium", "TownCenter", 40.0);
int avoidTCFar=rmCreateTypeDistanceConstraint("stay away from TC Far", "TownCenter", 60.0);
int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 8.0);
int avoidStartMines=rmCreateTypeDistanceConstraint("mines avoid starting mines", "gold", 15.0);

int avoidLandFar = rmCreateTerrainDistanceConstraint("avoid land far", "Land", true, 18+2.0*cNumberNonGaiaPlayers);
int avoidWhale=rmCreateTypeDistanceConstraint("avoid whale", "fish", 40.0);
int avoidFish=rmCreateTypeDistanceConstraint("avoid fish", "fish", 20.0);
int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 6.0);
int avoidCoinShort=rmCreateTypeDistanceConstraint("stuff avoids coin short", "gold", 14.0);
int avoidCoin=rmCreateTypeDistanceConstraint("coin avoid coin", "gold", 50.0);
int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 17.0);
int forestConstraintShort=rmCreateClassDistanceConstraint("forest vs. forest short", rmClassID("classForest"), 10.0);
int forestConstraintVeryShort=rmCreateClassDistanceConstraint("forest vs. forest very short", rmClassID("classForest"), 10.0);
int avoidImportantItem = rmCreateClassDistanceConstraint("secrets etc avoid each other", rmClassID("importantItem"), 10.0);
int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "AbstractNugget", 50.0);
int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 20);
int flagEdgeConstraint = rmCreatePieConstraint("flags stay near edge of map", 0.5, 0.5, rmGetMapXSize()-20, rmGetMapXSize()-10, 0, 0, 0);
int avoidDeer = rmCreateTypeDistanceConstraint("avoid  deer", "deer", 45.0);
int avoidypGiantSalamander = rmCreateTypeDistanceConstraint("avoid  ypGiantSalamander", "ypGiantSalamander", 45.0);


int theBeach = -1;
theBeach=rmCreateArea("Beach");
rmSetAreaLocation(theBeach,0.7,0.3);
rmSetAreaSize(theBeach, 0.13, 0.13); // 0.38 0.47
rmAddAreaInfluenceSegment(theBeach, 0.75, 0.45, 0.7,0.3);
rmAddAreaInfluenceSegment(theBeach, 0.55, 0.25, 0.7,0.3);
rmAddAreaInfluenceSegment(theBeach, 0.55, 0.45, 0.7,0.3);
rmAddAreaInfluenceSegment(theBeach, 0.65, 0.55, 0.7,0.3);
rmAddAreaInfluenceSegment(theBeach, 0.45, 0.35, 0.7,0.3);
rmSetAreaSmoothDistance(theBeach, 15);
rmSetAreaBaseHeight(theBeach, -1);
rmSetAreaCoherence(theBeach, 0.8);
rmSetAreaSmoothDistance(theBeach, 20.0);
rmSetAreaObeyWorldCircleConstraint(theBeach, false);
rmSetAreaElevationNoiseBias(theBeach, 1); // Sets the area elevation variation noise bias (-1 means down only, 0 means +- equally, 1 means up only.)
rmSetAreaElevationVariation(theBeach, 4.0); //: Sets the area elevation variation height (amount to vary +- from area base height).
rmSetAreaElevationPersistence(theBeach, 0.5); //: Sets the area elevation variation noise persistence (best >0 and <1).
rmSetAreaElevationOctaves(theBeach, 1); //: Sets the area elevation variation noise octaves.
rmSetAreaElevationMinFrequency(theBeach, 0.1);
rmSetAreaElevationType(theBeach, cElevTurbulence); //: Sets the area elevation variation type (cElevNormal, cElevFractalSum, cElevTurbulence).
rmSetAreaTerrainType(theBeach,"carolinas\ground_shoreline3_car");
rmBuildArea(theBeach);

int avoidBeach =  rmCreateAreaDistanceConstraint("avoid the Beach", theBeach,3);
int stayBeach =  rmCreateAreaConstraint("stay in beach", theBeach);

int bigContinentID = -1;
bigContinentID=rmCreateArea("big continent");
rmSetAreaSize(bigContinentID, 0.35, 0.35); // 0.38 0.47
rmSetAreaMinBlobDistance(bigContinentID, rmXFractionToMeters(0.1));
rmSetAreaMaxBlobDistance(bigContinentID, rmXFractionToMeters(0.4));
rmSetAreaSmoothDistance(bigContinentID, 20);
rmSetAreaMix(bigContinentID, "carolina_grass");
rmSetAreaBaseHeight(bigContinentID, -1);
rmSetAreaCoherence(bigContinentID, 0.9);
rmSetAreaObeyWorldCircleConstraint(bigContinentID, false);
rmSetAreaLocation(bigContinentID, 0.45, 0.55);
rmAddAreaInfluenceSegment(bigContinentID, 0.4, 0.6, 0,1.0);
rmAddAreaInfluenceSegment(bigContinentID, 0.4, 0.6, 0.3,1.0);
rmAddAreaInfluenceSegment(bigContinentID, 0.4, 0.6, 0.0,0.7);
rmAddAreaInfluenceSegment(bigContinentID, 0.3, 0.7, 0.8, 0.6);
rmAddAreaInfluenceSegment(bigContinentID, 0.8, 0.6, 0.8, 0.55);
rmAddAreaInfluenceSegment(bigContinentID, 0.3, 0.7, 0.4, 0.2);
rmAddAreaInfluenceSegment(bigContinentID, 0.4, 0.2, 0.45, 0.2);
rmSetAreaObeyWorldCircleConstraint(bigContinentID, false);
rmAddAreaTerrainLayer(bigContinentID, "carolinas\ground_marsh1_car", 0, 2);
rmBuildArea(bigContinentID);


int CliffPlacement =  rmCreateEdgeDistanceConstraint("define area for cliffs", bigContinentID,5);

int middlePoint = -1;
middlePoint=rmCreateArea("middlePoint");
rmSetAreaLocation(middlePoint, 0.48, 0.52);
rmSetAreaSize(middlePoint, rmXMetersToFraction(3.0), rmXMetersToFraction(3.0));
rmSetAreaCoherence(middlePoint, 0.5);
rmAddAreaToClass(middlePoint,rmClassID("Passage"));
rmSetAreaTerrainType(middlePoint, "carolinas\ground_marsh2_car");
rmBuildArea(middlePoint);

int topPoint = -1;
topPoint=rmCreateArea("topPoint");
rmSetAreaLocation(topPoint, 0.78, 0.52);
rmSetAreaCoherence(topPoint, 0.5);
rmSetAreaSize(topPoint, rmXMetersToFraction(2.0), rmXMetersToFraction(2.0));
rmAddAreaToClass(topPoint,rmClassID("Passage"));
rmSetAreaTerrainType(topPoint, "carolinas\ground_marsh2_car");
rmBuildArea(topPoint);

int bottomPoint = -1;
bottomPoint=rmCreateArea("bottomPoint");
rmSetAreaLocation(bottomPoint, 0.48, 0.22);
rmSetAreaCoherence(bottomPoint, 0.5);
rmSetAreaSize(bottomPoint, rmXMetersToFraction(2.0), rmXMetersToFraction(2.0));
rmAddAreaToClass(bottomPoint,rmClassID("Passage"));
rmSetAreaTerrainType(bottomPoint, "carolinas\ground_marsh2_car");
rmBuildArea(bottomPoint);

int randomPoint1 = -1;
randomPoint1=rmCreateArea("randomPoint1");
rmSetAreaLocation(randomPoint1, 0.2500, 0.5500);
rmSetAreaCoherence(randomPoint1, 0.5);
rmSetAreaSize(randomPoint1, rmXMetersToFraction(2.0), rmXMetersToFraction(2.0));
rmAddAreaToClass(randomPoint1,rmClassID("Passage"));
rmSetAreaSmoothDistance(randomPoint1, 10);
rmSetAreaHeightBlend(randomPoint1,1);
rmSetAreaTerrainType(randomPoint1, "carolinas\ground_marsh2_car");
rmBuildArea(randomPoint1);

int randomPoint2 = -1;
randomPoint2=rmCreateArea("randomPoint2");
rmSetAreaLocation(randomPoint2, 0.6800, 0.6800);
rmSetAreaCoherence(randomPoint2, 0.5);
rmSetAreaSize(randomPoint2, rmXMetersToFraction(2.0), rmXMetersToFraction(2.0));
rmAddAreaToClass(randomPoint2,rmClassID("Passage"));
rmSetAreaSmoothDistance(randomPoint2, 10);
rmSetAreaHeightBlend(randomPoint2,1);
rmSetAreaTerrainType(randomPoint2, "carolinas\ground_marsh2_car");
rmBuildArea(randomPoint2);

int randomPoint3 = -1;
randomPoint3=rmCreateArea("randomPoint3");
rmSetAreaLocation(randomPoint3, 0.3200, 0.3200);
rmSetAreaCoherence(randomPoint3, 0.5);
rmSetAreaSize(randomPoint3, rmXMetersToFraction(2.0), rmXMetersToFraction(2.0));
rmAddAreaToClass(randomPoint3,rmClassID("Passage"));
rmSetAreaSmoothDistance(randomPoint3, 10);
rmSetAreaHeightBlend(randomPoint3,1);
rmSetAreaTerrainType(randomPoint3, "carolinas\ground_marsh2_car");
rmBuildArea(randomPoint3);

int randomPoint4 = -1;
randomPoint4=rmCreateArea("randomPoint4");
rmSetAreaLocation(randomPoint4, 0.45, 0.75);
rmSetAreaCoherence(randomPoint4, 0.5);
rmSetAreaSize(randomPoint4, rmXMetersToFraction(3.0), rmXMetersToFraction(3.0));
rmAddAreaToClass(randomPoint4,rmClassID("Passage"));
rmSetAreaSmoothDistance(randomPoint4, 10);
rmSetAreaHeightBlend(randomPoint4,1);
rmSetAreaTerrainType(randomPoint4, "carolinas\ground_marsh2_car");
rmBuildArea(randomPoint4);

int randomPoint5 = -1;
randomPoint5=rmCreateArea("randomPoint5");
rmSetAreaLocation(randomPoint5, 0.05, 0.65);
rmSetAreaCoherence(randomPoint5, 0.5);
rmSetAreaSize(randomPoint5, rmXMetersToFraction(2.0), rmXMetersToFraction(2.0));
rmAddAreaToClass(randomPoint5,rmClassID("Passage"));
rmSetAreaSmoothDistance(randomPoint5, 10);
rmSetAreaHeightBlend(randomPoint5,1);
rmSetAreaTerrainType(randomPoint5, "carolinas\ground_marsh2_car");
rmBuildArea(randomPoint5);

int randomPoint6 = -1;
randomPoint6=rmCreateArea("randomPoint6");
rmSetAreaLocation(randomPoint6, 0.35, 0.95);
rmSetAreaCoherence(randomPoint6, 0.5);
rmSetAreaSize(randomPoint6, rmXMetersToFraction(2.0), rmXMetersToFraction(2.0));
rmAddAreaToClass(randomPoint6,rmClassID("Passage"));
rmSetAreaSmoothDistance(randomPoint6, 10);
rmSetAreaHeightBlend(randomPoint6,1);
rmSetAreaTerrainType(randomPoint6, "carolinas\ground_marsh2_car");
rmBuildArea(randomPoint6);


int cliffID=rmCreateArea("cliffs");
rmSetAreaSize(cliffID, 0.25, 0.25);
rmSetAreaLocation(cliffID,0.3,0.7);
rmSetAreaWarnFailure(cliffID, false);
rmSetAreaCliffType(cliffID, "carolina");
rmSetAreaCliffEdge(cliffID, 1, 1.0);
rmSetAreaCliffPainting(cliffID, true, true, true, 1.0, false);
rmSetAreaCliffHeight(cliffID, 4, 0.0, 0.5);
rmSetAreaHeightBlend(cliffID, 2);
rmAddAreaToClass(cliffID, rmClassID("classCliff"));
rmSetAreaSmoothDistance(cliffID, 8);
rmSetAreaCoherence(cliffID, 0);
rmAddAreaConstraint(cliffID,CliffPlacement);
rmAddAreaCliffEdgeAvoidClass(cliffID,rmClassID("Passage"));
rmAddAreaTerrainLayer(cliffID, "carolinas\ground_marsh1_car", 0, 1);
rmAddAreaTerrainReplacement(cliffID,"carolinas\ground_grass3_car","carolinas\ground_grass3_car");
rmBuildArea(cliffID);

int avoidBigContinent = rmCreateAreaDistanceConstraint("avoid Big Continent",bigContinentID,0.1);
int stayBigContinent = rmCreateAreaConstraint("stay Big Continent",bigContinentID);
int nearShore = rmCreateEdgeMaxDistanceConstraint("stay near shore", bigContinentID, 4);
int stayInCliffs= rmCreateCliffEdgeDistanceConstraint("stay in the cliffs", cliffID, 5);


	
// Choose Mercs
chooseMercs();


int NorthIsland = -1;
NorthIsland=rmCreateArea("north island");
rmSetAreaSize(NorthIsland, 0.03, 0.03); // 0.38 0.47
rmSetAreaSmoothDistance(NorthIsland, 10);
rmSetAreaMix(NorthIsland, "carolina_grass");
rmSetAreaElevationType(NorthIsland, cElevTurbulence);
rmSetAreaElevationVariation(NorthIsland, 2.0);
rmSetAreaBaseHeight(NorthIsland, 0);
rmSetAreaElevationMinFrequency(NorthIsland, 0.09);
rmSetAreaElevationOctaves(NorthIsland, 3);
rmSetAreaElevationPersistence(NorthIsland, 0.2);
rmSetAreaElevationNoiseBias(NorthIsland, 1);
rmSetAreaCoherence(NorthIsland, 0.6);
rmSetAreaObeyWorldCircleConstraint(NorthIsland, true);
rmSetAreaLocation(NorthIsland, 0.7, 1.0);
rmSetAreaEdgeFilling(NorthIsland, 0);
rmAddAreaTerrainLayer(NorthIsland, "carolinas\ground_marsh1_car",0,3);
rmAddAreaTerrainLayer(NorthIsland, "carolinas\ground_marsh2_car",3,6);
rmAddAreaTerrainLayer(NorthIsland, "carolinas\ground_marsh3_car",6,8);
rmBuildArea(NorthIsland);

int SouthIsland = -1;
SouthIsland=rmCreateArea("south island");
rmSetAreaSize(SouthIsland, 0.03, 0.03); // 0.38 0.47
rmSetAreaSmoothDistance(SouthIsland, 10);
rmSetAreaMix(SouthIsland, "carolina_grass");
rmSetAreaElevationType(SouthIsland, cElevTurbulence);
rmSetAreaElevationVariation(SouthIsland, 2.0);
rmSetAreaBaseHeight(SouthIsland, 0);
rmSetAreaElevationMinFrequency(SouthIsland, 0.09);
rmSetAreaElevationOctaves(SouthIsland, 3);
rmSetAreaElevationPersistence(SouthIsland, 0.2);
rmSetAreaElevationNoiseBias(SouthIsland, 1);
rmSetAreaCoherence(SouthIsland, 0.6);
rmSetAreaObeyWorldCircleConstraint(SouthIsland, true);
rmSetAreaLocation(SouthIsland, 0.0, 0.3);
rmSetAreaEdgeFilling(SouthIsland, 0);
rmAddAreaTerrainLayer(SouthIsland, "carolinas\ground_marsh1_car",0,3);
rmAddAreaTerrainLayer(SouthIsland, "carolinas\ground_marsh2_car",3,6);
rmAddAreaTerrainLayer(SouthIsland, "carolinas\ground_marsh3_car",6,8);
rmBuildArea(SouthIsland);

int stayNorthIsland=rmCreateAreaConstraint("stay north island", NorthIsland);
int avoidNorthIsland=rmCreateAreaDistanceConstraint("avoid north island", NorthIsland,5.0);
int staySouthIsland=rmCreateAreaConstraint("stay south island", SouthIsland);
int avoidSouthIsland=rmCreateAreaDistanceConstraint("avoid south island", SouthIsland,5.0);




int socketID=-1;
socketID=rmCreateObjectDef("sockets for Trade Route");
rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
rmAddObjectDefToClass(socketID, rmClassID("importantItem"));
rmSetObjectDefAllowOverlap(socketID, true);
rmSetObjectDefMinDistance(socketID, 0.0);
rmSetObjectDefMaxDistance(socketID, 8.0);

int tradeRouteID =-1;
tradeRouteID=rmCreateTradeRoute();
rmAddTradeRouteWaypoint(tradeRouteID, 0.1, 0.9);
rmAddRandomTradeRouteWaypoints(tradeRouteID, 0.3, 0.7, 4, 4);
rmAddTradeRouteWaypoint(tradeRouteID,0.5,0.5);
rmAddRandomTradeRouteWaypoints(tradeRouteID, 0.6, 0.4, 4, 4);
rmAddTradeRouteWaypoint(tradeRouteID,0.65,0.35);
bool placedTradeRoute = rmBuildTradeRoute(tradeRouteID, "dirt");
vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.15);
rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.5);
rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 1.0);
rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);


int comancheVillageIDA = -1;
comancheVillageIDA = rmCreateGrouping("Cherokee village A", "native Cherokee village 1");
rmSetGroupingMinDistance(comancheVillageIDA, 0.00);
rmSetGroupingMaxDistance(comancheVillageIDA, 0.00);
rmAddGroupingConstraint(comancheVillageIDA, avoidAll);
rmAddGroupingToClass(comancheVillageIDA, rmClassID("importantItem"));
rmPlaceGroupingAtLoc(comancheVillageIDA, 0, 0.32, 0.83);


int comancheVillageIDB = -1;
comancheVillageIDB = rmCreateGrouping("Cherokee village B", "native Cherokee village 1");
rmSetGroupingMinDistance(comancheVillageIDB, 0.00);
rmSetGroupingMaxDistance(comancheVillageIDB, 0.00);
rmAddGroupingConstraint(comancheVillageIDB, avoidAll);
rmAddGroupingToClass(comancheVillageIDB, rmClassID("importantItem"));
rmPlaceGroupingAtLoc(comancheVillageIDB, 0, 0.17, 0.68);



if (cNumberNonGaiaPlayers==2)
{
	rmPlacePlayer(1,0.7800,0.5800);
	rmPlacePlayer(2,0.4000,0.2000);
}
if (cNumberNonGaiaPlayers>2)
{
   rmSetPlacementTeam(0);
   rmPlacePlayersLine(0.78, 0.58, 0.54, 0.66, 10, 5);

   rmSetPlacementTeam(1);
   rmPlacePlayersLine(0.42, 0.22, 0.34, 0.46, 10, 5);
}

int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
int startingTCID = rmCreateObjectDef("startingTC");
if ( rmGetNomadStart())
{
	rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
}
else
{
	rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0);
}
rmAddObjectDefToClass(startingTCID, rmClassID("startingUnit"));
rmSetObjectDefMinDistance(startingTCID, 0.0);
rmSetObjectDefMaxDistance(startingTCID, 0.0);

int startSilverID = rmCreateObjectDef("first mine");
rmAddObjectDefItem(startSilverID, "MineTin", 1, 5.0);
rmAddObjectDefToClass(startSilverID, rmClassID("startingUnit"));
rmSetObjectDefMinDistance(startSilverID, 13.0);
rmSetObjectDefMaxDistance(startSilverID, 16.0);
rmAddObjectDefConstraint(startSilverID, avoidStartMines);
rmAddObjectDefConstraint(startSilverID, avoidStartingUnits);
rmAddObjectDefConstraint(startSilverID, stayInCliffs);

int startBerries = rmCreateObjectDef("starting berries");
rmAddObjectDefItem(startBerries, "berrybush", 4, 2.0);
rmAddObjectDefToClass(startBerries, rmClassID("startingUnit"));
rmSetObjectDefMinDistance(startBerries, 10.0);
rmSetObjectDefMaxDistance(startBerries, 13.0);
rmAddObjectDefConstraint(startBerries, avoidStartingUnits);

int starTrees = rmCreateObjectDef("starting trees");
rmAddObjectDefItem(starTrees, "TreeGreatPlains", rmRandInt(2,3), 2.0);
rmAddObjectDefItem(starTrees, "Underbrushcarolinasforest", 1, 2.0);
rmAddObjectDefToClass(starTrees, rmClassID("startingUnit"));
rmSetObjectDefMinDistance(starTrees, 10.0);
rmSetObjectDefMaxDistance(starTrees, 22.0);
rmAddObjectDefConstraint(starTrees, avoidStartingUnits);
rmAddObjectDefConstraint(starTrees, avoidWater);

int startHunt = rmCreateObjectDef("starting hunt");
rmAddObjectDefItem(startHunt, "deer", 8, 5.0);
rmAddObjectDefToClass(startHunt, rmClassID("startingUnit"));
rmSetObjectDefMinDistance(startHunt, 9.0);
rmSetObjectDefMaxDistance(startHunt, 12.0);
rmAddObjectDefConstraint(startHunt, avoidStartingUnits);
rmAddObjectDefConstraint(startHunt, stayInCliffs);

int waterFlagID=rmCreateObjectDef("HC water flag ");
rmAddObjectDefItem(waterFlagID, "HomeCityWaterSpawnFlag", 1, 0.0);
rmAddClosestPointConstraint(flagVsFlag);
rmAddClosestPointConstraint(avoidLand);

int catamaranID=rmCreateObjectDef("a little canoe");
rmAddObjectDefItem(catamaranID, "Canoe", 1, 3.0);

for(i=1; <=cNumberNonGaiaPlayers)
{
	rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	vector TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingTCID, i));
    vector closestPoint = rmFindClosestPointVector(TCLocation, rmXFractionToMeters(1.0));

	if(ypIsAsian(i) && rmGetNomadStart() == false){
      	rmPlaceObjectDefAtLoc(ypMonasteryBuilder(i, 0), i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	}
	rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	rmPlaceObjectDefAtLoc(startSilverID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	rmPlaceObjectDefAtLoc(startSilverID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	rmPlaceObjectDefAtLoc(startBerries, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	rmPlaceObjectDefAtLoc(startHunt, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	rmPlaceObjectDefAtLoc(starTrees, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	rmPlaceObjectDefAtLoc(starTrees, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	rmPlaceObjectDefAtLoc(starTrees, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	rmPlaceObjectDefAtLoc(starTrees, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	rmPlaceObjectDefAtLoc(starTrees, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	rmPlaceObjectDefAtLoc(starTrees, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	rmPlaceObjectDefAtLoc(waterFlagID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
	vector flagLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(waterFlagID, i));
	rmPlaceObjectDefAtLoc(catamaranID, i, rmXMetersToFraction(xsVectorGetX(flagLocation)), rmZMetersToFraction(xsVectorGetZ(flagLocation)));
}




// ------------------------------------------- Resources --------------------------------------------------

if (cNumberNonGaiaPlayers==2)
{
	int silvermines = rmCreateObjectDef("silver mines");
	rmAddObjectDefItem(silvermines, "mine", 1, 5.0);
	rmSetObjectDefMinDistance(silvermines, 0.0);
	rmSetObjectDefMaxDistance(silvermines, 8.0);
	rmAddObjectDefConstraint(silvermines, avoidAll);
	rmAddObjectDefConstraint(silvermines, avoidTradeRoute);
	rmPlaceObjectDefAtLoc(silvermines, 0, 0.06, 0.3); // Beach
	rmPlaceObjectDefAtLoc(silvermines, 0, 0.7, 0.94); // Beach
	if (rmRandFloat(0,1)<0.5){
		rmPlaceObjectDefAtLoc(silvermines, 0, 0.75, 0.35); // Beach
		rmPlaceObjectDefAtLoc(silvermines, 0, 0.65, 0.25);
		rmPlaceObjectDefAtLoc(silvermines, 0, 0.65, 0.62); // Ramp
		rmPlaceObjectDefAtLoc(silvermines, 0, 0.38, 0.35);
		rmPlaceObjectDefAtLoc(silvermines, 0, 0.3, 0.9); // Left
		rmPlaceObjectDefAtLoc(silvermines, 0, 0.1, 0.7);
		rmPlaceObjectDefAtLoc(silvermines, 0, 0.55, 0.45);	// Middle
		rmPlaceObjectDefAtLoc(silvermines, 0, 0.3, 0.7);	// Middle Left
	}
	else {
		rmPlaceObjectDefAtLoc(silvermines, 0, 0.75, 0.45); // Beach
		rmPlaceObjectDefAtLoc(silvermines, 0, 0.55, 0.25);
		rmPlaceObjectDefAtLoc(silvermines, 0, 0.58, 0.6); // Ramp
		rmPlaceObjectDefAtLoc(silvermines, 0, 0.4, 0.42);
		rmPlaceObjectDefAtLoc(silvermines, 0, 0.38, 0.75); // Left
		rmPlaceObjectDefAtLoc(silvermines, 0, 0.25, 0.62);
		rmPlaceObjectDefAtLoc(silvermines, 0, 0.73, 0.27);	// Beach Right
		rmPlaceObjectDefAtLoc(silvermines, 0, 0.5, 0.5);	// Middle
		rmPlaceObjectDefAtLoc(silvermines, 0, 0.2, 0.8);	// Middle Left
	}
}
if (cNumberNonGaiaPlayers>2)
{
		   for (i=0; <cNumberNonGaiaPlayers*3)
      {
	int silverminesteam = rmCreateObjectDef("silver mines team"+i);
	rmAddObjectDefItem(silverminesteam, "mine", 1, 0.0);
	rmSetObjectDefMinDistance(silverminesteam, 0.0);
	rmSetObjectDefMaxDistance(silverminesteam, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(silverminesteam, avoidAll);
	rmAddObjectDefConstraint(silverminesteam, avoidTradeRoute);
	rmAddObjectDefConstraint(silverminesteam, avoidTCMedium);
	rmAddObjectDefConstraint(silverminesteam, avoidCoin);
	rmPlaceObjectDefAtLoc(silverminesteam, 0, 0.5, 0.5);
}
}


int northFood= rmCreateObjectDef("north food");
rmAddObjectDefItem(northFood, "cow", 3, 8);
rmAddObjectDefItem(northFood, "berrybush", 3, 8);
rmSetObjectDefMinDistance(northFood, 0.0);
rmSetObjectDefMaxDistance(northFood, rmXFractionToMeters(0.5));
rmAddObjectDefConstraint(northFood,stayNorthIsland);
rmAddObjectDefConstraint(northFood,avoidWater);
rmAddObjectDefConstraint(northFood,avoidEdge);
rmPlaceObjectDefAtLoc(northFood, 0, 0.5, 0.5);

int southFood= rmCreateObjectDef("south food");
rmAddObjectDefItem(southFood, "cow", 3, 8);
rmAddObjectDefItem(southFood, "berrybush", 3, 8);
rmSetObjectDefMinDistance(southFood, 0.0);
rmSetObjectDefMaxDistance(southFood, rmXFractionToMeters(0.5));
rmAddObjectDefConstraint(southFood,staySouthIsland);
rmAddObjectDefConstraint(southFood,avoidWater);
rmAddObjectDefConstraint(southFood,avoidEdge);
rmPlaceObjectDefAtLoc(southFood, 0, 0.5, 0.5);


for(i=1; <=10)
{
int PlateauForest=rmCreateArea("plateau forest"+i);
rmSetAreaWarnFailure(PlateauForest, false);
rmSetAreaSize(PlateauForest, rmXMetersToFraction(5), rmXMetersToFraction(6));
rmSetAreaForestType(PlateauForest, "z68 Carolina Plains");
rmSetAreaForestDensity(PlateauForest, 0.4);
rmSetAreaForestClumpiness(PlateauForest, 0.5);
rmSetAreaForestUnderbrush(PlateauForest, 0.4);
rmSetAreaCoherence(PlateauForest, 0.5);
rmAddAreaToClass(PlateauForest, rmClassID("classForest"));
rmAddAreaConstraint(PlateauForest, avoidImportantItem);
rmAddAreaConstraint(PlateauForest, avoidCoinShort);
rmAddAreaConstraint(PlateauForest, stayBigContinent);
rmAddAreaConstraint(PlateauForest, stayInCliffs);
rmAddAreaConstraint(PlateauForest, forestConstraint);
rmAddAreaConstraint(PlateauForest, avoidTCShort);
rmAddAreaConstraint(PlateauForest, avoidWaterShort);
rmSetAreaObeyWorldCircleConstraint(PlateauForest, true);
rmBuildArea(PlateauForest);
}

int j=0;
for(i=1; <=20)
{
int ShoreForestNorth=rmCreateArea("shore forest north"+i);
rmSetAreaWarnFailure(ShoreForestNorth, false);
rmSetAreaSize(ShoreForestNorth, 1.0, 1.0);
rmSetAreaCoherence(ShoreForestNorth, 0.0);
rmAddAreaToClass(ShoreForestNorth, rmClassID("classForest"));
rmAddAreaConstraint(ShoreForestNorth, avoidStartingUnits);
rmAddAreaConstraint(ShoreForestNorth, nearShore);
rmAddAreaConstraint(ShoreForestNorth, avoidPassage);
rmAddAreaConstraint(ShoreForestNorth, avoidBeach);
rmAddAreaConstraint(ShoreForestNorth, stayNorth);
rmBuildArea(ShoreForestNorth);

		int stayInNorthForest = rmCreateAreaMaxDistanceConstraint("stay in north forest"+i, ShoreForestNorth, 0);

		for (j=0; < rmRandInt(1,2)) //18,20
		{
			int northtreeID = rmCreateObjectDef("north tree"+i+j);
			rmAddObjectDefItem(northtreeID, "underbrushmongolia", rmRandInt(4,5), 4.0); // 1,2
			rmAddObjectDefItem(northtreeID, "ypTreeMongolianFir", rmRandInt(1,2), 2.0); // 1,2
			rmSetObjectDefMinDistance(northtreeID, 0);
			rmSetObjectDefMaxDistance(northtreeID, rmXFractionToMeters(0.5));
			rmAddObjectDefToClass(northtreeID, rmClassID("classForest"));
			rmAddObjectDefConstraint(northtreeID, stayInNorthForest);
			rmPlaceObjectDefAtLoc(northtreeID, 0, 0.50, 0.50);
		}



}

for(i=1; <=20)
{
int ShoreForestSouth=rmCreateArea("shore forest south"+i);
rmSetAreaWarnFailure(ShoreForestSouth, false);
rmSetAreaSize(ShoreForestSouth, 1.0, 1.0);
rmSetAreaCoherence(ShoreForestSouth, 0.0);
rmAddAreaToClass(ShoreForestSouth, rmClassID("classForest"));
rmAddAreaConstraint(ShoreForestSouth, avoidStartingUnits);
rmAddAreaConstraint(ShoreForestSouth, nearShore);
rmAddAreaConstraint(ShoreForestSouth, avoidPassage);
rmAddAreaConstraint(ShoreForestSouth, avoidBeach);
rmAddAreaConstraint(ShoreForestSouth, staySouth);
rmBuildArea(ShoreForestSouth);

		int stayInSouthForest = rmCreateAreaMaxDistanceConstraint("stay in shouth forest"+i, ShoreForestSouth, 0);

		for (j=0; < rmRandInt(1,2)) //18,20
		{
			int southTreeID = rmCreateObjectDef("south tree"+i+j);
			rmAddObjectDefItem(southTreeID, "underbrushmongolia", rmRandInt(4,5), 4.0); // 1,2
			rmAddObjectDefItem(southTreeID, "ypTreeMongolianFir", rmRandInt(1,2), 2.0); // 1,2
			rmSetObjectDefMinDistance(southTreeID, 0);
			rmSetObjectDefMaxDistance(southTreeID, rmXFractionToMeters(0.5));
			rmAddObjectDefToClass(southTreeID, rmClassID("classForest"));
			rmAddObjectDefConstraint(southTreeID, stayInSouthForest);
			rmPlaceObjectDefAtLoc(southTreeID, 0, 0.50, 0.50);
		}


}
for(i=1; <=8)
{
int BeachForest=rmCreateArea("shore forest beach"+i);
rmSetAreaSize(BeachForest, rmXMetersToFraction(1), rmXMetersToFraction(2));
rmSetAreaForestType(BeachForest, "z40 Steppe Forest");
rmSetAreaForestDensity(BeachForest, 0.7);
rmSetAreaForestClumpiness(BeachForest, 0.0);
rmSetAreaForestUnderbrush(BeachForest, 0.3);
rmSetAreaCoherence(BeachForest, 0.0);
rmAddAreaToClass(BeachForest, rmClassID("classForest"));
rmAddAreaConstraint(BeachForest, avoidPassage);
rmAddAreaConstraint(BeachForest, stayBeach);
rmAddAreaConstraint(BeachForest, avoidBigContinent);
rmAddAreaConstraint(BeachForest, avoidImportantItem);
rmAddAreaConstraint(BeachForest, forestConstraintShort);
rmAddAreaConstraint(BeachForest, avoidCoinShort);
rmBuildArea(BeachForest);
}

if (cNumberNonGaiaPlayers==2)
{
int connectionTopHunt = rmCreateObjectDef("connection top hunt");
rmAddObjectDefItem(connectionTopHunt, "ypGiantSalamander", rmRandInt(7,8), 6.0);
rmSetObjectDefMinDistance(connectionTopHunt, 0.0);
rmSetObjectDefMaxDistance(connectionTopHunt, 0.0);
rmSetObjectDefCreateHerd(connectionTopHunt, true);
rmPlaceObjectDefAtLoc(connectionTopHunt, 0, 0.7, 0.4);

int connectionBottomHunt = rmCreateObjectDef("connection bottom hunt");
rmAddObjectDefItem(connectionBottomHunt, "ypGiantSalamander", rmRandInt(7,8), 6.0);
rmSetObjectDefMinDistance(connectionBottomHunt, 0.0);
rmSetObjectDefMaxDistance(connectionBottomHunt, 0.0);
rmSetObjectDefCreateHerd(connectionBottomHunt, true);
rmPlaceObjectDefAtLoc(connectionBottomHunt, 0, 0.6, 0.3);

int ramTopHuntTC = rmCreateObjectDef("ramp top hunt tc");
rmAddObjectDefItem(ramTopHuntTC, "deer", rmRandInt(10,11), 8.0);
rmSetObjectDefMinDistance(ramTopHuntTC, 0.0);
rmSetObjectDefMaxDistance(ramTopHuntTC, 0.0);
rmSetObjectDefCreateHerd(ramTopHuntTC, true);
rmPlaceObjectDefAtLoc(ramTopHuntTC, 0,  0.67, 0.6);

int rampBottomHunt = rmCreateObjectDef("ramp bottom hunt tc");
rmAddObjectDefItem(rampBottomHunt, "deer", rmRandInt(10,11), 8.0);
rmSetObjectDefMinDistance(rampBottomHunt, 0.0);
rmSetObjectDefMaxDistance(rampBottomHunt, 0.0);
rmSetObjectDefCreateHerd(rampBottomHunt, true);
rmPlaceObjectDefAtLoc(rampBottomHunt, 0, 0.4, 0.33);

int topFrontIslandHunt = rmCreateObjectDef("top front island hunt");
rmAddObjectDefItem(topFrontIslandHunt, "deer", rmRandInt(7,8), 8.0);
rmSetObjectDefMinDistance(topFrontIslandHunt, 0.0);
rmSetObjectDefMaxDistance(topFrontIslandHunt, 0.0);
rmSetObjectDefCreateHerd(topFrontIslandHunt, true);
rmPlaceObjectDefAtLoc(topFrontIslandHunt, 0,  0.52, 0.7);

int bottomFrontIslandHunt = rmCreateObjectDef("bottom front island hunt");
rmAddObjectDefItem(bottomFrontIslandHunt, "deer", rmRandInt(7,8), 8.0);
rmSetObjectDefMinDistance(bottomFrontIslandHunt, 0.0);
rmSetObjectDefMaxDistance(bottomFrontIslandHunt, 0.0);
rmSetObjectDefCreateHerd(bottomFrontIslandHunt, true);
rmPlaceObjectDefAtLoc(bottomFrontIslandHunt, 0,  0.3, 0.48);

int middlerightHunt = rmCreateObjectDef("middle right hunt");
rmAddObjectDefItem(middlerightHunt, "deer", rmRandInt(16,18), 8.0);
rmSetObjectDefMinDistance(middlerightHunt, 0.0);
rmSetObjectDefMaxDistance(middlerightHunt, 0.0);
rmSetObjectDefCreateHerd(middlerightHunt, true);
rmPlaceObjectDefAtLoc(middlerightHunt, 0, 0.48, 0.52);

int middleLeftHunt = rmCreateObjectDef("middle left hunt");
rmAddObjectDefItem(middleLeftHunt, "deer", rmRandInt(14,15), 8.0);
rmSetObjectDefMinDistance(middleLeftHunt, 0.0);
rmSetObjectDefMaxDistance(middleLeftHunt, 0.0);
rmSetObjectDefCreateHerd(middleLeftHunt, true);
rmPlaceObjectDefAtLoc(middleLeftHunt, 0, 0.3, 0.7);

int topmiddleHunt = rmCreateObjectDef("top middle hunt");
rmAddObjectDefItem(topmiddleHunt, "deer", rmRandInt(12,13), 8.0);
rmSetObjectDefMinDistance(topmiddleHunt, 0.0);
rmSetObjectDefMaxDistance(topmiddleHunt, 0.0);
rmSetObjectDefCreateHerd(topmiddleHunt, true);
rmPlaceObjectDefAtLoc(topmiddleHunt,0, 0.3, 0.9);

int bottomMiddleHunt = rmCreateObjectDef("bottom middle hunt");
rmAddObjectDefItem(bottomMiddleHunt, "deer", rmRandInt(12,13), 8.0);
rmSetObjectDefMinDistance(bottomMiddleHunt, 0.0);
rmSetObjectDefMaxDistance(bottomMiddleHunt, 0.0);
rmSetObjectDefCreateHerd(bottomMiddleHunt, true);
rmPlaceObjectDefAtLoc(bottomMiddleHunt, 0, 0.1, 0.7);
}
if (cNumberNonGaiaPlayers>2)
{
	for (i=1;<cNumberNonGaiaPlayers*2)
{
	int TeamHunt=rmCreateObjectDef("deer herd" +i);
	rmAddObjectDefItem(TeamHunt, "deer", rmRandInt(10,12), 7.0);
	rmSetObjectDefMinDistance(TeamHunt, 0.0);
	rmSetObjectDefMaxDistance(TeamHunt, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(TeamHunt, avoidAll);
	rmAddObjectDefConstraint(TeamHunt, avoidTCMedium);
	rmAddObjectDefConstraint(TeamHunt, stayInCliffs);
	rmAddObjectDefConstraint(TeamHunt, avoidBeach);
    rmAddAreaConstraint(TeamHunt, avoidDeer);
	rmSetObjectDefCreateHerd(TeamHunt, true);
	rmPlaceObjectDefAtLoc(TeamHunt, 0, 0.5, 0.5);
}
	for (i=1;<cNumberNonGaiaPlayers)
{
	int TeamHuntMid=rmCreateObjectDef("ypGiantSalamander herd" +i);
	rmAddObjectDefItem(TeamHuntMid, "ypGiantSalamander", rmRandInt(10,12), 7.0);
	rmSetObjectDefMinDistance(TeamHuntMid, 0.0);
	rmSetObjectDefMaxDistance(TeamHuntMid, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(TeamHuntMid, avoidAll);
	rmAddObjectDefConstraint(TeamHuntMid, avoidTCMedium);
	rmAddObjectDefConstraint(TeamHuntMid, avoidWater);
	rmAddObjectDefConstraint(TeamHuntMid, stayBeach);
    rmAddAreaConstraint(TeamHuntMid, avoidypGiantSalamander);
	rmSetObjectDefCreateHerd(TeamHuntMid, true);
	rmPlaceObjectDefAtLoc(TeamHuntMid, 0, 0.5, 0.5);
}
}
for (i=1;<4)
{
	int NorthForest=rmCreateArea("north forest"+i);
	rmSetAreaSize(NorthForest, rmXMetersToFraction(2), rmXMetersToFraction(2));
	rmSetAreaForestType(NorthForest, "z69 Appalachian Rainforest");
	rmSetAreaForestDensity(NorthForest, 0.3);
	rmSetAreaForestClumpiness(NorthForest, 0.5);
	rmSetAreaForestUnderbrush(NorthForest, 0.5);
	rmSetAreaCoherence(NorthForest, 0.5);
	rmAddAreaToClass(NorthForest, rmClassID("classForest"));
	rmAddAreaConstraint(NorthForest,stayNorthIsland);
	rmAddAreaConstraint(NorthForest,avoidAll);
	rmAddAreaConstraint(NorthForest,avoidAll);
	rmAddAreaConstraint(NorthForest,stayinMap);
	rmAddAreaConstraint(NorthForest,avoidWaterShort);
	rmAddAreaConstraint(NorthForest,forestConstraintVeryShort);
	rmSetAreaObeyWorldCircleConstraint(NorthForest,true);
	rmBuildArea(NorthForest);


	int SouthForest=rmCreateArea("south forest"+i);
	rmSetAreaSize(SouthForest, rmXMetersToFraction(2), rmXMetersToFraction(2));
	rmSetAreaForestType(SouthForest, "z69 Appalachian Rainforest");
	rmSetAreaForestDensity(SouthForest, 0.3);
	rmSetAreaForestClumpiness(SouthForest, 0.5);
	rmSetAreaForestUnderbrush(SouthForest, 0.5);
	rmSetAreaCoherence(SouthForest, 0.5);
	rmAddAreaToClass(SouthForest, rmClassID("classForest"));
	rmAddAreaConstraint(SouthForest,staySouthIsland);
	rmAddAreaConstraint(SouthForest,avoidAll);
	rmAddAreaConstraint(SouthForest,stayinMap);
	rmAddAreaConstraint(SouthForest,avoidWaterShort);
	rmAddAreaConstraint(SouthForest,forestConstraintVeryShort);
	rmBuildArea(SouthForest);
}
// ------------------------------------------ Fishes -------------------------------------------------

int whalecount = 3*cNumberNonGaiaPlayers;
int whaleNorth=rmCreateObjectDef("whale north");
rmAddObjectDefItem(whaleNorth, "HumpbackWhale", 1, 3.0);
rmSetObjectDefMinDistance(whaleNorth, 0.0);
rmSetObjectDefMaxDistance(whaleNorth, 8.0);
rmPlaceObjectDefAtLoc(whaleNorth, 0, 0.55, 0.85);
rmPlaceObjectDefAtLoc(whaleNorth, 0, 0.85, 0.8);
rmPlaceObjectDefAtLoc(whaleNorth, 0, 0.94, 0.44);
rmPlaceObjectDefAtLoc(whaleNorth, 0, 0.15, 0.45);
rmPlaceObjectDefAtLoc(whaleNorth, 0, 0.2, 0.15);
rmPlaceObjectDefAtLoc(whaleNorth, 0, 0.83, 0.17);
rmPlaceObjectDefAtLoc(whaleNorth, 0, 0.55, 0.05);

int fishcount = 10+7*cNumberNonGaiaPlayers;
for (i=0; < fishcount)
{
int fishNorth = rmCreateObjectDef("fish north"+i);
rmAddObjectDefItem(fishNorth, "FishTarpon", 1, 7.0);
rmSetObjectDefMinDistance(fishNorth, 0.0);
rmSetObjectDefMaxDistance(fishNorth, rmXFractionToMeters(0.5));
rmAddObjectDefConstraint(fishNorth, avoidFish);
rmAddObjectDefConstraint(fishNorth, avoidLand);
rmAddObjectDefConstraint(fishNorth, avoidEdge);
rmPlaceObjectDefAtLoc(fishNorth, 0,  0.51, 0.51);
}

int nuggetID= rmCreateObjectDef("nugget");
rmAddObjectDefItem(nuggetID, "Nugget", 1, 0.0);
rmSetObjectDefMinDistance(nuggetID, 0.0);
rmSetObjectDefMaxDistance(nuggetID, rmXFractionToMeters(0.5));
rmAddObjectDefConstraint(nuggetID, avoidAll);
rmAddObjectDefConstraint(nuggetID, avoidNugget);
rmAddObjectDefConstraint(nuggetID, avoidTCMedium);
rmAddObjectDefConstraint(nuggetID, avoidWater);
rmAddObjectDefConstraint(nuggetID, avoidCoinShort);
rmAddObjectDefConstraint(nuggetID, avoidImpassableLand);
rmAddObjectDefConstraint(nuggetID, avoidCliffs);
rmSetNuggetDifficulty(1, 1);
rmPlaceObjectDefAtLoc(nuggetID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2);

int nuggetIDBig= rmCreateObjectDef("nugget big");
rmAddObjectDefItem(nuggetIDBig, "Nugget", 1, 0.0);
rmSetObjectDefMinDistance(nuggetIDBig, 0.0);
rmSetObjectDefMaxDistance(nuggetIDBig, rmXFractionToMeters(0.5));
rmAddObjectDefConstraint(nuggetIDBig, avoidAll);
rmAddObjectDefConstraint(nuggetIDBig, avoidNugget);
rmAddObjectDefConstraint(nuggetIDBig, avoidTCMedium);
rmAddObjectDefConstraint(nuggetIDBig, avoidWater);
rmAddObjectDefConstraint(nuggetIDBig, avoidCoinShort);
rmAddObjectDefConstraint(nuggetIDBig, avoidImpassableLand);
rmAddObjectDefConstraint(nuggetIDBig, avoidEdge);
rmSetNuggetDifficulty(2, 2);
rmPlaceObjectDefAtLoc(nuggetIDBig, 0, 0.5, 0.5, cNumberNonGaiaPlayers*5);

// ------------------------------------------------------ KOTH ---------------------------------------------------------------------

	if(rmGetIsKOTH()) {
    
		int randLoc = rmRandInt(1,3);
		float xLoc = 0.7;
		float yLoc = 0.35;
		float walk = 0.075;

		ypKingsHillPlacer(xLoc, yLoc, walk, 0);
		rmEchoInfo("XLOC = "+xLoc);
		rmEchoInfo("XLOC = "+yLoc);
	}


}
