// RM script of Pyrenees
// For K&B mod
// By AOE_Fan

// TAD-compatible version!

include "mercenaries.xs";
include "ypAsianInclude.xs";
include "ypKOTHInclude.xs";

void main(void)
{
   // Text
   // Make the loading bar move
   rmSetStatusText("",0.01);


   // Chooses the 2 natives, Visigoths and Franks

   // Native 1
   rmSetSubCiv(0, "Comanche");

   // Native 2
   rmSetSubCiv(1, "Comanche");


   // Picks the map size
   int playerTiles = 20000;
   if (cNumberNonGaiaPlayers == 8)
	playerTiles = 14000;
   else if (cNumberNonGaiaPlayers == 7)
	playerTiles = 15000;
   else if (cNumberNonGaiaPlayers == 6)
	playerTiles = 16000;
   else if (cNumberNonGaiaPlayers == 5)
	playerTiles = 17000;
   else if (cNumberNonGaiaPlayers == 4)
	playerTiles = 18000;
   else if (cNumberNonGaiaPlayers == 3)
	playerTiles = 19000;

   int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
   rmSetMapSize(size, size);


   // Set map the map smoothness
   rmSetMapElevationHeightBlend(1);


   // Chooses where the mountain pass is - 1 = NW, 2 = Middle, 3 = SE
   int passLocation = rmRandInt(1,3);


   // Picks a default water height
   rmSetSeaLevel(0.0);


   // Pick lighting
   rmSetLightingSet("Rockies");


   // Picks default terrain and map type
   rmSetMapElevationParameters(cElevTurbulence, 0.2, 4, 0.3, 7.0);
   rmTerrainInitialize("rockies\ground4_roc", 0.0);
   rmSetMapType("grass");
   rmSetMapType("land");
   rmSetMapType("greatPlains");
   

   chooseMercs();


   // Corner constraint
   rmSetWorldCircleConstraint(true);


   // Define classes, these are used for constraints
   int classPlayer=rmDefineClass("player");
   int classAnimals=rmDefineClass("animals");
   int classMines=rmDefineClass("mines");
   rmDefineClass("startingUnit");
   rmDefineClass("nuggets");
   rmDefineClass("classMountain");
   rmDefineClass("classTerrain");
   rmDefineClass("classForest");
   rmDefineClass("classTreeStraggler");
   rmDefineClass("natives");


   // Define constraints - used for things to avoid certain things
   
   // Map edge and centre constraints
   int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));

   // All player things avoidance
   int veryLongPlayerConstraint=rmCreateClassDistanceConstraint("nuggets stay away from players very long", classPlayer, 70.0);
   int longPlayerConstraint=rmCreateClassDistanceConstraint("nuggets stay away from players long", classPlayer, 55.0);
   int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 45.0);
   int mediumPlayerConstraint=rmCreateClassDistanceConstraint("nuggets stay away from players medium", classPlayer, 40.0);
   int somePlayerConstraint=rmCreateClassDistanceConstraint("things stay away from players", classPlayer, 30.0);
   int shortPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players short", classPlayer, 20.0);
   int shortAvoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units short", rmClassID("startingUnit"), 10.0);

   // All resource avoidance
   int avoidMines=rmCreateClassDistanceConstraint("avoid mines", classMines, 80.0);
   int avoidStartResource=rmCreateTypeDistanceConstraint("start resource no overlap", "resource", 10.0);
   int animalConstraint=rmCreateClassDistanceConstraint("avoid all animals", classAnimals, 65.0);
   int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 40.0);
   int shortForestConstraint=rmCreateClassDistanceConstraint("forest vs. forest short", rmClassID("classForest"), 10.0);
   int stragglerTreeConstraint=rmCreateClassDistanceConstraint("straggler tree constraint", rmClassID("classTreeStraggler"), 20.0);

   // Terrain avoidance
   int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 8.0);
   int avoidImpassableLandLong=rmCreateTerrainDistanceConstraint("avoid impassable land long", "Land", false, 15.0);

   // Area avoidance
   int avoidMountain=rmCreateClassDistanceConstraint("avoid mountain peaks", rmClassID("classMountain"), 25.0);
   int avoidTerrain=rmCreateClassDistanceConstraint("avoid mountain terrain", rmClassID("classTerrain"), 5.0);

   // Nuggets avoidance
   int avoidNuggets=rmCreateClassDistanceConstraint("stuff avoids nuggets", rmClassID("nuggets"), 60.0);

   // Native avoidance
   int avoidNatives=rmCreateClassDistanceConstraint("things avoids natives", rmClassID("natives"), 5.0);

   // Decoration avoidance
   int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 5.0);


   // Text
   rmSetStatusText("",0.10);


   // Place players - in team and FFA games

   // Player placement if FFA (Free For All) OR two player game - manual placement
   if(cNumberTeams > 2 || cNumberNonGaiaPlayers == 2)
   {
      if (cNumberNonGaiaPlayers == 2)
      {
            rmPlacePlayer(1, 0.85, 0.5);
            rmPlacePlayer(2, 0.15, 0.5);
      }
      if (cNumberNonGaiaPlayers == 3)
      {
            rmPlacePlayer(1, 0.8, 0.8);
            rmPlacePlayer(2, 0.8, 0.2);
            rmPlacePlayer(3, 0.15, 0.5);
      }
      if (cNumberNonGaiaPlayers == 4)
      {
            rmPlacePlayer(1, 0.8, 0.8);
            rmPlacePlayer(2, 0.8, 0.2);
            rmPlacePlayer(3, 0.2, 0.8);
            rmPlacePlayer(4, 0.2, 0.2);
      }
      if (cNumberNonGaiaPlayers == 5)
      {
            rmPlacePlayer(1, 0.8, 0.8);
            rmPlacePlayer(2, 0.8, 0.2);
            rmPlacePlayer(3, 0.2, 0.8);
            rmPlacePlayer(4, 0.2, 0.2);
            rmPlacePlayer(5, 0.9, 0.5);
      }
      if (cNumberNonGaiaPlayers == 6)
      {
            rmPlacePlayer(1, 0.8, 0.8);
            rmPlacePlayer(2, 0.8, 0.2);
            rmPlacePlayer(3, 0.2, 0.8);
            rmPlacePlayer(4, 0.2, 0.2);
            rmPlacePlayer(5, 0.9, 0.5);
            rmPlacePlayer(6, 0.1, 0.5);
      }
      if (cNumberNonGaiaPlayers == 7)
      {
            rmPlacePlayer(1, 0.7, 0.85);
            rmPlacePlayer(2, 0.7, 0.15);
            rmPlacePlayer(3, 0.3, 0.85);
            rmPlacePlayer(4, 0.3, 0.15);
            rmPlacePlayer(5, 0.85, 0.35);
            rmPlacePlayer(6, 0.15, 0.65);
            rmPlacePlayer(7, 0.85, 0.65);
      }
      if (cNumberNonGaiaPlayers == 8)
      {
            rmPlacePlayer(1, 0.7, 0.85);
            rmPlacePlayer(2, 0.7, 0.15);
            rmPlacePlayer(3, 0.3, 0.85);
            rmPlacePlayer(4, 0.3, 0.15);
            rmPlacePlayer(5, 0.85, 0.35);
            rmPlacePlayer(6, 0.15, 0.65);
            rmPlacePlayer(7, 0.85, 0.65);
            rmPlacePlayer(8, 0.15, 0.35);
      }
   }

   // Player placement if teams - place both teams in their own "sides"
   if(cNumberTeams == 2 && cNumberNonGaiaPlayers >= 3)
   {
      rmSetPlacementTeam(0);
      rmSetPlacementSection(0.15, 0.35);
      rmPlacePlayersCircular(0.39, 0.40, 0.0);

      rmSetPlacementTeam(1);
      rmSetPlacementSection(0.65, 0.85);
      rmPlacePlayersCircular(0.39, 0.40, 0.0);
   }


   // Text
   rmSetStatusText("",0.20);

   // Define and place player area
   float playerFraction=rmAreaTilesToFraction(100);
   for(i=1; <cNumberPlayers)
   {
      int id=rmCreateArea("Player"+i);
      rmSetPlayerArea(i, id);
      rmSetAreaSize(id, playerFraction, playerFraction);
      rmAddAreaToClass(id, classPlayer);
      rmSetAreaBaseHeight(id, 1);
      rmSetAreaMinBlobs(id, 1);
      rmSetAreaMaxBlobs(id, 1);
      rmAddAreaConstraint(id, playerConstraint); 
      rmAddAreaConstraint(id, avoidImpassableLand); 
      rmSetAreaCoherence(id, 0.9);
      rmSetAreaLocPlayer(id, i);
      rmSetAreaWarnFailure(id, false);
   }


   // Build the areas.
   rmBuildAllAreas();


   // Text
   rmSetStatusText("",0.30);


   // Define starting objects and resources

   int startingTCID=rmCreateObjectDef("startingTC");
   if (rmGetNomadStart())
      rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 5.0);
   else
      rmAddObjectDefItem(startingTCID, "townCenter", 1, 5.0);
   rmAddObjectDefConstraint(startingTCID, avoidImpassableLand);
   rmAddObjectDefToClass(startingTCID, classPlayer);

   int startingUnits=rmCreateStartingUnitsObjectDef(5.0);
   rmSetObjectDefMinDistance(startingUnits, 5.0);
   rmSetObjectDefMaxDistance(startingUnits, 10.0);
   rmAddObjectDefToClass(startingUnits, rmClassID("startingUnit"));

   int startTreeID=rmCreateObjectDef("starting trees");
   rmAddObjectDefItem(startTreeID, "TreeMadrone", 6, 4.0);
   rmSetObjectDefMinDistance(startTreeID, 16);
   rmSetObjectDefMaxDistance(startTreeID, 20);
   rmAddObjectDefConstraint(startTreeID, avoidStartResource);
   rmAddObjectDefConstraint(startTreeID, avoidImpassableLand);
   rmAddObjectDefConstraint(startTreeID, shortAvoidStartingUnits);

   int startIbexID=rmCreateObjectDef("starting ibex");
   rmAddObjectDefItem(startIbexID, "ypIbex", 6, 4.0);
   rmSetObjectDefCreateHerd(startIbexID, true);
   rmSetObjectDefMinDistance(startIbexID, 14);
   rmSetObjectDefMaxDistance(startIbexID, 20);
   rmAddObjectDefConstraint(startIbexID, avoidStartResource);
   rmAddObjectDefConstraint(startIbexID, avoidImpassableLand);
   rmAddObjectDefConstraint(startIbexID, shortAvoidStartingUnits);

   int startCopperID=rmCreateObjectDef("player copper");
   rmAddObjectDefItem(startCopperID, "MineCopper", 1, 5.0);
   rmSetObjectDefMinDistance(startCopperID, 14);
   rmSetObjectDefMaxDistance(startCopperID, 20);
   rmAddObjectDefConstraint(startCopperID, avoidStartResource);
   rmAddObjectDefConstraint(startCopperID, avoidImpassableLand);
   rmAddObjectDefConstraint(startCopperID, shortAvoidStartingUnits);

   // Place starting objects and resources

   for(i=1; <cNumberPlayers)
   {					
      // Place starting objects and resources
      rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
      rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	  if(ypIsAsian(i) && rmGetNomadStart() == false)
         rmPlaceObjectDefAtLoc(ypMonasteryBuilder(i, 1), i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
      rmPlaceObjectDefAtLoc(startTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
      rmPlaceObjectDefAtLoc(startCopperID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
      rmPlaceObjectDefAtLoc(startIbexID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
   }


   // Text
   rmSetStatusText("",0.40);


   // Define and place mountains dividing the map

   // Define different sizes of mountains - scales with the size of map
   int radius = size * 0.5;
   int mountainMixSize = radius * 90.0;
   int mountainTerrainSize = radius * 60.0;
   int mountainPeaksSizeShort = radius * 3.0;
   int mountainPeaksSize = radius * 5.0;
   int mountainPeaksSizeLong = radius * 7.0;
   int mountainTreesSize = radius * 10.0;

   // Define and place mountain mix - softenes the area between the snowy mountain terrain and green base terrain
   int mountainMixID = rmCreateArea("mountain Mix"); 
   rmSetAreaSize(mountainMixID, rmAreaTilesToFraction(mountainMixSize), rmAreaTilesToFraction(mountainMixSize));
   rmSetAreaLocation(mountainMixID, 0.5, 0.5); 
   rmAddAreaInfluenceSegment(mountainMixID, 0.5, 0.0, 0.5, 1.0); 
   rmSetAreaCoherence(mountainMixID, 0.8);
   rmSetAreaSmoothDistance(mountainMixID, 10);
   rmSetAreaBaseHeight(mountainMixID, 2.0);
   rmSetAreaHeightBlend(mountainMixID, 2);
   rmSetAreaWarnFailure(mountainMixID, false);
   rmSetAreaMix(mountainMixID, "rockies_snow");
   rmBuildArea(mountainMixID);

   // Define and place mountain terrain - snowy in middle, more green in edges
   int mountainTerrainID = rmCreateArea("mountain terrain"); 
   rmSetAreaSize(mountainTerrainID, rmAreaTilesToFraction(mountainTerrainSize), rmAreaTilesToFraction(mountainTerrainSize));
   rmAddAreaToClass(mountainTerrainID, rmClassID("classTerrain"));
   rmSetAreaLocation(mountainTerrainID, 0.5, 0.5); 
   rmAddAreaInfluenceSegment(mountainTerrainID, 0.5, 0.0, 0.5, 1.0); 
   rmSetAreaCoherence(mountainTerrainID, 0.8);
   rmSetAreaSmoothDistance(mountainTerrainID, 10);
   rmSetAreaBaseHeight(mountainTerrainID, 5.0);
   rmSetAreaElevationType(mountainTerrainID, cElevTurbulence);
   rmSetAreaElevationVariation(mountainTerrainID, 3);
   rmSetAreaHeightBlend(mountainTerrainID, 1);
   rmSetAreaWarnFailure(mountainTerrainID, false);
   rmSetAreaTerrainType(mountainTerrainID, "patagonia\ground_snow1_pat");
   rmAddAreaTerrainLayer(mountainTerrainID, "patagonia\ground_snow1_pat", 11, 15);
   rmAddAreaTerrainLayer(mountainTerrainID, "rockies\groundsnow6_roc", 7, 11);
   rmAddAreaTerrainLayer(mountainTerrainID, "rockies\groundsnow7_roc", 3, 7);
   rmAddAreaTerrainLayer(mountainTerrainID, "rockies\groundsnow8_roc", 0, 3);
   rmBuildArea(mountainTerrainID);


   // Text
   rmSetStatusText("",0.50);

		
		rmDefineClass("classPlateau");

   // Define and place south mountain peaks
   int mountainPeaksSID = rmCreateArea("mountain peaks south");
   rmAddAreaToClass(mountainPeaksSID, rmClassID("classPlateau"));
   if (passLocation == 1)
      rmSetAreaSize(mountainPeaksSID, rmAreaTilesToFraction(mountainPeaksSizeLong), rmAreaTilesToFraction(mountainPeaksSizeLong));
   else if (passLocation == 2)
      rmSetAreaSize(mountainPeaksSID, rmAreaTilesToFraction(mountainPeaksSize), rmAreaTilesToFraction(mountainPeaksSize));
   else if (passLocation == 3)
      rmSetAreaSize(mountainPeaksSID, rmAreaTilesToFraction(mountainPeaksSizeShort), rmAreaTilesToFraction(mountainPeaksSizeShort));
   rmAddAreaToClass(mountainPeaksSID, rmClassID("classMountain"));
   rmSetAreaLocation(mountainPeaksSID, 0.5, 0.25);
   if (passLocation == 1)
      rmAddAreaInfluenceSegment(mountainPeaksSID, 0.5, 0.0, 0.5, 0.5);
   else if (passLocation == 2)
      rmAddAreaInfluenceSegment(mountainPeaksSID, 0.5, 0.0, 0.5, 0.4);
   else if (passLocation == 3)
      rmAddAreaInfluenceSegment(mountainPeaksSID, 0.5, 0.0, 0.5, 0.3);
   rmSetAreaCoherence(mountainPeaksSID, 0.8); 
   rmSetAreaSmoothDistance(mountainPeaksSID, 5);
   rmSetAreaBaseHeight(mountainPeaksSID, 17);
   rmSetAreaElevationType(mountainPeaksSID, cElevTurbulence);
   rmSetAreaElevationVariation(mountainPeaksSID, 9.0);
   rmSetAreaHeightBlend(mountainPeaksSID, 1);
   rmSetAreaWarnFailure(mountainPeaksSID, false);
   rmSetAreaTerrainType(mountainPeaksSID, "patagonia\ground_snow1_pat");
   rmBuildArea(mountainPeaksSID);


   // Define and place north mountain peaks
   int mountainPeaksNID = rmCreateArea("mountain peaks north");
      rmAddAreaToClass(mountainPeaksNID, rmClassID("classPlateau"));
   if (passLocation == 1)
      rmSetAreaSize(mountainPeaksNID, rmAreaTilesToFraction(mountainPeaksSizeShort), rmAreaTilesToFraction(mountainPeaksSizeShort));
   else if (passLocation == 2)
      rmSetAreaSize(mountainPeaksNID, rmAreaTilesToFraction(mountainPeaksSize), rmAreaTilesToFraction(mountainPeaksSize));
   else if (passLocation == 3)
      rmSetAreaSize(mountainPeaksNID, rmAreaTilesToFraction(mountainPeaksSizeLong), rmAreaTilesToFraction(mountainPeaksSizeLong));
   rmAddAreaToClass(mountainPeaksNID, rmClassID("classMountain"));
   rmAddAreaConstraint(mountainPeaksNID, avoidMountain);
   rmSetAreaLocation(mountainPeaksNID, 0.5, 0.75);  
   if (passLocation == 1)    
      rmAddAreaInfluenceSegment(mountainPeaksNID, 0.5, 1.0, 0.5, 0.7); 
   else if (passLocation == 2)
      rmAddAreaInfluenceSegment(mountainPeaksNID, 0.5, 1.0, 0.5, 0.6); 
   else if (passLocation == 3)
      rmAddAreaInfluenceSegment(mountainPeaksNID, 0.5, 1.0, 0.5, 0.5); 
   rmSetAreaCoherence(mountainPeaksNID, 0.8); 
   rmSetAreaSmoothDistance(mountainPeaksNID, 5);
   rmSetAreaBaseHeight(mountainPeaksNID, 17);
   rmSetAreaElevationType(mountainPeaksNID, cElevTurbulence);
   rmSetAreaElevationVariation(mountainPeaksNID, 9.0);
   rmSetAreaHeightBlend(mountainPeaksNID, 1);
   rmSetAreaWarnFailure(mountainPeaksNID, false);
   rmSetAreaTerrainType(mountainPeaksNID, "patagonia\ground_snow1_pat");
   rmBuildArea(mountainPeaksNID);


   // Text
   rmSetStatusText("",0.60);


   // Define and place southern fir forests near mountains
   int mountainTreesSID = rmCreateArea("mountain trees S"); 
   rmSetAreaSize(mountainTreesSID, rmAreaTilesToFraction(mountainTreesSize), rmAreaTilesToFraction(mountainTreesSize));
   if (cNumberNonGaiaPlayers < 6)
   {
      rmSetAreaLocation(mountainTreesSID, 0.4, 0.5); 
      rmAddAreaInfluenceSegment(mountainTreesSID, 0.4, 0.0, 0.4, 1.0); 
   }
   else if (cNumberNonGaiaPlayers >= 6)
   {
      rmSetAreaLocation(mountainTreesSID, 0.42, 0.5); 
      rmAddAreaInfluenceSegment(mountainTreesSID, 0.42, 0.0, 0.42, 1.0); 
   }
   else if (cNumberNonGaiaPlayers == 8)
   {
      rmSetAreaLocation(mountainTreesSID, 0.45, 0.5); 
      rmAddAreaInfluenceSegment(mountainTreesSID, 0.45, 0.0, 0.45, 1.0); 
   }
   rmSetAreaCoherence(mountainTreesSID, 0.8);
   rmSetAreaSmoothDistance(mountainTreesSID, 10);
   rmSetAreaBaseHeight(mountainTreesSID, 3.0);
   rmSetAreaHeightBlend(mountainTreesSID, 2);
   rmSetAreaWarnFailure(mountainTreesSID, false);
   rmSetAreaForestType(mountainTreesSID, "Himalayas Forest");
   rmAddAreaToClass(mountainTreesSID, rmClassID("classForest"));
   rmSetAreaForestDensity(mountainTreesSID, 0.9);
   rmSetAreaForestClumpiness(mountainTreesSID, 0.9);
   rmBuildArea(mountainTreesSID);

   // Define and place northern fir forests near mountains
   int mountainTreesNID = rmCreateArea("mountain trees N"); 
   rmSetAreaSize(mountainTreesNID, rmAreaTilesToFraction(mountainTreesSize), rmAreaTilesToFraction(mountainTreesSize));
   if (cNumberNonGaiaPlayers < 6)
   {
      rmSetAreaLocation(mountainTreesNID, 0.6, 0.5); 
      rmAddAreaInfluenceSegment(mountainTreesNID, 0.6, 0.0, 0.6, 1.0);
   }
   else if (cNumberNonGaiaPlayers >= 6)
   { 
      rmSetAreaLocation(mountainTreesNID, 0.58, 0.5); 
      rmAddAreaInfluenceSegment(mountainTreesNID, 0.58, 0.0, 0.58, 1.0);
   }
   else if (cNumberNonGaiaPlayers == 8)
   { 
      rmSetAreaLocation(mountainTreesNID, 0.55, 0.5); 
      rmAddAreaInfluenceSegment(mountainTreesNID, 0.55, 0.0, 0.55, 1.0);
   }
   rmSetAreaCoherence(mountainTreesNID, 0.8);
   rmSetAreaSmoothDistance(mountainTreesNID, 10);
   rmSetAreaBaseHeight(mountainTreesNID, 2.0);
   rmSetAreaHeightBlend(mountainTreesNID, 2);
   rmSetAreaWarnFailure(mountainTreesNID, false);
   rmSetAreaForestType(mountainTreesNID, "Himalayas Forest");
   rmAddAreaToClass(mountainTreesNID, rmClassID("classForest"));
   rmSetAreaForestDensity(mountainTreesNID, 0.9);
   rmSetAreaForestClumpiness(mountainTreesNID, 0.9);
   rmBuildArea(mountainTreesNID);


   // Text
   rmSetStatusText("",0.70);


   // Define and place the 2 natives, Visigoths and Franks

   // Visigoths, to south-western side
   int nativeVillageType = rmRandInt(1,5);
   int nativeVillageID = rmCreateGrouping("visigoths village", "native comanche village "+nativeVillageType);
   rmSetGroupingMinDistance(nativeVillageID, 0.0);
   rmSetGroupingMaxDistance(nativeVillageID, 10.0);
   rmAddGroupingToClass(nativeVillageID, rmClassID("natives"));
   rmPlaceGroupingAtLoc(nativeVillageID, 0, 0.3, 0.5);

   // Franks, to north-eastern side
   int nativeVillage2Type = rmRandInt(1,5);
   int nativeVillage2ID = rmCreateGrouping("franks village", "native comanche village "+nativeVillage2Type);
   rmSetGroupingMinDistance(nativeVillage2ID, 0.0);
   rmSetGroupingMaxDistance(nativeVillage2ID, 10.0);
   rmAddGroupingToClass(nativeVillage2ID, rmClassID("natives"));
   rmPlaceGroupingAtLoc(nativeVillage2ID, 0, 0.7, 0.5);


   // Define and place forests

   int numTries=10*cNumberNonGaiaPlayers;
   int failCount=0;
   for (i=0; <numTries)
   {   
      int forest=rmCreateArea("forest"+i);
      rmSetAreaWarnFailure(forest, false);
      rmSetAreaSize(forest, rmAreaTilesToFraction(150), rmAreaTilesToFraction(200));
      rmSetAreaForestType(forest, "california madrone forest");
      rmSetAreaForestDensity(forest, 0.9);
      rmAddAreaToClass(forest, rmClassID("classForest"));
      rmSetAreaForestClumpiness(forest, 0.8);
      rmSetAreaForestUnderbrush(forest, 0.2);
      rmSetAreaBaseHeight(forest, 1.0);
      rmSetAreaCoherence(forest, 0.4);
      rmSetAreaSmoothDistance(forest, 1);
      rmAddAreaConstraint(forest, avoidImpassableLand);
      rmAddAreaConstraint(forest, avoidTerrain);
      rmAddAreaConstraint(forest, somePlayerConstraint);
      rmAddAreaConstraint(forest, forestConstraint);
      rmAddAreaConstraint(forest, avoidNatives);
      if(rmBuildArea(forest)==false)
      {
            // Stop trying once we fail 5 times in a row.  
            failCount++;
            if(failCount==5)
                        break;
      }
      else
                        failCount=0; 
   }


   // Define and place straggler trees
   for (i=0; < 40)
   { 
      int stragglerTreeID=rmCreateObjectDef("straggler tree madrone"+i);
      rmAddObjectDefItem(stragglerTreeID, "TreeMadrone", rmRandInt(1,5), 10.0);
      rmSetObjectDefMinDistance(stragglerTreeID, 0.0);
      rmSetObjectDefMaxDistance(stragglerTreeID, rmZFractionToMeters(0.47));
      rmAddObjectDefToClass(stragglerTreeID, rmClassID("classForest"));
      rmAddObjectDefToClass(stragglerTreeID, rmClassID("classTreeStraggler"));
      rmAddObjectDefConstraint(stragglerTreeID, somePlayerConstraint);
      rmAddObjectDefConstraint(stragglerTreeID, avoidImpassableLand);
      rmAddObjectDefConstraint(stragglerTreeID, shortForestConstraint);
      rmAddObjectDefConstraint(stragglerTreeID, stragglerTreeConstraint);
      rmAddObjectDefConstraint(stragglerTreeID, avoidNatives);
      rmAddObjectDefConstraint(stragglerTreeID, avoidTerrain);
      rmPlaceObjectDefAtLoc(stragglerTreeID, 0, 0.5, 0.5);
   }


   // Text
   rmSetStatusText("",0.80);


		//============================================================================================\\
		//==================================== BEGIN QUICKBALANCE ====================================\\
		//====================================== qB By Durokan =======================================\\
		//============================================================================================\\
		int quickBalanceCircle=rmCreatePieConstraint("quickBalance circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.48), rmDegreesToRadians(0), rmDegreesToRadians(360));
		int quickBalanceAvoidWaterShort = rmCreateTerrainDistanceConstraint("quickBalance avoid water short", "Land", false, 6.0);
		int quickBalanceAvoidTradeRouteSmall = rmCreateTradeRouteDistanceConstraint("quickBalance objects avoid trade route small", 4.0);
		int quickBalanceAvoidTownCenter=rmCreateTypeDistanceConstraint("quickBalance avoid Town Center", "townCenter", 35.0);
		int quickBalanceavoidPlateau=rmCreateClassDistanceConstraint("stuff vs. cliffs", rmClassID("classPlateau"), 5.0);

		//=========== HUNTS ===========

		int huntRows = 0;
		float huntX = 0.0; 
		float huntXmod = 0.1;
	
		for (huntRows = 0; < (5)) {  
		int qBmainHunts=rmCreateObjectDef("qBhunts"+huntRows);
		rmAddObjectDefItem(qBmainHunts, "ypIbex", rmRandInt(8,8), 10.0);
		rmSetObjectDefCreateHerd(qBmainHunts, true);
		rmSetObjectDefMinDistance(qBmainHunts, 0);
		rmSetObjectDefMaxDistance(qBmainHunts, 16);
		rmAddObjectDefConstraint(qBmainHunts, quickBalanceAvoidWaterShort);
		rmAddObjectDefConstraint(qBmainHunts, quickBalanceAvoidTownCenter);
		rmAddObjectDefConstraint(qBmainHunts, quickBalanceCircle);
		rmAddObjectDefConstraint(qBmainHunts, quickBalanceavoidPlateau);
		if(cNumberNonGaiaPlayers >5){
		rmPlaceObjectDefAtLoc(qBmainHunts, 0, huntX, .15, 1);
		rmPlaceObjectDefAtLoc(qBmainHunts, 0, huntXmod, .29, 1);
		rmPlaceObjectDefAtLoc(qBmainHunts, 0, huntX, .43, 1);
		rmPlaceObjectDefAtLoc(qBmainHunts, 0, huntXmod, .57, 1);
		rmPlaceObjectDefAtLoc(qBmainHunts, 0, huntX, .71, 1);
		rmPlaceObjectDefAtLoc(qBmainHunts, 0, huntXmod, .85, 1);
		rmPlaceObjectDefAtLoc(qBmainHunts, 0, huntX, .99, 1);
		}else{
		rmPlaceObjectDefAtLoc(qBmainHunts, 0, huntX, .1, 1);
		rmPlaceObjectDefAtLoc(qBmainHunts, 0, huntXmod, .3, 1);
		rmPlaceObjectDefAtLoc(qBmainHunts, 0, huntX, .5, 1);
		rmPlaceObjectDefAtLoc(qBmainHunts, 0, huntXmod, .7, 1);
		rmPlaceObjectDefAtLoc(qBmainHunts, 0, huntX, .9, 1);
		}
		huntX = huntX + .25;
		huntXmod = huntXmod + .25;
		}
		
		//=========== GOLD ===========

		int goldRows = 0;
		float goldZ = 0.0;
		float goldZmod = 0.1;
	
		for (goldRows = 0; < (5)) {  
		int qBmines=rmCreateObjectDef("qBmines"+goldRows);
		rmSetObjectDefMinDistance(qBmines, 0);
		rmSetObjectDefMaxDistance(qBmines, 18);
		rmAddObjectDefConstraint(qBmines, quickBalanceAvoidTownCenter);
		rmAddObjectDefConstraint(qBmines, quickBalanceAvoidWaterShort);
		rmAddObjectDefConstraint(qBmines, quickBalanceCircle);
		rmAddObjectDefConstraint(qBmines, quickBalanceavoidPlateau);
		rmAddObjectDefItem(qBmines, "mine", 1, 0);

		if(cNumberNonGaiaPlayers > 5){
		rmPlaceObjectDefAtLoc(qBmines, 0, .15, goldZ, 1);
		rmPlaceObjectDefAtLoc(qBmines, 0, .29, goldZmod, 1);
		rmPlaceObjectDefAtLoc(qBmines, 0, .43, goldZ, 1);
		rmPlaceObjectDefAtLoc(qBmines, 0, .57, goldZmod, 1);
		rmPlaceObjectDefAtLoc(qBmines, 0, .71, goldZ, 1);
		rmPlaceObjectDefAtLoc(qBmines, 0, .85, goldZmod, 1);
		rmPlaceObjectDefAtLoc(qBmines, 0, .99, goldZ, 1);
		}else{
		rmPlaceObjectDefAtLoc(qBmines, 0, .1, goldZ, 1);
		rmPlaceObjectDefAtLoc(qBmines, 0, .3, goldZmod, 1);
		rmPlaceObjectDefAtLoc(qBmines, 0, .5, goldZ, 1);
		rmPlaceObjectDefAtLoc(qBmines, 0, .7, goldZmod, 1);
		rmPlaceObjectDefAtLoc(qBmines, 0, .9, goldZ, 1);
		}
		goldZ = goldZ + .25;
		goldZmod = goldZmod + .25;
		}

		int nuggetRows = 0;
		float nuggetX = 0.5;
		float nuggetZ = 0.0;
		float nuggetZmod = 0.1;
		float nuggetXmod = 0.1;

		//=========== TREASURES ===========
		for (nuggetRows = 0; < (5)) {  
		int qBtreasures=rmCreateObjectDef("qBtreasures"+nuggetRows);
        rmAddObjectDefItem(qBtreasures, "Nugget", 1, 0.0);
		rmSetObjectDefMinDistance(qBtreasures, 0);
		rmSetObjectDefMaxDistance(qBtreasures, 20);
		rmSetNuggetDifficulty(1, 2);
		rmAddObjectDefConstraint(qBtreasures, quickBalanceAvoidWaterShort);
		rmAddObjectDefConstraint(qBtreasures, quickBalanceCircle);
		rmAddObjectDefConstraint(qBtreasures, quickBalanceavoidPlateau);

		if(cNumberNonGaiaPlayers >5){
		rmPlaceObjectDefAtLoc(qBtreasures, 0, .15, nuggetZmod, 1);
		rmPlaceObjectDefAtLoc(qBtreasures, 0, .29, nuggetZ, 1);
		rmPlaceObjectDefAtLoc(qBtreasures, 0, .43, nuggetZmod, 1);
		rmPlaceObjectDefAtLoc(qBtreasures, 0, .57, nuggetZ, 1);
		rmPlaceObjectDefAtLoc(qBtreasures, 0, .71, nuggetZmod, 1);
		rmPlaceObjectDefAtLoc(qBtreasures, 0, .85, nuggetZ, 1);
		rmPlaceObjectDefAtLoc(qBtreasures, 0, .99, nuggetZmod, 1);
		}else{
		rmPlaceObjectDefAtLoc(qBtreasures, 0, .1, nuggetZmod, 1);
		rmPlaceObjectDefAtLoc(qBtreasures, 0, .3, nuggetZ, 1);
		rmPlaceObjectDefAtLoc(qBtreasures, 0, .5, nuggetZmod, 1);
		rmPlaceObjectDefAtLoc(qBtreasures, 0, .7, nuggetZ, 1);
		rmPlaceObjectDefAtLoc(qBtreasures, 0, .9, nuggetZmod, 1);
		}
		
		nuggetZ = nuggetZ + .2;
		nuggetX = nuggetX + .2;
		nuggetZmod = nuggetZmod + .2;
		nuggetXmod = nuggetXmod + .2;
		}		
		//============================================================================================\\
		//===================================== END QUICKBALANCE =====================================\\
		//============================================================================================
   // Text
   rmSetStatusText("",1.0);
}  
