// ***********************************************************************************************************************************************
// ****************************************************** M E N D O C I N O **********************************************************************
// ***********************************************************************************************************************************************

// ------------------------------------------------------ Comentaries ---------------------------------------------------------------------------
// For Treaty Patch
// Work done by Rikikipu - September 2016
// Idea: Charlemagen


// ------------------------------------------------------ Starting the OP UI --------------------------------------------------------------------

// No  UI in this version


// ------------------------------------------------------ Initialization ------------------------------------------------------------------------
include "mercenaries.xs";
include "ypAsianInclude.xs";
include "ypKOTHInclude.xs";

void main(void)
{
   rmSetStatusText("",0.01);

   int playerTiles=12000;
   if (cNumberNonGaiaPlayers >2)
		playerTiles = 10850;
   if (cNumberNonGaiaPlayers >4)
      playerTiles = 8500;

	int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
	rmSetMapSize(size, size);
	rmSetSeaLevel(0.0);
	rmSetMapElevationParameters(cElevTurbulence, 0.06, 2, 0.1, 5.0);
	rmSetBaseTerrainMix("california_a");
	rmTerrainInitialize("california\fakecalifgrassmix2_cal", 5);
	rmSetLightingSet("california");
	rmSetMapType("california");
	rmSetMapType("land");
	rmSetWorldCircleConstraint(true);
	rmSetMapType("grass");

   int subCiv0=-1;
   int subCiv1=-1;
   int subCiv2=-1;
   int subCiv3=-1;
   if (rmAllocateSubCivs(2) == true)
   {
		subCiv0=rmGetCivID("Nootka");
		rmEchoInfo("subCiv0 is Nootka "+subCiv0);
		if (subCiv0 >= 0)
			rmSetSubCiv(0, "Nootka");

		subCiv1=rmGetCivID("Nootka");
		rmEchoInfo("subCiv1 is Nootka "+subCiv1);
		if (subCiv1 >= 0)
			rmSetSubCiv(1, "Nootka");
                subCiv2=rmGetCivID("Nootka");
		rmEchoInfo("subCiv2 is Nootka "+subCiv2);
   }
   int numTries = -1;
   int failCount = -1;

	chooseMercs();


// ------------------------------------------------------ Contraints ---------------------------------------------------------------------------
	int classPlayer=rmDefineClass("player");
	rmDefineClass("classPatch");
	rmDefineClass("starting settlement");
	rmDefineClass("startingUnit");
	rmDefineClass("classForest");
	rmDefineClass("importantItem");
	rmDefineClass("secrets");
	rmDefineClass("natives");	
	rmDefineClass("socketClass");
	rmDefineClass("nuggets");
        rmDefineClass("classCliff");
	int pondClass=rmDefineClass("pond");

   
   // Map edge constraints
   int avoidCenter = rmCreatePieConstraint("Avoid Center",0.5,0.5, rmXFractionToMeters(0.03),rmXFractionToMeters(0.5), rmDegreesToRadians(0),rmDegreesToRadians(360));
   int avoidEdgeGold = rmCreatePieConstraint("Avoid Edge1",0.5,0.5, rmXFractionToMeters(0.23),rmXFractionToMeters(0.48), rmDegreesToRadians(0),rmDegreesToRadians(360));

   // For Gold
   int stayNE = rmCreatePieConstraint("stay NE",0.5,0.5, rmXFractionToMeters(0.3),rmXFractionToMeters(0.47), rmDegreesToRadians(45),rmDegreesToRadians(145));
   int staySW = rmCreatePieConstraint("stay SW",0.5,0.5, rmXFractionToMeters(0.3),rmXFractionToMeters(0.47), rmDegreesToRadians(225),rmDegreesToRadians(325));
   int stayNE1 = rmCreatePieConstraint("stay NE1",0.5,0.5, rmXFractionToMeters(0.24),rmXFractionToMeters(0.48), rmDegreesToRadians(55),rmDegreesToRadians(140));
   int staySW1 = rmCreatePieConstraint("stay SW1",0.5,0.5, rmXFractionToMeters(0.24),rmXFractionToMeters(0.48), rmDegreesToRadians(235),rmDegreesToRadians(320));
// X marks the spot

   int avoidCenterGold3 = rmCreatePieConstraint("Avoid Center gold 3",0.5,0.5, rmXFractionToMeters(0.43),rmXFractionToMeters(0.48), rmDegreesToRadians(0),rmDegreesToRadians(360));
   // Player constraints
   int playerConstraint=rmCreateClassDistanceConstraint("player vs. player", classPlayer, 10.0);
   int nuggetPlayerConstraint=rmCreateClassDistanceConstraint("nuggets stay away from players a lot", rmClassID("startingUnit"), 50.0);

   // Resource avoidance
   int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 25.0);
   int coinForestConstraint=rmCreateClassDistanceConstraint("coin vs. forest", rmClassID("classForest"), 15.0);
   int avoidDeer=rmCreateTypeDistanceConstraint("Deer avoids food", "Deer", 50.0);
   int avoidDeerPond=rmCreateTypeDistanceConstraint("Deer avoids food1", "Deer", 10.0);
   int avoidElk=rmCreateTypeDistanceConstraint("Elk avoids food", "Elk", 50.0);
   int avoidElkShort=rmCreateTypeDistanceConstraint("Elk avoids food short", "Elk", 15.0);
   int avoidCoin=rmCreateTypeDistanceConstraint("coin avoids coin", "gold", 35.0);
   int avoidCoinPond=rmCreateTypeDistanceConstraint("pond avoids coin", "gold", 12.0);
   int avoidCoinShort=rmCreateTypeDistanceConstraint("avoids coin short", "gold", 8.0);
   int avoidStartingCoin=rmCreateTypeDistanceConstraint("starting coin avoids coin", "gold", 28.0);
   int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "AbstractNugget", 43.0);
   int avoidNuggetSmall=rmCreateTypeDistanceConstraint("avoid nuggets by a little", "AbstractNugget", 6.0);
   int avoidNuggetSmall1=rmCreateTypeDistanceConstraint("avoid nuggets by a little1", "AbstractNugget", 8.0);
   int avoidFastCoin=rmCreateTypeDistanceConstraint("fast coin avoids coin", "gold", 63);
   int avoidFastCoinTeam=rmCreateTypeDistanceConstraint("fast coin avoids coin team", "gold", 72);
   int avoidDeerShort = rmCreateTypeDistanceConstraint("avoid Deer short", "Deer", 15.0);

   // Avoid impassable land
   int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 6.0);
   int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);
   int patchConstraint=rmCreateClassDistanceConstraint("patch vs. patch", rmClassID("classPatch"), 5.0);

   // Unit avoidance - for things that aren't in the starting resources.
   int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 30.0);
   int avoidStartingUnitsTree=rmCreateClassDistanceConstraint("objects avoid starting units1", rmClassID("startingUnit"), 10.0);
   int avoidStartingUnitsSmall=rmCreateClassDistanceConstraint("objects avoid starting units small", rmClassID("startingUnit"), 5.0);
   int avoidTownCenterFar=rmCreateTypeDistanceConstraint("avoid Town Center Far", "townCenter", 50.0);
   int avoidTownCenterFar1=rmCreateTypeDistanceConstraint("avoid Town Center Far 1", "townCenter", 40.0);
   int avoidTownCenterFar2=rmCreateTypeDistanceConstraint("avoid Town Center Far team", "townCenter", 60.0);
   int avoidPondMine=rmCreateClassDistanceConstraint("mines avoid Pond", pondClass, 20.0);
   
   

   // Decoration avoidance
   int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);

   // VP avoidance
   int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 6.0);
   int avoidTradeRouteSmall = rmCreateTradeRouteDistanceConstraint("trade route small", 4.0);
   int avoidImportantItem=rmCreateClassDistanceConstraint("important stuff avoids each other", rmClassID("importantItem"), 15.0);
   int avoidSocket=rmCreateClassDistanceConstraint("socket avoidance", rmClassID("socketClass"), 6.0);
   int avoidSocketMore=rmCreateClassDistanceConstraint("bigger socket avoidance", rmClassID("socketClass"), 10.0);

   // Constraint to avoid water.
   int avoidWater = rmCreateTerrainDistanceConstraint("avoid water long", "Land", false, 50.0);

   // Avoid the Cliffs.
   int avoidCliffsShort = rmCreateClassDistanceConstraint("avoid Cliffs short", rmClassID("classCliff"), 1.0);
   int avoidCliffs = rmCreateClassDistanceConstraint("avoid Cliffs", rmClassID("classCliff"), 10.0);
   int avoidCliffsFar = rmCreateClassDistanceConstraint("avoid Cliffs far", rmClassID("classCliff"), 15.0);
	
   // natives avoid natives
   int avoidNatives = rmCreateClassDistanceConstraint("avoid Natives", rmClassID("natives"), 10.0);
   int avoidNativesWood = rmCreateClassDistanceConstraint("avoid Natives wood", rmClassID("natives"), 6.0);
   int avoidNativesNuggets = rmCreateClassDistanceConstraint("nuggets avoid Natives", rmClassID("natives"), 20.0);

   int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));


  									 rmSetStatusText("",0.10);

	
// ------------------------------------------------------ Trade Route ---------------------------------------------------------------------------
   int tradeRouteID = rmCreateTradeRoute();

   int socketID=rmCreateObjectDef("sockets to dock Trade Posts");
   rmSetObjectDefTradeRouteID(socketID, tradeRouteID);

   rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
   rmSetObjectDefAllowOverlap(socketID, true);
   rmAddObjectDefToClass(socketID, rmClassID("socketClass"));
   rmAddObjectDefConstraint(socketID,avoidCliffsShort);
   rmSetObjectDefMinDistance(socketID, 0.0);
   rmSetObjectDefMaxDistance(socketID, 6.0);


      rmAddTradeRouteWaypoint(tradeRouteID, 0.6, 0.6);
      rmAddTradeRouteWaypoint(tradeRouteID, 0.4, 0.6);
	  rmAddTradeRouteWaypoint(tradeRouteID, 0.4, 0.4);
	  rmAddTradeRouteWaypoint(tradeRouteID, 0.6, 0.4);
	  rmAddTradeRouteWaypoint(tradeRouteID, 0.6, 0.6);


   bool placedTradeRoute = rmBuildTradeRoute(tradeRouteID, "dirt");

   								rmSetStatusText("",0.20);

// ------------------------------------------------------ Player Location and Specific Area ---------------------------------------------------------------------------


if (cNumberTeams ==2)
{
	if(cNumberNonGaiaPlayers==2)
	{
		if (rmRandFloat(0,1)<0.5)
		{
		rmPlacePlayer(1,0.75,0.75);
		rmPlacePlayer(2,0.25,0.25);
		}
		else
		{
		rmPlacePlayer(2,0.75,0.75);
		rmPlacePlayer(1,0.25,0.25);
		}	
	}
	else
	{
		if (rmRandFloat(0,1)<0.5)
		{
		rmSetPlacementTeam(0);
		rmSetPlacementSection(0.02, 0.24);
		rmPlacePlayersCircular(0.35, 0.36, 0);

		rmSetPlacementTeam(1);
		rmSetPlacementSection(0.52, 0.74);
		rmPlacePlayersCircular(0.35, 0.36, 0);
		}
		else
		{
		rmSetPlacementTeam(0);
		rmSetPlacementSection(0.02, 0.24);
		rmPlacePlayersCircular(0.35, 0.36, 0);

		rmSetPlacementTeam(1);
		rmSetPlacementSection(0.52, 0.74);
		rmPlacePlayersCircular(0.35, 0.36, 0);
		}
	}
 }
else
{
    rmSetTeamSpacingModifier(0.25);
    rmPlacePlayersCircular(0.38, 0.40, 0.0);		
}	  
   
   for(i=0; <cNumberNonGaiaPlayers*4)
   {
   int newGrass = rmCreateArea("new grass"+i);
   rmSetAreaLocation(newGrass, rmRandFloat(0.05,0.95), rmRandFloat(0.05,0.95)); 
   rmSetAreaWarnFailure(newGrass, false);
   rmSetAreaSize(newGrass,rmXMetersToFraction(6), rmXMetersToFraction(6));
   rmSetAreaCoherence(newGrass, 0);
   rmSetAreaSmoothDistance(newGrass, 1);
   rmAddAreaConstraint(newGrass, avoidCliffs);
   rmSetAreaObeyWorldCircleConstraint(newGrass, false);
   rmAddAreaToClass(newGrass, rmClassID("classPatch")); 
   rmSetAreaTerrainType(newGrass, "california\fakecalifgrassmix_cal");
   rmSetAreaMix(newGrass, "california grass");
   rmBuildArea(newGrass);
   }


      // Changing grass
   for(i=0; <cNumberNonGaiaPlayers*5)
   {
   int newGrass2 = rmCreateArea("new grass2"+i);
   rmSetAreaLocation(newGrass2, rmRandFloat(0.05,0.95), rmRandFloat(0.05,0.95)); 
   rmSetAreaWarnFailure(newGrass2, false);
   rmSetAreaSize(newGrass2, rmXMetersToFraction(6), rmXMetersToFraction(6));
   rmSetAreaCoherence(newGrass2, 0);
   rmSetAreaSmoothDistance(newGrass2, 1);
   rmAddAreaConstraint(newGrass2, avoidCliffs);
   rmAddAreaConstraint(newGrass2, patchConstraint);
   rmSetAreaObeyWorldCircleConstraint(newGrass2, false);
   rmAddAreaToClass(newGrass2, rmClassID("classPatch")); 
   rmSetAreaTerrainType(newGrass2, "california\ground5_cal");
   rmSetAreaMix(newGrass2, "california grass");
   rmBuildArea(newGrass2);
   }
   
   int littleCircleArea = rmCreateArea("new grass3"+i);
   rmSetAreaLocation(littleCircleArea, 0.5, 0.5);
   rmAddAreaInfluenceSegment(littleCircleArea, 0.55, 0.45, 0.45, 0.55);
   rmAddAreaInfluenceSegment(littleCircleArea, 0.55, 0.55, 0.45, 0.45);   
   rmSetAreaWarnFailure(littleCircleArea, false);
   rmSetAreaSize(littleCircleArea, 0.075, 0.075);
 //  rmSetAreaSize(littleCircleArea, 0.06, 0.06);
   rmSetAreaCoherence(littleCircleArea, 0.8);
   rmSetAreaSmoothDistance(littleCircleArea, 5);
   rmAddAreaToClass(littleCircleArea, rmClassID("classPatch")); 
   rmSetAreaTerrainType(littleCircleArea, "california\desert2_cal"); // to check if the area to avoid is OK
   rmAddAreaTerrainLayer(littleCircleArea,"california\desert4_cal",0,5);
   rmBuildArea(littleCircleArea);

    int BigCircleCliff = rmCreatePieConstraint("Bog Circle for cliffs",0.5,0.5, rmXFractionToMeters(0.0),rmXFractionToMeters(0.25), rmDegreesToRadians(0),rmDegreesToRadians(360));
	int LittleCircleCliff = rmCreateAreaDistanceConstraint("little Circle for cliffs", littleCircleArea, 1);
	int ForestavoidCenter = rmCreateAreaDistanceConstraint("forests avoid Center", littleCircleArea, rmXFractionToMeters(0.06));

   numTries=1;
   failCount=0;
      int cliffID=rmCreateArea("cliff");
	  rmSetAreaLocation(cliffID, 0.35, 0.65);
	  rmSetAreaSize(cliffID, 0.03, 0.03);
      rmSetAreaWarnFailure(cliffID, false);
	  rmSetAreaCliffType(cliffID, "california");
      rmSetAreaCliffEdge(cliffID, 1, 1);
//	  rmSetAreaTerrainType(cliffID, "california\groundshore4_cal");
      rmSetAreaCliffPainting(cliffID, true, true, true, 1.5, true);
      rmSetAreaCliffHeight(cliffID, 8, 1.0, 0.5);
      rmSetAreaHeightBlend(cliffID, 1);
      rmAddAreaToClass(cliffID, rmClassID("classCliff")); 
      rmSetAreaSmoothDistance(cliffID, 0);
      rmSetAreaCoherence(cliffID, 0.75);
	  rmAddAreaConstraint(cliffID, LittleCircleCliff);
	  rmAddAreaConstraint(cliffID, BigCircleCliff);
	rmBuildArea(cliffID);

   numTries=1;
   failCount=0;

    int cliffID1=rmCreateArea("cliff1");
	rmSetAreaLocation(cliffID1, 0.65, 0.35);
	//rmAddAreaInfluenceSegment(cliffID1, 0.6, 0.4, 0.6, 0.6);
	rmSetAreaSize(cliffID1, 0.03, 0.03);
    rmSetAreaWarnFailure(cliffID1, false);
	rmSetAreaCliffType(cliffID1, "california");
    rmSetAreaCliffEdge(cliffID1, 1, 1);
//	rmSetAreaTerrainType(cliffID1, "california\groundshore4_cal");
    rmSetAreaCliffPainting(cliffID1, true, true, true, 1.5, true);
    rmSetAreaCliffHeight(cliffID1, 8, 1.0, 0.5);
    rmSetAreaHeightBlend(cliffID1, 1);
    rmAddAreaToClass(cliffID1, rmClassID("classCliff")); 
    rmSetAreaSmoothDistance(cliffID1, 0);
    rmSetAreaCoherence(cliffID1, 0.75);
	rmAddAreaConstraint(cliffID1, LittleCircleCliff);
	rmAddAreaConstraint(cliffID1, BigCircleCliff);
	rmBuildArea(cliffID1);

       vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.);
    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
    socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.3);
    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.5);
    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.8);
    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

  	rmSetStatusText("",0.30);
  	
   if (subCiv0 == rmGetCivID("Nootka"))
   {  
      int NootkaVillageAID = -1;
      NootkaVillageAID = rmCreateGrouping("nootka village A", "native nootka village "+4);
      rmSetGroupingMinDistance(NootkaVillageAID, 0.00);
      rmSetGroupingMaxDistance(NootkaVillageAID, 0.00);
      rmAddGroupingConstraint(NootkaVillageAID, avoidImpassableLand);
      rmAddGroupingToClass(NootkaVillageAID, rmClassID("natives"));
      rmPlaceGroupingAtLoc(NootkaVillageAID, 0, 0.1, 0.55);

      int NootkaVillageAID2 = -1;
      NootkaVillageAID2 = rmCreateGrouping("Nootka village B", "native nootka village "+2);
      rmSetGroupingMinDistance(NootkaVillageAID2, 0.0);
      rmSetGroupingMaxDistance(NootkaVillageAID2, 0.00);
      rmAddGroupingConstraint(NootkaVillageAID2, avoidImpassableLand);
      rmAddGroupingToClass(NootkaVillageAID2, rmClassID("natives"));
      rmPlaceGroupingAtLoc(NootkaVillageAID2, 0, 0.9, 0.45); 
	  
	  int NootkaVillageAID3 = -1;
      NootkaVillageAID3 = rmCreateGrouping("Nootka village C", "native nootka village "+1);
      rmSetGroupingMinDistance(NootkaVillageAID3, 0.0);
      rmSetGroupingMaxDistance(NootkaVillageAID3, 0.00);
      rmAddGroupingConstraint(NootkaVillageAID3, avoidImpassableLand);
      rmAddGroupingToClass(NootkaVillageAID3, rmClassID("natives"));
      rmPlaceGroupingAtLoc(NootkaVillageAID3, 0, 0.45, 0.9); 
	  
	 int NootkaVillageAID4 = -1;
      NootkaVillageAID4 = rmCreateGrouping("Nootka village D", "native nootka village "+2);
      rmSetGroupingMinDistance(NootkaVillageAID4, 0.0);
      rmSetGroupingMaxDistance(NootkaVillageAID4, 0.00);
      rmAddGroupingConstraint(NootkaVillageAID4, avoidImpassableLand);
      rmAddGroupingToClass(NootkaVillageAID4, rmClassID("natives"));
      rmPlaceGroupingAtLoc(NootkaVillageAID4, 0, 0.55, 0.1); 
   }
// ------------------------------------------------------ Starting Ressources ---------------------------------------------------------------------------


	int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	rmSetObjectDefMinDistance(startingUnits, 0.0);
	rmSetObjectDefMaxDistance(startingUnits, 0.0);

	int startingTCID = rmCreateObjectDef("startingTC");
	if ( rmGetNomadStart())
	{
		rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
	}
	else
	{
		rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0);
	}
	rmAddObjectDefToClass(startingTCID, rmClassID("startingUnit"));
	rmSetObjectDefMinDistance(startingTCID, 0.0);
	rmSetObjectDefMaxDistance(startingTCID, 1.0);

	int StartAreaTreeID=rmCreateObjectDef("starting trees");
	rmAddObjectDefItem(StartAreaTreeID, "TreeMadrone", 1, 0.0);
	rmSetObjectDefMinDistance(StartAreaTreeID, 12.0);
	rmSetObjectDefMaxDistance(StartAreaTreeID, 25.0);
	rmAddObjectDefConstraint(StartAreaTreeID, avoidStartingUnitsSmall);

	int StartDeerID1=rmCreateObjectDef("starting Deer");
	rmAddObjectDefItem(StartDeerID1, "Deer", 5, 5.0);
	rmSetObjectDefMinDistance(StartDeerID1, 10.0);
	rmSetObjectDefMaxDistance(StartDeerID1, 12.0);
	rmSetObjectDefCreateHerd(StartDeerID1, true);
	rmAddObjectDefConstraint(StartDeerID1, avoidStartingUnitsSmall);

	int StartDeerID11=rmCreateObjectDef("starting Deer1");
	rmAddObjectDefItem(StartDeerID11, "Deer", rmRandInt(13,14), 7.0);
	rmSetObjectDefMinDistance(StartDeerID11, 36.0);
	rmSetObjectDefMaxDistance(StartDeerID11, 38.0);
	rmSetObjectDefCreateHerd(StartDeerID11, true);
	rmAddObjectDefConstraint(StartDeerID11, avoidStartingUnitsSmall);
	rmAddObjectDefConstraint(StartDeerID11, avoidNatives);
	rmAddObjectDefConstraint(StartDeerID11, avoidCliffs);

	int StartElkID1=rmCreateObjectDef("starting elk");
	rmAddObjectDefItem(StartElkID1, "Elk", rmRandInt(8,9), 7.0);
	rmSetObjectDefMinDistance(StartElkID1, 46.0);
	rmSetObjectDefMaxDistance(StartElkID1, 48.0);
	rmSetObjectDefCreateHerd(StartElkID1, true);
	rmAddObjectDefConstraint(StartElkID1, avoidStartingUnitsSmall);
	rmAddObjectDefConstraint(StartElkID1, avoidNatives);
	rmAddObjectDefConstraint(StartElkID1, avoidCliffs);
	rmAddObjectDefConstraint(StartElkID1, avoidDeer);


	int playerNuggetID=rmCreateObjectDef("player nugget");
	rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
	rmAddObjectDefToClass(playerNuggetID, rmClassID("nuggets"));
	rmAddObjectDefToClass(playerNuggetID, rmClassID("startingUnit"));
    rmSetObjectDefMinDistance(playerNuggetID, 23.0);
    rmSetObjectDefMaxDistance(playerNuggetID, 32.0);
	rmAddObjectDefConstraint(playerNuggetID, avoidNugget);
	rmAddObjectDefConstraint(playerNuggetID, avoidNativesNuggets);
	rmAddObjectDefConstraint(playerNuggetID, avoidTradeRouteSmall);
	rmAddObjectDefConstraint(playerNuggetID, circleConstraint);
	// rmAddObjectDefConstraint(playerNuggetID, avoidImportantItem);

	
	int silverType = -1;
	int playerGoldID = -1;

 	for(i=1; <=cNumberNonGaiaPlayers)
	{
		rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
    
    if(ypIsAsian(i) && rmGetNomadStart() == false)
      rmPlaceObjectDefAtLoc(ypMonasteryBuilder(i, 1), i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
    
		rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// Everyone gets two ore ObjectDefs, one pretty close, the other a little further away.

		silverType = rmRandInt(1,10);
		playerGoldID = rmCreateObjectDef("player silver closer "+i);
		rmAddObjectDefItem(playerGoldID, "mine", 1, 0.0);
		rmAddObjectDefConstraint(playerGoldID, avoidTradeRoute);
		rmAddObjectDefConstraint(playerGoldID, avoidStartingCoin);
		rmAddObjectDefConstraint(playerGoldID, avoidStartingUnitsSmall);
		rmSetObjectDefMinDistance(playerGoldID, 15.0);
		rmSetObjectDefMaxDistance(playerGoldID, 16.0);

		int startSilver3ID = rmCreateObjectDef("player farther silver"+i);
		rmAddObjectDefItem(startSilver3ID, "mine", 1, 0.0);
		rmSetObjectDefMinDistance(startSilver3ID, 65.0);
		rmSetObjectDefMaxDistance(startSilver3ID, 70.0);
		rmAddObjectDefConstraint(startSilver3ID, avoidAll);
		rmAddObjectDefConstraint(startSilver3ID, avoidFastCoin);
		rmAddObjectDefConstraint(startSilver3ID, avoidCliffs);
		rmAddObjectDefConstraint(startSilver3ID, avoidCenterGold3);


		// Place  gold mines

if (cNumberNonGaiaPlayers ==2)
{
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
}

if (cNumberNonGaiaPlayers >2)
{
		rmPlaceObjectDefAtLoc(startSilver3ID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
}


		// Placing starting trees...
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	    rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));






		rmPlaceObjectDefAtLoc(StartDeerID1, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartDeerID11, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartElkID1, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		rmSetNuggetDifficulty(1, 1);
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	}
if (cNumberNonGaiaPlayers>2)
{
int mineb=rmAddFairLoc("TownCenter", false, false, 18, 19, 12, 5); 
rmAddObjectDefConstraint(mineb, avoidStartingCoin);
rmAddObjectDefConstraint(mineb, avoidStartingUnitsSmall);

	if(rmPlaceFairLocs())
	{
	mineb=rmCreateObjectDef("mine behind");
	rmAddObjectDefItem(mineb, "mine", 1, 0.0);
	for(i=1; <cNumberNonGaiaPlayers+1)
		{
	for(j=0; <rmGetNumberFairLocs(i))
			{
	rmPlaceObjectDefAtLoc(mineb, i, rmFairLocXFraction(i, j), rmFairLocZFraction(i, j), 1);
			}
		}
	}

int minef=rmAddFairLoc("TownCenter", true, true, 18, 19, 12, 5);
rmAddObjectDefConstraint(minef, avoidStartingCoin);
rmAddObjectDefConstraint(minef, avoidStartingUnitsSmall);


	if(rmPlaceFairLocs())
	{
	minef=rmCreateObjectDef("forward mine");
	rmAddObjectDefItem(minef, "mine", 1, 0.0);
	for(i=1; <cNumberNonGaiaPlayers+1)
	{
	for(j=1; <rmGetNumberFairLocs(i))
	{
	rmPlaceObjectDefAtLoc(minef, i, rmFairLocXFraction(i, j), rmFairLocZFraction(i, j), 1);
	}
	}
	}
}


							   rmSetStatusText("",0.60);


// ------------------------------------------------------ Natives & Nuggets & Design ---------------------------------------------------------------------------

 

	// Ponds o' Fun
   int pondConstraint=rmCreateClassDistanceConstraint("ponds avoid ponds", rmClassID("pond"), 50.0);
	
   int numPonds=cNumberNonGaiaPlayers+2;
 


							   rmSetStatusText("",0.80);



// ------------------------------------------------------ Others Ressources ---------------------------------------------------------------------------

int TopArea1 = rmCreatePieConstraint("Top area constraint",0.55,0.55, rmXFractionToMeters(0.0),rmXFractionToMeters(0.5), rmDegreesToRadians(315),rmDegreesToRadians(135));
int BottomArea1 = rmCreatePieConstraint("Bottom area constraint",0.45,0.45, rmXFractionToMeters(0.0),rmXFractionToMeters(0.5), rmDegreesToRadians(135),rmDegreesToRadians(315));
/*
   int TopArea = rmCreateArea("top area");
   rmSetAreaLocation(TopArea, 0.3, 0.3); 
   rmSetAreaSize(TopArea, 0.4, 0.4);
   rmSetAreaCoherence(TopArea, 1);
   rmSetAreaSmoothDistance(TopArea, 1);
   rmSetAreaObeyWorldCircleConstraint(TopArea, false);
   rmAddAreaConstraint(TopArea,BottomArea1);
   rmAddAreaToClass(TopArea, rmClassID("classPatch")); 
   rmSetAreaTerrainType(TopArea, "yukon\ground1_yuk");
   rmBuildArea(TopArea);*/

	int silverCount = cNumberNonGaiaPlayers/2*3; 
	int silverID3 = -1;
	int silverID4 = -1;

	silverType = rmRandInt(1,10);
	
		for(i=0; < silverCount)
	{
		silverID3 = rmCreateObjectDef("silver Top"+i);
		rmAddObjectDefItem(silverID3, "mine", 1, 0.0);
		rmSetObjectDefMinDistance(silverID3, 0.0);
		rmSetObjectDefMaxDistance(silverID3, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(silverID3, avoidFastCoinTeam);
		rmAddObjectDefConstraint(silverID3, avoidAll);
		rmAddObjectDefConstraint(silverID3, avoidImpassableLand);
		rmAddObjectDefConstraint(silverID3, avoidTradeRouteSmall);
		rmAddObjectDefConstraint(silverID3, avoidSocketMore);
		rmAddObjectDefConstraint(silverID3, avoidCliffs);
		rmAddObjectDefConstraint(silverID3, TopArea1);
		rmPlaceObjectDefAtLoc(silverID3, 0, 0.5, 0.5);		
   	}

	for(i=0; < silverCount)
	{
		silverID4 = rmCreateObjectDef("silver Bottom"+i);
		rmAddObjectDefItem(silverID4, "mine", 1, 0.0);
		rmSetObjectDefMinDistance(silverID4, 0.0);
		rmSetObjectDefMaxDistance(silverID4, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(silverID4, avoidFastCoinTeam);
		rmAddObjectDefConstraint(silverID4, avoidAll);
		rmAddObjectDefConstraint(silverID4, avoidImpassableLand);
		rmAddObjectDefConstraint(silverID4, avoidTradeRouteSmall);
		rmAddObjectDefConstraint(silverID4, avoidSocketMore);
		rmAddObjectDefConstraint(silverID4, avoidCliffs);
		rmAddObjectDefConstraint(silverID4, BottomArea1);
		rmPlaceObjectDefAtLoc(silverID4, 0, 0.5, 0.5);		
   	}


  
  // RANDOM TREES
   numTries=8*cNumberNonGaiaPlayers;
   failCount=0;
   for (i=0; <numTries)
   {   
		int forest=rmCreateArea("forest "+i);
		rmSetAreaWarnFailure(forest, false);
		rmSetAreaSize(forest, rmAreaTilesToFraction(100), rmAreaTilesToFraction(140));
		rmSetAreaForestType(forest, "california pine forest");
		rmSetAreaForestDensity(forest, 0.8);
		rmSetAreaForestClumpiness(forest, 0.1);
		rmSetAreaForestUnderbrush(forest, 0.5);
		rmSetAreaCoherence(forest, 0.5);
		rmAddAreaToClass(forest, rmClassID("classForest")); 
		rmAddAreaConstraint(forest, forestConstraint);
		rmAddAreaConstraint(forest, avoidTownCenterFar1);
		rmAddAreaConstraint(forest, avoidImportantItem);
		rmAddAreaConstraint(forest, avoidImpassableLand);
		rmAddAreaConstraint(forest, avoidCliffs);
	    rmAddAreaConstraint(forest, avoidTradeRoute);
		rmAddAreaConstraint(forest, avoidSocket);
		rmAddAreaConstraint(forest, avoidNuggetSmall);
		rmAddAreaConstraint(forest, LittleCircleCliff);
		rmAddAreaConstraint(forest, avoidStartingUnitsTree);
		rmAddAreaConstraint(forest, avoidNatives);
        rmAddAreaConstraint(forest, avoidCoinShort);
		rmAddAreaConstraint(forest, avoidAll);
		rmAddAreaConstraint(forest, ForestavoidCenter);
		if(rmBuildArea(forest)==false)
		{
			// Stop trying once we fail 10 times in a row.
			failCount++;
			if(failCount==10)
			break;
		}
		else
			failCount=0; 
   }
  

   numTries=10;
   failCount=0;
   for (i=0; <numTries)
   {   
		int forest2=rmCreateArea("near "+i);
		rmSetAreaWarnFailure(forest2, false);
		rmSetAreaSize(forest2, rmAreaTilesToFraction(60), rmAreaTilesToFraction(80));
		rmSetAreaForestType(forest2, "california madrone forest");
		rmSetAreaForestDensity(forest2, 0.8);
		rmSetAreaForestClumpiness(forest2, 0.1);
		rmSetAreaForestUnderbrush(forest2, 0.9);
		rmSetAreaCoherence(forest2, 0.5);
		rmAddAreaToClass(forest2, rmClassID("classForest")); 
		rmAddAreaConstraint(forest2, forestConstraint);
		rmAddAreaConstraint(forest2, playerConstraint);
		rmAddAreaConstraint(forest2, avoidTownCenterFar1);
		rmAddAreaConstraint(forest2, avoidImportantItem);
		rmAddAreaConstraint(forest2, avoidImpassableLand);
		rmAddAreaConstraint(forest2, avoidCliffs);
		rmAddAreaConstraint(forest2, avoidTradeRoute);
		rmAddAreaConstraint(forest2, avoidSocket);
		rmAddAreaConstraint(forest2, avoidNuggetSmall);
		rmAddAreaConstraint(forest2, avoidStartingUnitsTree);
        rmAddAreaConstraint(forest2, avoidCoinShort);
        rmAddAreaConstraint(forest2, avoidNatives);
		rmAddAreaConstraint(forest2, LittleCircleCliff);
		rmAddAreaConstraint(forest2, avoidAll);
		rmAddAreaConstraint(forest2, ForestavoidCenter);
		if(rmBuildArea(forest2)==false)
		{
			// Stop trying once we fail 10 times in a row.
			failCount++;
			if(failCount==10)
			break;
		}
		else
			failCount=0; 
   }

		// Elk	
   int ElkID4=rmCreateObjectDef("Elk herd team");
   rmAddObjectDefItem(ElkID4, "Elk", rmRandInt(10,12), 8.0);
   rmSetObjectDefMinDistance(ElkID4, 0.0);
   rmSetObjectDefMaxDistance(ElkID4, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(ElkID4, avoidDeer);
   rmAddObjectDefConstraint(ElkID4, avoidElk);
	rmAddObjectDefConstraint(ElkID4, avoidAll);
   rmAddObjectDefConstraint(ElkID4, avoidImpassableLand);
	rmAddObjectDefConstraint(ElkID4, avoidSocket);
	rmAddObjectDefConstraint(ElkID4, avoidTownCenterFar2);
	rmAddObjectDefConstraint(ElkID4, avoidCliffs);
	rmAddObjectDefConstraint(ElkID4, avoidCoinShort);
	rmAddObjectDefConstraint(ElkID4, avoidNatives);
	rmAddObjectDefConstraint(ElkID4, BottomArea1);
   rmSetObjectDefCreateHerd(ElkID4, true);
	rmPlaceObjectDefAtLoc(ElkID4, 0, 0.5, 0.5, cNumberNonGaiaPlayers/2*3);
	
	
		// Deer	
   int DeerID4=rmCreateObjectDef("Deer herd team");
   rmAddObjectDefItem(DeerID4, "Deer", rmRandInt(10,12), 8.0);
   rmSetObjectDefMinDistance(DeerID4, 0.0);
   rmSetObjectDefMaxDistance(DeerID4, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(DeerID4, avoidDeer);
   rmAddObjectDefConstraint(DeerID4, avoidElk);
	rmAddObjectDefConstraint(DeerID4, avoidAll);
   rmAddObjectDefConstraint(DeerID4, avoidImpassableLand);
	rmAddObjectDefConstraint(DeerID4, avoidSocket);
	rmAddObjectDefConstraint(DeerID4, avoidStartingUnits);
	rmAddObjectDefConstraint(DeerID4, avoidCliffs);
	rmAddObjectDefConstraint(DeerID4, avoidTownCenterFar2);
	rmAddObjectDefConstraint(DeerID4, avoidCoinShort);
	rmAddObjectDefConstraint(DeerID4, avoidNatives);
	rmAddObjectDefConstraint(DeerID4, TopArea1);
    rmSetObjectDefCreateHerd(DeerID4, true);
	rmPlaceObjectDefAtLoc(DeerID4, 0, 0.5, 0.5, cNumberNonGaiaPlayers/2*3);	   


							   rmSetStatusText("",0.90);
							   
//	---------------------------------------------------- Nuggets ----------------------------------------------------------------------------------------


	int nuggetID= rmCreateObjectDef("nugget"); 
	rmAddObjectDefItem(nuggetID, "Nugget", 1, 0.0);
	rmSetObjectDefMinDistance(nuggetID, 0.0);
	rmSetObjectDefMaxDistance(nuggetID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(nuggetID, shortAvoidImpassableLand);
  	rmAddObjectDefConstraint(nuggetID, avoidNugget);
	rmAddObjectDefConstraint(nuggetID, nuggetPlayerConstraint);
  	rmAddObjectDefConstraint(nuggetID, playerConstraint);
  	rmAddObjectDefConstraint(nuggetID, avoidTradeRoute);
	rmAddObjectDefConstraint(nuggetID, avoidSocketMore);
	rmAddObjectDefConstraint(nuggetID, avoidCliffs);
	rmAddObjectDefConstraint(nuggetID, avoidNativesNuggets);
	rmAddObjectDefConstraint(nuggetID, avoidCoinShort);
	rmAddObjectDefConstraint(nuggetID, circleConstraint);
  	rmAddObjectDefConstraint(nuggetID, avoidAll);
	rmSetNuggetDifficulty(1, 3);
	rmPlaceObjectDefAtLoc(nuggetID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*4);						   
							   
							   
							   
							   



// ------------------------------------------------------ KOTH for noobs ---------------------------------------------------------------------

  if(rmGetIsKOTH()) {
    
    int randLoc = rmRandInt(1,3);
    float xLoc = 0.5;
    float yLoc = 0.5;
    float walk = 0.075;
    
    ypKingsHillPlacer(xLoc, yLoc, walk, 0);
    rmEchoInfo("XLOC = "+xLoc);
    rmEchoInfo("XLOC = "+yLoc);
  }
// ------------------------------------------------------ Finishing the OP UI ---------------------------------------------------------------------------


  							 rmSetStatusText("",1.0);
}  


// ***********************************************************************************************************************************************
// ****************************************************** E N D **********************************************************************************
// ***********************************************************************************************************************************************