include "mercenaries.xs";
include "ypAsianInclude.xs";
include "ypKOTHInclude.xs";

void main(void)
{


	/*
	================
	Local variables
	================
	*/
	
	//loop variables and map size
	int playerTiles = -1;
	if(cNumberNonGaiaPlayers==2)
		playerTiles = 16000;
	else
		playerTiles = 12000;
	int numTries = 25;
	int failCount = -1;	

	
	//objects variables
	int riverID = -1;
	int riverID2 = -1;
	int riverLeftID = -1;
	int riverLeftID2 = -1;
	int riverRightID = -1;
	int riverRightID2 = 1;
	
	int continent2 = -1;

	int bottomTreeID = -1;
	int forestbottomID = -1;
	int topTreeID = -1;
	int mapTrees = -1;
	int topHunt = -1;
	int bottomHunt = -1;
	int topGold = -1;
	int bottomGold = -1;
	int spawnTreasure = -1;
	
	int subCiv0 = -1; //tupi top
	int subCiv1 = -1; //maya top
	int subCiv2 = -1; //tupi bot
	int subCiv3 = -1; //maya bot
	int subCiv4 = -1; //tupi left
	int subCiv5 = -1; //maya left
	int subCiv6 = -1; //tupi right
	int subCiv7 = -1; //maya right
	
	int botVillageID = -1;
	
	int radianl1 = -1;
	int radianl2 = -1;
	
	int radianr1 = -1;
	int radianr2 = -1;
	
	int leftConstraint = -1;
	int rightConstraint = -1;
	int bottomConstraint = -1;
	int topConstraint = -1;
	
	
	float worldEdgeDistance = -1; //distance from herds to world's edge. The bigger the map, the closer you can set the distance to the world edge. Map size is relative to distance from world edge for hunts
	
	if(cNumberNonGaiaPlayers == 4) //2vs2
		worldEdgeDistance = 0.435;
	if(cNumberNonGaiaPlayers == 6) //3vs3	
		worldEdgeDistance = 0.465;		
	else 						   //1vs1
		worldEdgeDistance = 0.430;

	//nats	
	if (rmAllocateSubCivs(8) == true)
	{
		subCiv0=rmGetCivID("Aztecs");
		if (subCiv0 >= 0)
			rmSetSubCiv(0, "Aztecs");
		
		subCiv1=rmGetCivID("Aztecs");
		if (subCiv1 >= 0)
			rmSetSubCiv(1, "Aztecs");

		subCiv2=rmGetCivID("Aztecs");
		if (subCiv2 >= 0)
			rmSetSubCiv(2, "Aztecs");

		subCiv3=rmGetCivID("Aztecs");
		if (subCiv3 >= 0)
			rmSetSubCiv(3, "Aztecs");		
		
		subCiv4=rmGetCivID("Jesuit");
		if (subCiv4 >= 0)
			rmSetSubCiv(4, "Jesuit");

		subCiv5=rmGetCivID("Jesuit");
		if (subCiv5 >= 0)
			rmSetSubCiv(5, "Jesuit");	
				
		subCiv6=rmGetCivID("Jesuit");
		if (subCiv6 >= 0)
			rmSetSubCiv(6, "Jesuit");

		subCiv7=rmGetCivID("Jesuit");
		if (subCiv7 >= 0)
			rmSetSubCiv(7, "Jesuit");	
	}
	
	int size = 2.0 * sqrt(cNumberNonGaiaPlayers*playerTiles);
	rmSetMapSize(size, size);
	
	// Picks default terrain and water	
	rmSetBaseTerrainMix("amazon grass");
	rmTerrainInitialize("amazon\ground4_ama", 4);
	rmSetMapType("amazonia");
	rmSetMapType("tropical");
	rmSetMapType("land");
	rmSetLightingSet("paris");	
	
	//Define custom classes
    rmDefineClass("classForest");
	rmDefineClass("classNatives");
	
	/*
	======================
	Define constraints...
	=====================
	*/
	
	//...river
	int avoidRiver = rmCreateTerrainDistanceConstraint("avoid river", "Land", false, 12.0);
	
	//...resources
	int avoidHerd = rmCreateTypeDistanceConstraint("herds avoid herds", "herdable", 40.0);
	int avoidHunt = rmCreateTypeDistanceConstraint("hunts avoid hunts", "huntable", 40.0);
	
	int avoidCoin = rmCreateTypeDistanceConstraint("avoid coin", "Mine", 10.0);
	int avoidCoinTree = rmCreateTypeDistanceConstraint("coin vs tree", "Mine", 15.0);
	int avoidCoinCliff = rmCreateTypeDistanceConstraint("coin vs cliff", "Mine", 30.0);
    int avoidCoinMed = rmCreateTypeDistanceConstraint("avoid coin medium", "Mine", 45.0);
	
	int forestConstraint = rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 28.5);
	int forestConstraintThick = rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 28.0);
    int forestConstraintShort = rmCreateClassDistanceConstraint("object vs. forest", rmClassID("classForest"), 4.0);
	int forestConstraintSmaller = rmCreateClassDistanceConstraint("object vs. forest", rmClassID("classForest"), 29.0);
	
	//...objectcs
	int avoidNativesClose = rmCreateClassDistanceConstraint("stuff vs nats", rmClassID("classNatives"), 8.0);
	int avoidNativesMed = rmCreateClassDistanceConstraint("stuff vs nats", rmClassID("classNatives"), 16.0);
	
	
	//...towncenter
	int avoidTownCenterClose = rmCreateTypeDistanceConstraint("avoid Town Center small", "townCenter", 10.0);	
    int avoidTownCenterSmall = rmCreateTypeDistanceConstraint("avoid Town Center small", "townCenter", 15.0);
	int avoidTownCenterForest = rmCreateTypeDistanceConstraint("avoid Town Center small", "townCenter", 25.0);
	int avoidTownCenter = rmCreateTypeDistanceConstraint("avoid Town Center", "townCenter", 35.0);
    int avoidTownCenterMore = rmCreateTypeDistanceConstraint("avoid Town Center more", "townCenter", 40.0); 
	int avoidTownCenterSupaFar = rmCreateTypeDistanceConstraint("avoid Town Center supa far", "townCenter", 80.0);
	
	//...treasures(=nuggets)
	int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "AbstractNugget", 45.0);
	
	//...world constraints
	if(cNumberNonGaiaPlayers == 6)
	{
		leftConstraint = rmCreatePieConstraint("left Constraint", 0.5, 0.74, 0, 
			rmZFractionToMeters(0.6), rmDegreesToRadians(300), rmDegreesToRadians(50));
		
		rightConstraint = rmCreatePieConstraint("right Constraint", 0.5, 0.26, 0,
			rmZFractionToMeters(0.6), rmDegreesToRadians(125), rmDegreesToRadians(230));
		
		bottomConstraint = rmCreatePieConstraint("bottom Constraint", 0.6, 0.5, 0,
			rmZFractionToMeters(0.7), rmDegreesToRadians(225), rmDegreesToRadians(300));
			
		topConstraint = rmCreatePieConstraint("top Constraint", 0.4, 0.5, 0,
			rmZFractionToMeters(0.7), rmDegreesToRadians(52), rmDegreesToRadians(122));
	}
	else
	{
		leftConstraint = rmCreatePieConstraint("left Constraint", 0.5, 0.70, 0,		
			rmZFractionToMeters(0.6), rmDegreesToRadians(305), rmDegreesToRadians(45));
		
		rightConstraint = rmCreatePieConstraint("right Constraint", 0.5, 0.30, 0,		
			rmZFractionToMeters(0.6), rmDegreesToRadians(130), rmDegreesToRadians(225));
		
		bottomConstraint = rmCreatePieConstraint("bottom Constraint", 0.5, 0.5, 0,
			rmZFractionToMeters(0.7), rmDegreesToRadians(210), rmDegreesToRadians(305));
		
		topConstraint = rmCreatePieConstraint("top Constraint", 0.5, 0.5, 0,
			rmZFractionToMeters(0.7), rmDegreesToRadians(35), rmDegreesToRadians(147));	
	}	
	
	int worldEdgeConstraint = rmCreatePieConstraint("world Constraint", 0.5, 0.5, 0, 
		rmZFractionToMeters(worldEdgeDistance), rmDegreesToRadians(0), rmDegreesToRadians(360));
	
	int worldEdgeConstraintCoin = rmCreatePieConstraint("world Constraint coin", 0.5, 0.5, 0,
		rmZFractionToMeters(0.48), rmDegreesToRadians(0), rmDegreesToRadians(360));
	
	
	/*
	===============
	spawnpositions
	===============
	*/
	
	float spawnSwitch = rmRandFloat(0,1.2);
		if(cNumberNonGaiaPlayers == 4) // 2vs2
		{
			if (spawnSwitch <=0.6)
			{
				rmSetPlacementTeam(0);
				rmPlacePlayersLine(0.16, 0.405, 0.16, 0.595, 0, 0);
				rmSetPlacementTeam(1);
				rmPlacePlayersLine(0.84, 0.595, 0.84, 0.405, 0, 0);
			}
			else if(spawnSwitch <=1.2)
			{
				rmSetPlacementTeam(1);
				rmPlacePlayersLine(0.16, 0.405, 0.16, 0.595, 0, 0);
				rmSetPlacementTeam(0);
				rmPlacePlayersLine(0.84, 0.595, 0.84, 0.405, 0, 0);
			}
		}
		else if(cNumberNonGaiaPlayers == 2) // 1vs1
		{
			if(spawnSwitch <= 0.6)
			{
				rmPlacePlayer(1, 0.16, 0.50);
				rmPlacePlayer(2, 0.84, 0.50);
			}
			else if(spawnSwitch <= 1.2)
			{
				rmPlacePlayer(2, 0.16, 0.50);
				rmPlacePlayer(1, 0.84, 0.50);
			}
		}
		if(cNumberNonGaiaPlayers == 6) // 3vs3
		{
		if (spawnSwitch <=0.6)
			{
				rmSetPlacementTeam(0);
				rmPlacePlayersLine(0.16, 0.34, 0.16, 0.64, 0, 0);
				rmSetPlacementTeam(1);
				rmPlacePlayersLine(0.84, 0.64, 0.84, 0.34, 0, 0);
			}
			else if(spawnSwitch <=1.2)
			{
				rmSetPlacementTeam(1);
				rmPlacePlayersLine(0.16, 0.34, 0.16, 0.64, 0, 0);
				rmSetPlacementTeam(0);
				rmPlacePlayersLine(0.84, 0.64, 0.84, 0.34, 0, 0);
			}
		}
		else //ffa
		{
			rmPlacePlayersCircular(0.4, 0.4, 0.02);
		}
		
	
	/*
	=====================================
	initialize terrain and global objects
	=====================================
	*/
	
	//mercs
	chooseMercs();	
	//ground map
	continent2 = rmCreateArea("continent");
    rmSetAreaSize(continent2, 1.0, 1.0);
    rmSetAreaLocation(continent2, 0.5, 0.5);
    rmSetAreaTerrainType(continent2, "yukon\ground3_yuk");
    rmSetAreaBaseHeight(continent2, 0.0);
    rmSetAreaCoherence(continent2, 1.0);
    rmSetAreaSmoothDistance(continent2, 10);
    rmSetAreaHeightBlend(continent2, 1);
    rmSetAreaElevationNoiseBias(continent2, 0);
    rmSetAreaElevationEdgeFalloffDist(continent2, 10);
    rmSetAreaElevationVariation(continent2, 5);
    rmSetAreaElevationPersistence(continent2, .2);
    rmSetAreaElevationOctaves(continent2, 5);
    rmSetAreaElevationMinFrequency(continent2, 0.04);
    rmSetAreaElevationType(continent2, cElevTurbulence);  
    rmBuildArea(continent2);    
	
	/*
	=================================
	starting location and ressources
	================================
	*/
	
	
	//spawn point and starting ressources...		
	//...explorer
	int playerStart = rmCreateStartingUnitsObjectDef(5.0);
    rmSetObjectDefMinDistance(playerStart, 7.0);
    rmSetObjectDefMaxDistance(playerStart, 12.0);
	
	
	//...gold  
    int goldID = rmCreateObjectDef("starting gold");
    rmAddObjectDefItem(goldID, "mine", 1, 0);
    rmSetObjectDefMinDistance(goldID, 16.0);
    rmSetObjectDefMaxDistance(goldID, 17.0);
	rmAddObjectDefConstraint(goldID, avoidTownCenterSmall);      
	
	//...trees	
    int treeID = rmCreateObjectDef("starting trees");
    rmAddObjectDefItem(treeID, "ypTreeCeylon", rmRandInt(10,15), 20.0);
    rmSetObjectDefMinDistance(treeID, 12.0);
    rmSetObjectDefMaxDistance(treeID, 18.0);
    rmAddObjectDefConstraint(treeID, avoidTownCenterForest);
    rmAddObjectDefConstraint(treeID, avoidCoinTree);
	
	//...herd
    int foodID = rmCreateObjectDef("starting hunt");
    rmAddObjectDefItem(foodID, "ypSerow", 15, 15.0);
    rmSetObjectDefMinDistance(foodID, 10.0);
    rmSetObjectDefMaxDistance(foodID, 11.0);
    rmSetObjectDefCreateHerd(foodID, true);
	rmAddObjectDefConstraint(foodID, forestConstraintShort);
	
	//...treasure	
	int nuggetID = rmCreateObjectDef("nuggets");
	rmAddObjectDefItem(nuggetID, "Nugget", 1, 0.0); 
	rmSetObjectDefMinDistance(nuggetID, 20.0); 
	rmSetObjectDefMaxDistance(nuggetID, 30.0); 
    rmAddObjectDefConstraint(nuggetID, avoidTownCenterClose);     
	rmAddObjectDefConstraint(nuggetID, forestConstraintShort);
	rmSetNuggetDifficulty(0,1); 
	

	//...place tc and ressources
    for(i=1; < cNumberNonGaiaPlayers + 1) 
	{
		int id=rmCreateArea("Player"+i);
		rmSetPlayerArea(i, id);
		int startID = rmCreateObjectDef("object"+i);
		rmAddObjectDefItem(startID, "TownCenter", 1, 0);
		rmSetObjectDefMinDistance(startID, 0.0);
        rmSetObjectDefMaxDistance(startID, 3.0);
		rmPlaceObjectDefAtLoc(startID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));	
		vector TCLoc = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startID, i));	

		rmPlaceObjectDefAtLoc(goldID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));	
        rmPlaceObjectDefAtLoc(treeID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
        rmPlaceObjectDefAtLoc(foodID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));		
		rmPlaceObjectDefAtLoc(nuggetID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));	
        rmPlaceObjectDefAtLoc(playerStart, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		
		if(ypIsAsian(i) && rmGetNomadStart() == false)
			rmPlaceObjectDefAtLoc(ypMonasteryBuilder(i, 1), i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
	}
	
	
	/*
	=========================
	global ressources & nats
	=========================
	*/

	
	//...nats	
	float spawnSwitch0 = rmRandFloat(0, 1.2);
	float spawnSwitch2 = rmRandFloat(0, 1.2);
	float spawnSwitch3 = rmRandFloat(0, 1.2);
	float spawnSwitch4 = rmRandFloat(0, 1.2);
	float spawnSwitch5 = rmRandFloat(0, 1.2);
	
	if(cNumberNonGaiaPlayers == 2)
	{	
			//native jesuit mission cj 0 , native jesuit mission borneo 0
			botVillageID = rmCreateGrouping("Jesuit bot 1", "native jesuit mission borneo 0" + 2);
			rmSetGroupingMinDistance(botVillageID, 0.0);
			rmSetGroupingMaxDistance(botVillageID, 0.5);
			rmAddGroupingToClass(botVillageID, rmClassID("classNatives"));
			rmPlaceGroupingAtLoc(botVillageID, 0, 0.18, 0.31);
			
			botVillageID = rmCreateGrouping("aztecs village 2", "native aztec village " + 2);
			rmSetGroupingMinDistance(botVillageID, 0.0);
			rmSetGroupingMaxDistance(botVillageID, 0.5);
			rmAddGroupingToClass(botVillageID, rmClassID("classNatives"));
			rmPlaceGroupingAtLoc(botVillageID, 0, 0.17, 0.725);
			
			//native jesuit mission cj 0 , native jesuit mission borneo 0
			botVillageID = rmCreateGrouping("Jesuit bot 3", "native jesuit mission borneo 0" + 2);
			rmSetGroupingMinDistance(botVillageID, 0.0);
			rmSetGroupingMaxDistance(botVillageID, 0.5);
			rmAddGroupingToClass(botVillageID, rmClassID("classNatives"));
			rmPlaceGroupingAtLoc(botVillageID, 0, 0.83, 0.31);
			
			botVillageID = rmCreateGrouping("aztecs village 4", "native aztec village " + 2);
			rmSetGroupingMinDistance(botVillageID, 0.0);
			rmSetGroupingMaxDistance(botVillageID, 0.5);
			rmAddGroupingToClass(botVillageID, rmClassID("classNatives"));
			rmPlaceGroupingAtLoc(botVillageID, 0, 0.83, 0.725);
	}	
	
	if(cNumberNonGaiaPlayers == 4)
	{
			botVillageID = rmCreateGrouping("aztecs village 23", "native aztec village " + 2);
			rmSetGroupingMinDistance(botVillageID, 0.0);
			rmSetGroupingMaxDistance(botVillageID, 0.5);
			rmAddGroupingToClass(botVillageID, rmClassID("classNatives"));
			rmPlaceGroupingAtLoc(botVillageID, 0, 0.27, 0.5);
			
			botVillageID = rmCreateGrouping("aztecs village 24", "native aztec village " + 2);
			rmSetGroupingMinDistance(botVillageID, 0.0);
			rmSetGroupingMaxDistance(botVillageID, 0.5);
			rmAddGroupingToClass(botVillageID, rmClassID("classNatives"));		
			rmPlaceGroupingAtLoc(botVillageID, 0, 0.73, 0.5);
			
			
		if(spawnSwitch2 <= 0.6)
		{
			
			botVillageID = rmCreateGrouping("aztecs village 55", "native jesuit mission borneo 0" + 1);
			rmSetGroupingMinDistance(botVillageID, 0.0);
			rmSetGroupingMaxDistance(botVillageID, 0.5);
			rmAddGroupingToClass(botVillageID, rmClassID("classNatives"));
			rmPlaceGroupingAtLoc(botVillageID, 0, 0.81, 0.25);	

		}
		else
		{	
			botVillageID = rmCreateGrouping("aztecs village 44", "native jesuit mission borneo 0" + 4);
			rmSetGroupingMinDistance(botVillageID, 0.0);
			rmSetGroupingMaxDistance(botVillageID, 0.5);
			rmAddGroupingToClass(botVillageID, rmClassID("classNatives"));
			rmPlaceGroupingAtLoc(botVillageID, 0, 0.81, 0.76);
		}
		if(spawnSwitch3 <= 0.6)
		{		
			botVillageID = rmCreateGrouping("aztecs village 56", "native jesuit mission borneo 0" + 1);
			rmSetGroupingMinDistance(botVillageID, 0.0);
			rmSetGroupingMaxDistance(botVillageID, 0.5);
			rmAddGroupingToClass(botVillageID, rmClassID("classNatives"));
			rmPlaceGroupingAtLoc(botVillageID, 0, 0.20, 0.25);	
		}
		else
		{
			botVillageID = rmCreateGrouping("aztecs village 45", "native jesuit mission borneo 0" + 4);
			rmSetGroupingMinDistance(botVillageID, 0.0);
			rmSetGroupingMaxDistance(botVillageID, 0.5);
			rmAddGroupingToClass(botVillageID, rmClassID("classNatives"));
			rmPlaceGroupingAtLoc(botVillageID, 0, 0.20, 0.768);
		}
		
	}
	
	
	if(cNumberNonGaiaPlayers == 6)
	{
		if(spawnSwitch0 <= 0.6)
		{
			botVillageID = rmCreateGrouping("aztecs village 23000", "native aztec village " + 2);
			rmSetGroupingMinDistance(botVillageID, 0.0);
			rmSetGroupingMaxDistance(botVillageID, 0.5);
			rmAddGroupingToClass(botVillageID, rmClassID("classNatives"));
			rmPlaceGroupingAtLoc(botVillageID, 0, 0.27, 0.7);
			
			botVillageID = rmCreateGrouping("aztecs village 56000", "native jesuit mission borneo 0" + 1);
			rmSetGroupingMinDistance(botVillageID, 0.0);
			rmSetGroupingMaxDistance(botVillageID, 0.5);
			rmAddGroupingToClass(botVillageID, rmClassID("classNatives"));
			rmPlaceGroupingAtLoc(botVillageID, 0, 0.265, 0.3105);	
		}
		else
		{
			botVillageID = rmCreateGrouping("aztecs village 23001", "native aztec village " + 1);
			rmSetGroupingMinDistance(botVillageID, 0.0);
			rmSetGroupingMaxDistance(botVillageID, 0.5);
			rmAddGroupingToClass(botVillageID, rmClassID("classNatives"));
			rmPlaceGroupingAtLoc(botVillageID, 0, 0.27, 0.3);
			
			botVillageID = rmCreateGrouping("aztecs village 56001", "native jesuit mission borneo 0" + 1);
			rmSetGroupingMinDistance(botVillageID, 0.0);
			rmSetGroupingMaxDistance(botVillageID, 0.5);
			rmAddGroupingToClass(botVillageID, rmClassID("classNatives"));
			rmPlaceGroupingAtLoc(botVillageID, 0, 0.27, 0.7);	
		}
		if(spawnSwitch2 <=0.6)
		{
			botVillageID = rmCreateGrouping("aztecs village 23000", "native aztec village " + 2);
			rmSetGroupingMinDistance(botVillageID, 0.0);
			rmSetGroupingMaxDistance(botVillageID, 0.5);
			rmAddGroupingToClass(botVillageID, rmClassID("classNatives"));
			rmPlaceGroupingAtLoc(botVillageID, 0, 0.73, 0.7);
			
			botVillageID = rmCreateGrouping("aztecs village 56000", "native jesuit mission borneo 0" + 1);
			rmSetGroupingMinDistance(botVillageID, 0.0);
			rmSetGroupingMaxDistance(botVillageID, 0.5);
			rmAddGroupingToClass(botVillageID, rmClassID("classNatives"));
			rmPlaceGroupingAtLoc(botVillageID, 0, 0.73, 0.3105);	
		}
		else
		{
			botVillageID = rmCreateGrouping("aztecs village 23001", "native aztec village " + 1);
			rmSetGroupingMinDistance(botVillageID, 0.0);
			rmSetGroupingMaxDistance(botVillageID, 0.5);
			rmAddGroupingToClass(botVillageID, rmClassID("classNatives"));
			rmPlaceGroupingAtLoc(botVillageID, 0, 0.73, 0.3);
			
			botVillageID = rmCreateGrouping("aztecs village 56001", "native jesuit mission borneo 0" + 1);
			rmSetGroupingMinDistance(botVillageID, 0.0);
			rmSetGroupingMaxDistance(botVillageID, 0.5);
			rmAddGroupingToClass(botVillageID, rmClassID("classNatives"));
			rmPlaceGroupingAtLoc(botVillageID, 0, 0.73, 0.7);	
		}
	
	}
	
	
	//bottom area......
	

	
	//...trees
	if(cNumberNonGaiaPlayers == 6)
	{
		numTries =  35;
	}
	else if(cNumberNonGaiaPlayers == 4)
	{
		numTries = 24;
	}
	else numTries = 20;
	failCount = 0;
	for (i=0; <numTries)
	{   
		forestbottomID = rmCreateArea("forestbottomID"+i);
		rmSetAreaWarnFailure(forestbottomID, false);
		rmSetAreaSize(forestbottomID, rmAreaTilesToFraction(290), rmAreaTilesToFraction(290));
		rmSetAreaForestType(forestbottomID, "Ceylon Forest");
		rmSetAreaForestDensity(forestbottomID, 0.85);
		rmSetAreaForestClumpiness(forestbottomID, 0.85);		
		rmSetAreaForestUnderbrush(forestbottomID, 0.45);
		rmSetAreaMinBlobs(forestbottomID, 1);
		rmSetAreaMaxBlobs(forestbottomID, 4);						
		rmSetAreaMinBlobDistance(forestbottomID, 5.0);
		rmSetAreaMaxBlobDistance(forestbottomID, 20.0);
		rmSetAreaCoherence(forestbottomID, 0.4);
		rmSetAreaSmoothDistance(forestbottomID, 10);
		rmAddAreaToClass(forestbottomID, rmClassID("classForest"));
		rmAddAreaConstraint(forestbottomID,	bottomConstraint);
		rmAddAreaConstraint(forestbottomID, forestConstraint);
		rmAddAreaConstraint(forestbottomID, avoidTownCenter);
		rmAddAreaConstraint(forestbottomID, avoidNativesClose);
		rmAddAreaConstraint(forestbottomID, worldEdgeConstraintCoin);

		if(rmBuildArea(forestbottomID)==false)
		{
			// Stop trying once we fail 5 times in a row.
			failCount++;
			if(failCount==10)
				break;
		}
		else
			failCount=0; 
	}
	
	//top area...
	//...trees
	if(cNumberNonGaiaPlayers == 6)
	{
		numTries = 35;
	}
	else if(cNumberNonGaiaPlayers == 4)
	{
		numTries = 24;
	}
	else numTries = 20;
	failCount = 0;
	for (i=0; <numTries)
	{   
		topTreeID = rmCreateArea("topTreeID"+i);
		rmSetAreaWarnFailure(topTreeID, false);
		rmSetAreaSize(topTreeID, rmAreaTilesToFraction(290), rmAreaTilesToFraction(290));
		rmSetAreaForestType(topTreeID, "Ceylon Forest");
		rmSetAreaForestDensity(topTreeID, 0.80);
		rmSetAreaForestClumpiness(topTreeID, 0.80);		
		rmSetAreaForestUnderbrush(topTreeID, 0.45);
		rmSetAreaMinBlobs(topTreeID, 1);
		rmSetAreaMaxBlobs(topTreeID, 4);						
		rmSetAreaMinBlobDistance(topTreeID, 5.0);
		rmSetAreaMaxBlobDistance(topTreeID, 20.0);
		rmSetAreaCoherence(topTreeID, 0.4);
		rmSetAreaSmoothDistance(topTreeID, 10);
		rmAddAreaToClass(topTreeID, rmClassID("classForest"));
		rmAddAreaConstraint(topTreeID, topConstraint);
		rmAddAreaConstraint(topTreeID, forestConstraint);
		rmAddAreaConstraint(topTreeID, avoidTownCenter);
		rmAddAreaConstraint(topTreeID, avoidNativesClose);
		rmAddAreaConstraint(topTreeID, worldEdgeConstraintCoin);
		if(rmBuildArea(topTreeID)==false)
		{
			// Stop trying once we fail 5 times in a row.
			failCount++;
			if(failCount==10)
				break;
		}
		else
			failCount=0; 
	}	
	
	//.....rebuild map after forest base terrain mix fucks everything up (lul)
	continent2 = rmCreateArea("continent2");	
	rmSetAreaSize(continent2, 1.0, 1.0);
	rmSetAreaLocation(continent2, 0.5, 0.5);
	rmSetAreaTerrainType(continent2, "yukon\ground3_yuk");
	rmSetAreaBaseHeight(continent2, 0.0);
	rmSetAreaCoherence(continent2, 1.0);
	rmSetAreaSmoothDistance(continent2, 10);
	rmSetAreaHeightBlend(continent2, 1);
	rmSetAreaElevationNoiseBias(continent2, 0);
	rmSetAreaElevationEdgeFalloffDist(continent2, 10);
	rmSetAreaElevationVariation(continent2, 5);
	rmSetAreaElevationPersistence(continent2, .2);
	rmSetAreaElevationOctaves(continent2, 5);
	rmSetAreaElevationMinFrequency(continent2, 0.04);
	rmSetAreaElevationType(continent2, cElevTurbulence);  
	rmBuildArea(continent2);  

	
	riverID2 = rmRiverCreate(-1, "Yellow River", 20, 1, 9, 5); // (x,y, a,b,c,d) a: height, b length or something, c radius of waypoints, d
	rmRiverAddWaypoint(riverID2, 0.5, 0.30);
	rmRiverAddWaypoint(riverID2, 0.5, 0.5);
	rmRiverAddWaypoint(riverID2, 0.5, 0.70);
	if(cNumberNonGaiaPlayers==2)
		rmRiverSetShallowRadius(riverID2, 40+cNumberNonGaiaPlayers);
	if(cNumberNonGaiaPlayers==4)
		rmRiverSetShallowRadius(riverID2, 40+cNumberNonGaiaPlayers);
	if(cNumberNonGaiaPlayers==6)
		rmRiverSetShallowRadius(riverID2, 53);	
	rmRiverAddShallow(riverID2, 0.5);	
	rmRiverBuild(riverID2);
	
	
	if(cNumberNonGaiaPlayers==6) //3vs3
	{
	
		//right River
		riverRightID2 = rmRiverCreate(-1, "Yellow River", 5, 1, 9.5, 5);
		rmRiverAddWaypoint(riverRightID2, 0.00, 0.12);
		
		rmRiverAddWaypoint(riverRightID2, 0.05, 0.13);
		
		rmRiverAddWaypoint(riverRightID2, 0.10, 0.14);
		rmRiverAddWaypoint(riverRightID2, 0.15, 0.16);
		rmRiverAddWaypoint(riverRightID2, 0.20, 0.18);	
	
		rmRiverAddWaypoint(riverRightID2, 0.25, 0.20);

		rmRiverAddWaypoint(riverRightID2, 0.25, 0.22);
		rmRiverAddWaypoint(riverRightID2, 0.30, 0.24);
		rmRiverAddWaypoint(riverRightID2, 0.35, 0.26);
		rmRiverAddWaypoint(riverRightID2, 0.40, 0.28);
		rmRiverAddWaypoint(riverRightID2, 0.45, 0.29);	
	
		rmRiverAddWaypoint(riverRightID2, 0.5, 0.30);
	
		rmRiverAddWaypoint(riverRightID2, 0.55, 0.29);	
		rmRiverAddWaypoint(riverRightID2, 0.60, 0.28);
		rmRiverAddWaypoint(riverRightID2, 0.65, 0.26);
		rmRiverAddWaypoint(riverRightID2, 0.70, 0.24);	
		rmRiverAddWaypoint(riverRightID2, 0.75, 0.22);
		rmRiverAddWaypoint(riverRightID2, 0.80, 0.20);
		rmRiverAddWaypoint(riverRightID2, 0.85, 0.18);
		rmRiverAddWaypoint(riverRightID2, 0.90, 0.16);	
		rmRiverAddWaypoint(riverRightID2, 0.95, 0.14);	
		rmRiverAddWaypoint(riverRightID2, 1, 0.12);
	

		rmRiverSetShallowRadius(riverRightID2, 10+cNumberNonGaiaPlayers);
		rmRiverAddShallow(riverRightID2, 0.38);	
		rmRiverAddShallow(riverRightID2, 0.62);	
		rmRiverAddShallow(riverRightID2, 0.845);	
		rmRiverAddShallow(riverRightID2, 0.15);	
		rmRiverBuild(riverRightID2);

	
		//left river
		riverLeftID2 = rmRiverCreate(-1, "Yellow River", 5, 1, 9.5, 5);

		rmRiverAddWaypoint(riverLeftID2, 0.0, 0.88);
	
	
		rmRiverAddWaypoint(riverLeftID2, 0.05, 0.87);
		rmRiverAddWaypoint(riverLeftID2, 0.10, 0.86);
		rmRiverAddWaypoint(riverLeftID2, 0.15, 0.84);
		rmRiverAddWaypoint(riverLeftID2, 0.20, 0.82);
		rmRiverAddWaypoint(riverLeftID2, 0.25, 0.80);
		rmRiverAddWaypoint(riverLeftID2, 0.30, 0.78);
		rmRiverAddWaypoint(riverLeftID2, 0.35, 0.76);
		rmRiverAddWaypoint(riverLeftID2, 0.40, 0.74);
		rmRiverAddWaypoint(riverLeftID2, 0.45, 0.72);
	
		rmRiverAddWaypoint(riverLeftID2, 0.5, 0.70);


		rmRiverAddWaypoint(riverLeftID2, 0.55, 0.71);
		rmRiverAddWaypoint(riverLeftID2, 0.60, 0.72);
		rmRiverAddWaypoint(riverLeftID2, 0.65, 0.76);
		rmRiverAddWaypoint(riverLeftID2, 0.70, 0.78);
		rmRiverAddWaypoint(riverLeftID2, 0.75, 0.80);
		rmRiverAddWaypoint(riverLeftID2, 0.80, 0.82);
		rmRiverAddWaypoint(riverLeftID2, 0.85, 0.84);
		rmRiverAddWaypoint(riverLeftID2, 0.90, 0.86);
		rmRiverAddWaypoint(riverLeftID2, 0.95, 0.87);
	
		rmRiverAddWaypoint(riverLeftID2, 1.0, 0.88);

		rmRiverSetShallowRadius(riverLeftID2, 10+cNumberNonGaiaPlayers);
		rmRiverAddShallow(riverLeftID2, 0.38);	
		rmRiverAddShallow(riverLeftID2, 0.62);	
		rmRiverAddShallow(riverLeftID2, 0.15);	
		rmRiverAddShallow(riverLeftID2, 0.845);	
		rmRiverBuild(riverLeftID2);
		}
	
		else // 2vs2, 1vs1
		{

		//right River
		riverRightID = rmRiverCreate(-1, "Yellow River", 5, 1, 9.5, 5);
		rmRiverAddWaypoint(riverRightID, 0.10, 0.00);
	
		rmRiverAddWaypoint(riverRightID, 0.15, 0.06);
		rmRiverAddWaypoint(riverRightID, 0.20, 0.11);
		rmRiverAddWaypoint(riverRightID, 0.25, 0.16);
		rmRiverAddWaypoint(riverRightID, 0.30, 0.20);
		rmRiverAddWaypoint(riverRightID, 0.35, 0.24);
		rmRiverAddWaypoint(riverRightID, 0.40, 0.27);
		rmRiverAddWaypoint(riverRightID, 0.45, 0.29);
	
		rmRiverAddWaypoint(riverRightID, 0.5, 0.30);
	
		rmRiverAddWaypoint(riverRightID, 0.55, 0.29);
		rmRiverAddWaypoint(riverRightID, 0.60, 0.27);
		rmRiverAddWaypoint(riverRightID, 0.65, 0.24);
		rmRiverAddWaypoint(riverRightID, 0.70, 0.20);
		rmRiverAddWaypoint(riverRightID, 0.75, 0.16);
		rmRiverAddWaypoint(riverRightID, 0.80, 0.11);
		rmRiverAddWaypoint(riverRightID, 0.85, 0.06);
	
		rmRiverAddWaypoint(riverRightID, 0.90, 0.0);
	

		rmRiverSetShallowRadius(riverRightID, 10+cNumberNonGaiaPlayers);
		rmRiverAddShallow(riverRightID, 0.35);	
		rmRiverAddShallow(riverRightID, 0.65);	
		rmRiverBuild(riverRightID);

	
	
		riverLeftID = rmRiverCreate(-1, "Yellow River", 5, 1, 9.5, 5);

		rmRiverAddWaypoint(riverLeftID, 0.10, 1.0);
	
		rmRiverAddWaypoint(riverLeftID, 0.15, 0.94);
		rmRiverAddWaypoint(riverLeftID, 0.20, 0.89);
		rmRiverAddWaypoint(riverLeftID, 0.25, 0.84);
		rmRiverAddWaypoint(riverLeftID, 0.30, 0.80);
		rmRiverAddWaypoint(riverLeftID, 0.35, 0.76);
		rmRiverAddWaypoint(riverLeftID, 0.40, 0.73);
		rmRiverAddWaypoint(riverLeftID, 0.45, 0.71);	
		
		rmRiverAddWaypoint(riverLeftID, 0.5, 0.70);

		rmRiverAddWaypoint(riverLeftID, 0.55, 0.71);
		rmRiverAddWaypoint(riverLeftID, 0.60, 0.73);
		rmRiverAddWaypoint(riverLeftID, 0.65,  0.76);
		rmRiverAddWaypoint(riverLeftID, 0.70, 0.80);
		rmRiverAddWaypoint(riverLeftID, 0.75, 0.84);
		rmRiverAddWaypoint(riverLeftID, 0.80, 0.89);
		rmRiverAddWaypoint(riverLeftID, 0.85, 0.94);
	
		rmRiverAddWaypoint(riverLeftID, 0.9, 1.0);

		rmRiverSetShallowRadius(riverLeftID, 10+cNumberNonGaiaPlayers);
		rmRiverAddShallow(riverLeftID, 0.35);	
		rmRiverAddShallow(riverLeftID, 0.65);	
		rmRiverBuild(riverLeftID);	
	}	

	
	//top area...
	
	//...mines
	topGold = rmCreateObjectDef("top Gold");
	rmAddObjectDefItem(topGold, "mine", 1, 0.0);
	rmSetObjectDefMinDistance(topGold, 0.0);
	rmSetObjectDefMaxDistance(topGold, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(topGold, avoidCoinMed);
	rmAddObjectDefConstraint(topGold, avoidRiver);
	rmAddObjectDefConstraint(topGold, avoidTownCenter);
	rmAddObjectDefConstraint(topGold, forestConstraintShort);
	rmAddObjectDefConstraint(topGold, avoidNativesClose);
	rmAddObjectDefConstraint(topGold, topConstraint);
	rmAddObjectDefConstraint(topGold, worldEdgeConstraintCoin);
	rmPlaceObjectDefAtLoc(topGold, 0, 0.5, 0.5, 2 * (cNumberNonGaiaPlayers));
	
	//...hunts		
	topHunt = rmCreateObjectDef("top Hunts");
	rmAddObjectDefItem(topHunt, "ypSerow", 13, 14.0);
	rmSetObjectDefCreateHerd(topHunt, true);
	rmSetObjectDefMinDistance(topHunt, 0);
	rmSetObjectDefMaxDistance(topHunt, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(topHunt, avoidTownCenterMore);
	rmAddObjectDefConstraint(topHunt, avoidHunt);
	rmAddObjectDefConstraint(topHunt, avoidRiver);
	rmAddObjectDefConstraint(topHunt, avoidNativesClose);
	rmAddObjectDefConstraint(topHunt, topConstraint);
	rmAddObjectDefConstraint(topHunt, worldEdgeConstraint);
	rmPlaceObjectDefAtLoc(topHunt, 0, 0.5, 0.5, 2*(cNumberNonGaiaPlayers/2)+1);
	
	
	//bottom area
	
	//...mines
	bottomGold = rmCreateObjectDef("bottom Gold");
	rmAddObjectDefItem(bottomGold, "mine", 1, 0.0);
	rmSetObjectDefMinDistance(bottomGold, 0.0);
	rmSetObjectDefMaxDistance(bottomGold, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(bottomGold, avoidCoinMed);
	rmAddObjectDefConstraint(bottomGold, avoidRiver);
	rmAddObjectDefConstraint(bottomGold, avoidTownCenter);
	rmAddObjectDefConstraint(bottomGold, forestConstraintShort);
	rmAddObjectDefConstraint(bottomGold, avoidNativesClose);
	rmAddObjectDefConstraint(bottomGold, bottomConstraint);
	rmAddObjectDefConstraint(bottomGold, worldEdgeConstraintCoin);
	rmPlaceObjectDefAtLoc(bottomGold, 0, 0.5, 0.5, 2 * (cNumberNonGaiaPlayers));
	
	//...hunts		
	bottomHunt = rmCreateObjectDef("bottom Hunts");
	rmAddObjectDefItem(bottomHunt, "ypSerow", 13, 14.0);
	rmSetObjectDefCreateHerd(bottomHunt, true);
	rmSetObjectDefMinDistance(bottomHunt, 0);
	rmSetObjectDefMaxDistance(bottomHunt, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(bottomHunt, avoidTownCenterMore);
	rmAddObjectDefConstraint(bottomHunt, avoidHunt);
	rmAddObjectDefConstraint(bottomHunt, avoidRiver);
	rmAddObjectDefConstraint(bottomHunt, avoidNativesClose);
	rmAddObjectDefConstraint(bottomHunt, bottomConstraint);
	rmAddObjectDefConstraint(bottomHunt, worldEdgeConstraint);
	rmPlaceObjectDefAtLoc(bottomHunt, 0, 0.5, 0.5, 2*(cNumberNonGaiaPlayers/2)+1);
	
	if(cNumberNonGaiaPlayers == 2)
	{
		//nothing yet...maybe only a single nat?
	}
	if(cNumberNonGaiaPlayers == 4)
	{
		if(spawnSwitch4 <= 0.6)
		{
			botVillageID = rmCreateGrouping("aztecs village 4401", "native jesuit mission borneo 0" + 2);
			rmSetGroupingMinDistance(botVillageID, 0.0);
			rmSetGroupingMaxDistance(botVillageID, 0.5);
			rmAddGroupingToClass(botVillageID, rmClassID("classNatives"));
			rmPlaceGroupingAtLoc(botVillageID, 0, 0.5, 0.05);
			
			botVillageID = rmCreateGrouping("aztecs village 2301", "native aztec village " + 2);
			rmSetGroupingMinDistance(botVillageID, 0.0);
			rmSetGroupingMaxDistance(botVillageID, 0.5);
			rmAddGroupingToClass(botVillageID, rmClassID("classNatives"));
			rmPlaceGroupingAtLoc(botVillageID, 0, 0.5, 0.97);
			
		}
		else
		{
			botVillageID = rmCreateGrouping("aztecs village 4402", "native jesuit mission borneo 0" + 2);
			rmSetGroupingMinDistance(botVillageID, 0.0);
			rmSetGroupingMaxDistance(botVillageID, 0.5);
			rmAddGroupingToClass(botVillageID, rmClassID("classNatives"));
			rmPlaceGroupingAtLoc(botVillageID, 0, 0.5, 0.955);
			//4
			botVillageID = rmCreateGrouping("aztecs village 2302", "native aztec village " + 1);
			rmSetGroupingMinDistance(botVillageID, 0.0);
			rmSetGroupingMaxDistance(botVillageID, 0.5);
			rmAddGroupingToClass(botVillageID, rmClassID("classNatives"));
			rmPlaceGroupingAtLoc(botVillageID, 0, 0.5, 0.055);
		}
	}
	if(cNumberNonGaiaPlayers == 6)
	{
		if(spawnSwitch4 <= 0.6)
		{
			botVillageID = rmCreateGrouping("aztecs village 4401", "native jesuit mission borneo 0" + 2);
			rmSetGroupingMinDistance(botVillageID, 0.0);
			rmSetGroupingMaxDistance(botVillageID, 0.5);
			rmAddGroupingToClass(botVillageID, rmClassID("classNatives"));
			rmPlaceGroupingAtLoc(botVillageID, 0, 0.44, 0.045);
			
			botVillageID = rmCreateGrouping("aztecs village 2301", "native aztec village " + 2);
			rmSetGroupingMinDistance(botVillageID, 0.0);
			rmSetGroupingMaxDistance(botVillageID, 0.5);
			rmAddGroupingToClass(botVillageID, rmClassID("classNatives"));
			rmPlaceGroupingAtLoc(botVillageID, 0, 0.435, 0.97);
		}
		else
		{
			botVillageID = rmCreateGrouping("aztecs village 4402", "native jesuit mission borneo 0" + 4);
			rmSetGroupingMinDistance(botVillageID, 0.0);
			rmSetGroupingMaxDistance(botVillageID, 0.5);
			rmAddGroupingToClass(botVillageID, rmClassID("classNatives"));
			rmPlaceGroupingAtLoc(botVillageID, 0, 0.44, 0.955);
			
			botVillageID = rmCreateGrouping("aztecs village 2302", "native aztec village " + 1);
			rmSetGroupingMinDistance(botVillageID, 0.0);
			rmSetGroupingMaxDistance(botVillageID, 0.5);
			rmAddGroupingToClass(botVillageID, rmClassID("classNatives"));
			rmPlaceGroupingAtLoc(botVillageID, 0, 0.435, 0.042);
		}
		
		if(spawnSwitch5 <= 0.6)
		{
			botVillageID = rmCreateGrouping("aztecs village 4403", "native jesuit mission borneo 0" + 2);
			rmSetGroupingMinDistance(botVillageID, 0.0);
			rmSetGroupingMaxDistance(botVillageID, 0.5);
			rmAddGroupingToClass(botVillageID, rmClassID("classNatives"));
			rmPlaceGroupingAtLoc(botVillageID, 0, 0.565, 0.05);
			
			botVillageID = rmCreateGrouping("aztecs village 2303", "native aztec village " + 2);
			rmSetGroupingMinDistance(botVillageID, 0.0);
			rmSetGroupingMaxDistance(botVillageID, 0.5);
			rmAddGroupingToClass(botVillageID, rmClassID("classNatives"));
			rmPlaceGroupingAtLoc(botVillageID, 0, 0.56, 0.97);			
		}
		else
		{
			botVillageID = rmCreateGrouping("aztecs village 4404", "native jesuit mission borneo 0" + 4);
			rmSetGroupingMinDistance(botVillageID, 0.0);
			rmSetGroupingMaxDistance(botVillageID, 0.5);
			rmAddGroupingToClass(botVillageID, rmClassID("classNatives"));
			rmPlaceGroupingAtLoc(botVillageID, 0, 0.565, 0.955);
			//4
			botVillageID = rmCreateGrouping("aztecs village 2304", "native aztec village " + 1);
			rmSetGroupingMinDistance(botVillageID, 0.0);
			rmSetGroupingMaxDistance(botVillageID, 0.5);
			rmAddGroupingToClass(botVillageID, rmClassID("classNatives"));
			rmPlaceGroupingAtLoc(botVillageID, 0, 0.56, 0.042);
		}
	}
	

// op trigs for nats

for(i=1; <cNumberPlayers){
	rmCreateTrigger("_NiceKING_"+i);
    rmSwitchToTrigger(rmTriggerID("_NiceKING_"+i));
 rmSetTriggerPriority(4);
    rmSetTriggerActive(true);
    rmSetTriggerRunImmediately(true);
    rmSetTriggerLoop(false);   
    rmAddTriggerCondition("Always");  
  rmAddTriggerEffect("Modify Protounit");
    rmSetTriggerEffectParam("ProtoUnit", "NatEagleWarrior");
    rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 10);
    rmSetTriggerEffectParamInt("Delta", -2);
rmAddTriggerEffect("Modify Protounit");
    rmSetTriggerEffectParam("ProtoUnit", "NatJaguarWarrior");
    rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 10);
    rmSetTriggerEffectParamInt("Delta", -2);
rmAddTriggerEffect("Modify Protounit");
    rmSetTriggerEffectParam("ProtoUnit", "ypNatConquistador");
    rmSetTriggerEffectParamInt("PlayerID", i);
	rmSetTriggerEffectParamInt("Field", 10);
    rmSetTriggerEffectParamInt("Delta", -6);


}

	//right area.....
	
	//...trees
	for (j=0; < (2*cNumberNonGaiaPlayers)) {   
		mapTrees=rmCreateObjectDef("right trees"+j);
		rmAddObjectDefItem(mapTrees, "ypTreeCeylon", rmRandInt(14,16), rmRandFloat(14.0,20.0));
		rmAddObjectDefToClass(mapTrees, rmClassID("classForest")); 
		rmSetObjectDefMinDistance(mapTrees, 0);
		rmSetObjectDefMaxDistance(mapTrees, rmXFractionToMeters(0.45));
		rmAddObjectDefConstraint(mapTrees, forestConstraint);
		rmAddObjectDefConstraint(mapTrees, avoidNativesClose);
		rmAddObjectDefConstraint(mapTrees, rightConstraint);	
		rmAddObjectDefConstraint(mapTrees, avoidRiver);
		rmPlaceObjectDefAtLoc(mapTrees, 0, 0.5, 0.5, 5*cNumberNonGaiaPlayers);
	}

	
	//left area.....
	
	//...trees
	for (j=0; < (2*cNumberNonGaiaPlayers)) {   
		mapTrees=rmCreateObjectDef("left trees"+j);
		rmAddObjectDefItem(mapTrees, "ypTreeCeylon", rmRandInt(14,16), rmRandFloat(14.0,20.0));
		rmAddObjectDefToClass(mapTrees, rmClassID("classForest")); 
		rmSetObjectDefMinDistance(mapTrees, 0);
		rmSetObjectDefMaxDistance(mapTrees, rmXFractionToMeters(0.45));
		rmAddObjectDefConstraint(mapTrees, forestConstraint);
		rmAddObjectDefConstraint(mapTrees, avoidNativesClose);
		rmAddObjectDefConstraint(mapTrees, leftConstraint);	
		rmAddObjectDefConstraint(mapTrees, avoidRiver);
		rmPlaceObjectDefAtLoc(mapTrees, 0, 0.5, 0.5, 5*cNumberNonGaiaPlayers);
	}
	
	
	//treasures
	spawnTreasure = rmCreateObjectDef("nugget25"); 
	rmAddObjectDefItem(spawnTreasure, "Nugget", 1, 0.0); 
	rmSetObjectDefMinDistance(spawnTreasure, 0.0); 
	rmSetObjectDefMaxDistance(spawnTreasure, rmXFractionToMeters(0.5)); 
	rmAddObjectDefConstraint(spawnTreasure, avoidNugget); 
	rmAddObjectDefConstraint(spawnTreasure, avoidTownCenter);
	rmAddObjectDefConstraint(spawnTreasure, forestConstraintShort);
	rmAddObjectDefConstraint(spawnTreasure, avoidRiver); 
	rmAddObjectDefConstraint(spawnTreasure, avoidNativesClose);
	rmAddObjectDefConstraint(spawnTreasure, worldEdgeConstraintCoin);
	rmSetNuggetDifficulty(1,1); 
	rmPlaceObjectDefAtLoc(spawnTreasure, 0, 0.5, 0.5, 6*cNumberNonGaiaPlayers);  
	
	
}



	/*
	river designs
	---U: first one---	
	riverID = rmRiverCreate(-1, "Yellow River", 50, 1, 9, 5); // (x,y, a,b,c,d) a: height, b length or something, c radius of waypoints, d
	rmRiverAddWaypoint(riverID, 0.5, 0.30);
	rmRiverAddWaypoint(riverID, 0.5, 0.5);
	rmRiverAddWaypoint(riverID, 0.5, 0.70);
	rmRiverSetShallowRadius(riverID, 30+cNumberNonGaiaPlayers);
	rmRiverAddShallow(riverID, 0.5);	
	rmRiverBuild(riverID);
	


	//right River
	riverRightID = rmRiverCreate(-1, "Yellow River", 5, 1, 9.5, 5);
	rmRiverAddWaypoint(riverRightID, 0.10, 0.00);
	
	rmRiverAddWaypoint(riverRightID, 0.15, 0.06);
	rmRiverAddWaypoint(riverRightID, 0.20, 0.11);
	rmRiverAddWaypoint(riverRightID, 0.25, 0.16);
	rmRiverAddWaypoint(riverRightID, 0.30, 0.20);
	rmRiverAddWaypoint(riverRightID, 0.35, 0.24);
	rmRiverAddWaypoint(riverRightID, 0.40, 0.27);
	rmRiverAddWaypoint(riverRightID, 0.45, 0.29);
	
	
	rmRiverAddWaypoint(riverRightID, 0.5, 0.30);
	
	rmRiverAddWaypoint(riverRightID, 0.55, 0.29);
	rmRiverAddWaypoint(riverRightID, 0.60, 0.27);
	rmRiverAddWaypoint(riverRightID, 0.65, 0.24);
	rmRiverAddWaypoint(riverRightID, 0.70, 0.20);
	rmRiverAddWaypoint(riverRightID, 0.75, 0.16);
	rmRiverAddWaypoint(riverRightID, 0.80, 0.11);
	rmRiverAddWaypoint(riverRightID, 0.85, 0.06);
	
	rmRiverAddWaypoint(riverRightID, 0.90, 0.0);
	

	rmRiverSetShallowRadius(riverRightID, 10+cNumberNonGaiaPlayers);
	rmRiverAddShallow(riverRightID, 0.35);	
	rmRiverAddShallow(riverRightID, 0.65);	
	rmRiverBuild(riverRightID);

	riverLeftID = rmRiverCreate(-1, "Yellow River", 5, 1, 9.5, 5);

	rmRiverAddWaypoint(riverLeftID, 0.10, 1.0);
	
	rmRiverAddWaypoint(riverLeftID, 0.15, 0.94);
	rmRiverAddWaypoint(riverLeftID, 0.20, 0.89);
	rmRiverAddWaypoint(riverLeftID, 0.25, 0.84);
	rmRiverAddWaypoint(riverLeftID, 0.30, 0.80);
	rmRiverAddWaypoint(riverLeftID, 0.35, 0.76);
	rmRiverAddWaypoint(riverLeftID, 0.40, 0.73);
	rmRiverAddWaypoint(riverLeftID, 0.45, 0.71);	
	
	rmRiverAddWaypoint(riverLeftID, 0.5, 0.70);

	rmRiverAddWaypoint(riverLeftID, 0.55, 0.71);
	rmRiverAddWaypoint(riverLeftID, 0.60, 0.73);
	rmRiverAddWaypoint(riverLeftID, 0.65,  0.76);
	rmRiverAddWaypoint(riverLeftID, 0.70, 0.80);
	rmRiverAddWaypoint(riverLeftID, 0.75, 0.84);
	rmRiverAddWaypoint(riverLeftID, 0.80, 0.89);
	rmRiverAddWaypoint(riverLeftID, 0.85, 0.94);
	
	rmRiverAddWaypoint(riverLeftID, 0.9, 1.0);

	rmRiverSetShallowRadius(riverLeftID, 10+cNumberNonGaiaPlayers);
	rmRiverAddShallow(riverLeftID, 0.35);	
	rmRiverAddShallow(riverLeftID, 0.65);	
	rmRiverBuild(riverLeftID);	
	-------
	*/
