/*
Map made by Gichtenlord.
*/
include "mercenaries.xs";
include "ypAsianInclude.xs";
include "ypKOTHInclude.xs";

void main(void)
{
	/*
	================
	custom variables
	================
	*/
	
	int numTries = 25;
	int failCount = -1;	
	int playerTiles=17500;
	float worldEdgeDistance = -1; //distance from herds to world's edge. The bigger the map, the closer you can set the distance to the world edge. Map size is relative to distance from world edge for hunts
	if(cNumberNonGaiaPlayers == 4) //2vs2
		worldEdgeDistance = 0.435;
	if(cNumberNonGaiaPlayers == 6) //3vs3
	{
		worldEdgeDistance = 0.465;
	}
		
	else 						   //1vs1
		worldEdgeDistance = 0.430;
	
	//nats(incas)
	int subCiv0=-1;
	int subCiv1=-1;
	int subCiv2=-1;
	int subCiv3=-1;
	


	
	if (rmAllocateSubCivs(4) == true)
	{
		subCiv0=rmGetCivID("Incas");
		if (subCiv0 >= 0)
			rmSetSubCiv(0, "Incas");
		
		subCiv1=rmGetCivID("Incas");
		if (subCiv1 >= 0)
			rmSetSubCiv(1, "Incas");

		subCiv2=rmGetCivID("Incas");
		if (subCiv2 >= 0)
			rmSetSubCiv(2, "Incas");

		subCiv3=rmGetCivID("Incas");
		if (subCiv3 >= 0)
			rmSetSubCiv(3, "Incas");
	}

	
	int size = 2.0 * sqrt(cNumberNonGaiaPlayers*playerTiles);
	rmSetMapSize(size, size);
	
	//default terrain + lightning
	rmSetMapType("land");
    rmSetMapType("grass");
    rmSetMapType("newEngland");
    rmTerrainInitialize("grass");
	rmSetLightingSet("saguenay");

	
	//Define custom classes
    rmDefineClass("classForest");
	rmDefineClass("classPlateau");
	rmDefineClass("classBlob");
	rmDefineClass("classNatives");
	rmDefineClass("classCliffAvoidTree");
	rmDefineClass("classCliffAvoidTreeShort");
	rmDefineClass("classCliffsAvoid");
	rmDefineClass("classCliffsAvoid2");
	rmDefineClass("classCliffsAvoid3");	
	
	/*
	======================
	Define constraints...
	======================
	*/
	
	//...ressources
	int forestConstraint = rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 28.5);
	int forestConstraintThick = rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 28.0);
    int forestConstraintShort = rmCreateClassDistanceConstraint("object vs. forest", rmClassID("classForest"), 4.0);
	int forestConstraintSmaller = rmCreateClassDistanceConstraint("object vs. forest", rmClassID("classForest"), 29.0);
	
	int avoidHerd = rmCreateTypeDistanceConstraint("herds avoid herds", "herdable", 50.0);
	int avoidHunt = rmCreateTypeDistanceConstraint("hunts avoid hunts", "huntable", 50.0);
	int avoidLlama= rmCreateTypeDistanceConstraint("llama avoids llama", "Llama", 50.0);
	
	int avoidCoin = rmCreateTypeDistanceConstraint("avoid coin", "Mine", 10.0);
	int avoidCoinTree = rmCreateTypeDistanceConstraint("coin vs tree", "Mine", 15.0);
	int avoidCoinCliff = rmCreateTypeDistanceConstraint("coin vs cliff", "Mine", 30.0);
    int avoidCoinMed = rmCreateTypeDistanceConstraint("avoid coin medium", "Mine", 60.0);
	
	//...objects
	int avoidTradeRouteSmall = rmCreateTradeRouteDistanceConstraint("objects avoid trade route small", 8.0);
    int avoidSocket = rmCreateClassDistanceConstraint("socket avoidance", rmClassID("socketClass"), 12.0);
	int avoidSocketMed = rmCreateClassDistanceConstraint("socket avoidance", rmClassID("socketClass"), 16.0);
	int avoidSocketTC = rmCreateClassDistanceConstraint("socket avoidance", rmClassID("socketClass"), 90.0);
        
	int avoidTownCenterClose = rmCreateTypeDistanceConstraint("avoid Town Center small", "townCenter", 10.0);	
    int avoidTownCenterSmall = rmCreateTypeDistanceConstraint("avoid Town Center small", "townCenter", 15.0);
	int avoidTownCenterForest = rmCreateTypeDistanceConstraint("avoid Town Center small", "townCenter", 25.0);
	int avoidTownCenter = rmCreateTypeDistanceConstraint("avoid Town Center", "townCenter", 35.0);
    int avoidTownCenterMore = rmCreateTypeDistanceConstraint("avoid Town Center more", "townCenter", 40.0); 
	int avoidTownCenterSupaFar = rmCreateTypeDistanceConstraint("avoid Town Center supa far", "townCenter", 80.0);
	
	
	int avoidNativesClose = rmCreateClassDistanceConstraint("stuff vs nats", rmClassID("classNatives"), 10.0);
	int avoidNativesMed = rmCreateClassDistanceConstraint("stuff vs nats", rmClassID("classNatives"), 16.0);
	
	int avoidIncaSocket = rmCreateTypeDistanceConstraint("cliffs vs incasocket", "socketinca", 24.0);
	int avoidIncaSocketTC = rmCreateTypeDistanceConstraint("towncenter vs incasocket", "socketinca", 90.0);
	
	
	
	
	//...cliffs
	int avoidPlateau = rmCreateClassDistanceConstraint("stuff vs. cliffs", rmClassID("classPlateau"), 16.0);
	int avoidPlateauLong = rmCreateClassDistanceConstraint("stuff vs cliffs far", rmClassID("classPlateau"), 40);
	int cliffAvoidCliff = rmCreateClassDistanceConstraint("cliff vs. cliff", rmClassID("classPlateau"), 30.5); // 35.0
	
	float avoidTreeLine = -1;
	float avoidTreeShort = -1;
	if(cNumberNonGaiaPlayers == 6)
	{ 
		avoidTreeLine = 23.0;
		avoidTreeShort = 17.5;
	}
	else
	{
		avoidTreeLine = 23.0;
		avoidTreeShort = 15.5;
	}
	int cliffAvoidTreeline = rmCreateClassDistanceConstraint("cliff vs trees", rmClassID("classCliffAvoidTree"), avoidTreeLine);
	int cliffAvoidTreelineShort = rmCreateClassDistanceConstraint("cliff vs trees2", rmClassID("classCliffAvoidTreeShort"), avoidTreeShort);
	
	int avoidCircle = rmCreateClassDistanceConstraint("invisible obstacle vs cliffs", rmClassID("classCliffsAvoid"), 50.0);// 20.5
	int avoidCircleShort = rmCreateClassDistanceConstraint("invisible obstacle vs cliffs", rmClassID("classCliffsAvoid2"), 17.5);
	int avoidCircleFar = rmCreateClassDistanceConstraint("invisible obstacle vs cliffs", rmClassID("classCliffsAvoid3"), 30.0);
	
	int avoidCinematic = rmCreateTypeDistanceConstraint("avoid Block", "CinematicBlock", 100.0);
	
	
	
	//...treasures(=nuggets)
	int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "AbstractNugget", 60.0);
	
	//...all
	int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 8.0);
	int mediumShortAvoidImpassableLand = rmCreateTerrainDistanceConstraint("mediumshort avoid impassable land", "Land", false, 8.0);
	
	//...player	
	
	//...map dividing
	int bottomConstraint = -1;
	int routeConstraint = -1;
	int topConstraint = -1;	
	float cliffStartPointZ = -1;
	int cliffRadiusBegin = -1;
	
	if(cNumberNonGaiaPlayers == 4)
	{
		cliffStartPointZ = 0.55;
		cliffRadiusBegin = 313;
	}
	else 
	{
		cliffRadiusBegin = 305;
		cliffStartPointZ = 0.60;
	}
	
	
	
	if(cNumberNonGaiaPlayers == 4 || cNumberNonGaiaPlayers == 2)
	{
		routeConstraint = rmCreatePieConstraint("route Constraint", 0.5, 0.4, 0, rmZFractionToMeters(0.6), rmDegreesToRadians(140), rmDegreesToRadians(235));
		bottomConstraint = rmCreatePieConstraint("bottom Constraint", 0.5, 0.6, 0, rmZFractionToMeters(0.6), rmDegreesToRadians(215), rmDegreesToRadians(305));
		topConstraint = rmCreatePieConstraint("top Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.6), rmDegreesToRadians(45), rmDegreesToRadians(145));
	}
	else if(cNumberNonGaiaPlayers == 6)
	{
		routeConstraint = rmCreatePieConstraint("route Constraint", 0.5, 0.4, 0, rmZFractionToMeters(0.6), rmDegreesToRadians(143), rmDegreesToRadians(222));
		bottomConstraint = rmCreatePieConstraint("bottom Constraint", 0.5, 0.6, 0, rmZFractionToMeters(0.68), rmDegreesToRadians(208), rmDegreesToRadians(305));	
		topConstraint = rmCreatePieConstraint("top Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.6), rmDegreesToRadians(35), rmDegreesToRadians(147));
	}

	int cliffConstraint = rmCreatePieConstraint("cliff Constraint", 0.5, cliffStartPointZ, 0, rmZFractionToMeters(0.6), rmDegreesToRadians(cliffRadiusBegin), rmDegreesToRadians(46));
	int worldEdgeConstraint = rmCreatePieConstraint("world Constraint", 0.5, 0.5, 0, rmZFractionToMeters(worldEdgeDistance), rmDegreesToRadians(0), rmDegreesToRadians(360));
	int worldEdgeConstraintCoin = rmCreatePieConstraint("world Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.98), rmDegreesToRadians(0), rmDegreesToRadians(360));
	
	
	
	
	
	/*
	===============
	spawnpositions
	===============
	*/
	
	float spawnSwitch = rmRandFloat(0,1.2);
	
	

		if(cNumberNonGaiaPlayers == 4)
		{
			if (spawnSwitch <=0.6)
			{
				rmSetPlacementTeam(0);
				rmPlacePlayersLine(0.148, 0.36, 0.148, 0.535, 0, 0);
				rmSetPlacementTeam(1);
				rmPlacePlayersLine(0.852, 0.535, 0.852, 0.36, 0, 0);
			}
			else if(spawnSwitch <=1.2)
			{
				rmSetPlacementTeam(1);
				rmPlacePlayersLine(0.152, 0.36, 0.152, 0.535, 0, 0);
				rmSetPlacementTeam(0);
				rmPlacePlayersLine(0.848, 0.535, 0.848, 0.36, 0, 0);
			}
		}
		else if(cNumberNonGaiaPlayers == 2)
		{
			if(spawnSwitch <= 0.6)
			{
				rmPlacePlayer(1, 0.185, 0.46);
				rmPlacePlayer(2, 0.81, 0.47);
			}
			else if(spawnSwitch <= 1.2)
			{
				rmPlacePlayer(2, 0.18, 0.46);
				rmPlacePlayer(1, 0.81, 0.47);
			}
		}
		if(cNumberNonGaiaPlayers == 6)
		{
		if (spawnSwitch <=0.6)
			{
				rmSetPlacementTeam(0);
				rmPlacePlayersLine(0.14, 0.32, 0.135, 0.58, 0, 0);
				rmSetPlacementTeam(1);
				rmPlacePlayersLine(0.865, 0.58, 0.86, 0.32, 0, 0);
			}
			else if(spawnSwitch <=1.2)
			{
				rmSetPlacementTeam(1);
				rmPlacePlayersLine(0.14, 0.32, 0.135, 0.58, 0, 0);
				rmSetPlacementTeam(0);
				rmPlacePlayersLine(0.865, 0.58, 0.86, 0.32, 0, 0);
			}
		}

	
	else //ffa
	{
		rmPlacePlayersCircular(0.4, 0.4, 0.02);
	}
		

	
	/*
	=====================================
	initialize terrain and global objects
	=====================================
	*/
	
	//mercs
	chooseMercs();	
	
	//ground map
	int continent2 = rmCreateArea("continent");
    rmSetAreaSize(continent2, 1.0, 1.0);
    rmSetAreaLocation(continent2, 0.5, 0.5);
	//rmAddAreaToClass(continent2, "classCliffsAvoid");
    rmSetAreaTerrainType(continent2, "new_england\ground2_ne");
    rmSetAreaBaseHeight(continent2, 0.0);
    rmSetAreaCoherence(continent2, 1.0);
    rmSetAreaSmoothDistance(continent2, 10);
    rmSetAreaHeightBlend(continent2, 1);
    rmSetAreaElevationNoiseBias(continent2, 0);
    rmSetAreaElevationEdgeFalloffDist(continent2, 10);
    rmSetAreaElevationVariation(continent2, 5);
    rmSetAreaElevationPersistence(continent2, .2);
    rmSetAreaElevationOctaves(continent2, 5);
    rmSetAreaElevationMinFrequency(continent2, 0.04);
    rmSetAreaElevationType(continent2, cElevTurbulence);  
    rmBuildArea(continent2);  
	
	/*
	=====================================
			/Cliffs constraints
	=====================================
	*/	


	
	/*
	====================================
			Cliffs constraints/
	====================================
	*/
	
	//traderoute...
	//...create route
	int socketID = rmCreateObjectDef("sockets to dock Trade Posts");
	rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
	rmSetObjectDefAllowOverlap(socketID, true);
    rmSetObjectDefMinDistance(socketID, 0.0);
    rmSetObjectDefMaxDistance(socketID, 7.0); 
	
	int tradeRouteID = rmCreateTradeRoute();
	rmSetObjectDefTradeRouteID(socketID, tradeRouteID);
	
	if(cNumberNonGaiaPlayers == 4 || cNumberNonGaiaPlayers == 2) //2vs2 and 1vs1 same style
	{
		rmAddTradeRouteWaypoint(tradeRouteID, .13, .10);
		rmAddTradeRouteWaypoint(tradeRouteID, .45, .42);	
		rmAddTradeRouteWaypoint(tradeRouteID, .52, .42);
		rmAddTradeRouteWaypoint(tradeRouteID, .85, .10);
	} 
	else if(cNumberNonGaiaPlayers == 6) //3vs3
	{
		rmAddTradeRouteWaypoint(tradeRouteID, .10, .14);
		rmAddTradeRouteWaypoint(tradeRouteID, .47, .315);	
		rmAddTradeRouteWaypoint(tradeRouteID, .53, .315);
		rmAddTradeRouteWaypoint(tradeRouteID, .87, .12);
	} 
	
	
		
	rmBuildTradeRoute(tradeRouteID, "dirt"); 
	
	//...place sockets
	vector socketLoc1 = rmGetTradeRouteWayPoint(tradeRouteID, 0.13);
    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc1);       
    socketLoc1 = rmGetTradeRouteWayPoint(tradeRouteID, 0.33);
    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc1); 
	if(cNumberNonGaiaPlayers == 6)
	{
		socketLoc1 = rmGetTradeRouteWayPoint(tradeRouteID, 0.48);
		rmPlaceObjectDefAtPoint(socketID, 0, socketLoc1);
	}
	else if(cNumberNonGaiaPlayers == 4)
	{
		socketLoc1 = rmGetTradeRouteWayPoint(tradeRouteID, 0.5);
		rmPlaceObjectDefAtPoint(socketID, 0, socketLoc1);
	}
	else
	{
		socketLoc1 = rmGetTradeRouteWayPoint(tradeRouteID, 0.49);
		rmPlaceObjectDefAtPoint(socketID, 0, socketLoc1);
	}	
	socketLoc1 = rmGetTradeRouteWayPoint(tradeRouteID, 0.67);
	rmPlaceObjectDefAtPoint(socketID, 0, socketLoc1);
	socketLoc1 = rmGetTradeRouteWayPoint(tradeRouteID, 0.87);
	rmPlaceObjectDefAtPoint(socketID, 0, socketLoc1);
	
	
	
	//natives...
	//...creategrouping
	if (subCiv0 == rmGetCivID("Incas"))
	{  
		int incaVillageAID = -1;
		incaVillageAID = rmCreateGrouping("back inca village", "native inca village "+1);
		rmSetGroupingMinDistance(incaVillageAID, 0.0);
		rmSetGroupingMaxDistance(incaVillageAID, 0.20);
		rmAddGroupingToClass(incaVillageAID, rmClassID("classNatives"));
		rmAddGroupingConstraint(incaVillageAID, avoidNativesMed);
		rmPlaceGroupingAtLoc(incaVillageAID, 0, 0.75, 0.70);
	}
	
	
	if (subCiv1 == rmGetCivID("Incas"))
	{  
		int incavillageBID = -1;
		incavillageBID = rmCreateGrouping("left city", "native inca village "+2);
		rmSetGroupingMinDistance(incavillageBID, 0.0);
		rmSetGroupingMaxDistance(incavillageBID, 20.0);
		rmAddGroupingToClass(incavillageBID, rmClassID("classNatives"));
		rmAddGroupingConstraint(incavillageBID, avoidNativesMed);
		rmPlaceGroupingAtLoc(incavillageBID, 0, 0.85, 0.79);
	}

	if (subCiv2 == rmGetCivID("Incas"))
	{  
		int incavillageCID = -1;
		incavillageCID = rmCreateGrouping("right city", "native inca village "+3);
		rmSetGroupingMinDistance(incavillageCID, 0.0);
		rmSetGroupingMaxDistance(incavillageCID, 20.0);
		rmAddGroupingToClass(incavillageCID, rmClassID("classNatives"));
		rmAddGroupingConstraint(incavillageCID, avoidNativesMed);
		rmPlaceGroupingAtLoc(incavillageCID, 0, 0.15, 0.79);
	}


	if (subCiv3 == rmGetCivID("Incas"))
	{  
		int incavillageDID = -1;
		incavillageDID = rmCreateGrouping("front city", "native inca village "+4);
		rmSetGroupingMinDistance(incavillageDID, 0.0);
		rmSetGroupingMaxDistance(incavillageDID, 20.0);
		rmAddGroupingToClass(incavillageDID, rmClassID("classNatives"));
		rmAddGroupingConstraint(incavillageDID, avoidNativesMed);
		if(cNumberNonGaiaPlayers == 2)
		{
			rmPlaceGroupingAtLoc(incavillageDID, 0, 0.26, 0.71);
		}
		else
		{
			rmPlaceGroupingAtLoc(incavillageDID, 0, 0.25, 0.72);
		}
		
	}
	
	
	float co = 0.15;
	int treeBlockID = -1;
	for(i = 0; <20)
	{
		co = 0.05 + co;

		treeBlockID = rmCreateObjectDef("avoid treeline X"+i); 
		rmAddObjectDefItem(treeBlockID, "treeNewEngland", 1, 3.0);
		rmSetObjectDefMinDistance(treeBlockID, 2.0);
		rmSetObjectDefMaxDistance(treeBlockID, 3.0);
		rmAddObjectDefToClass(treeBlockID, rmClassID("classCliffAvoidTree"));
		rmAddObjectDefConstraint(treeBlockID, cliffConstraint);
		rmPlaceObjectDefAtLoc(treeBlockID, 0, co, 0.82, 1);
	}
	
	float do = 0.88;
	int treeBlockID2 = -1;
	for(i = 0; <15)
	{
		do = do - 0.04;

		treeBlockID2 = rmCreateObjectDef("avoid treeline Z"+i); 
		rmAddObjectDefItem(treeBlockID2, "treeNewEngland", 1, 3.0);
		rmSetObjectDefMinDistance(treeBlockID2, 2.0);
		rmSetObjectDefMaxDistance(treeBlockID2, 3.0);
		rmAddObjectDefToClass(treeBlockID2, rmClassID("classCliffAvoidTreeShort"));
		rmAddObjectDefConstraint(treeBlockID2, cliffConstraint);
		rmPlaceObjectDefAtLoc(treeBlockID2, 0, 0.495, do, 1);
	}
	
	int treeBlockID3 = -1;
	float eo = 0.95;
	for(i = 0; <5)
	{
		eo = eo - 0.02;

		treeBlockID3 = rmCreateObjectDef("avoid treeline D"+i); 
		rmAddObjectDefItem(treeBlockID3, "treeNewEngland", 1, 3.0);
		rmSetObjectDefMinDistance(treeBlockID3, 2.0);
		rmSetObjectDefMaxDistance(treeBlockID3, 3.0);
		rmAddObjectDefToClass(treeBlockID3, rmClassID("classCliffAvoidTreeShort"));
		rmAddObjectDefConstraint(treeBlockID3, cliffConstraint);
		rmPlaceObjectDefAtLoc(treeBlockID3, 0, 0.31, eo, 1);
	}
	
	int treeBlockID4 = -1;
	float fo = 0.95;
	for(i = 0; <5)
	{
		fo = fo - 0.02;
		treeBlockID4 = rmCreateObjectDef("avoid treeline B"+i); 
		rmAddObjectDefItem(treeBlockID4, "treeNewEngland", 1, 3.0);
		rmSetObjectDefMinDistance(treeBlockID4, 2.0);
		rmSetObjectDefMaxDistance(treeBlockID4, 3.0);
		rmAddObjectDefToClass(treeBlockID4, rmClassID("classCliffAvoidTreeShort"));
		rmAddObjectDefConstraint(treeBlockID4, cliffConstraint);
		rmPlaceObjectDefAtLoc(treeBlockID4, 0, 0.67, fo, 1);
	}
	
	
	
	numTries = 25;
	for(i=0; <numTries)
	{
		int cliffID=rmCreateArea("cliff"+i);
		rmSetAreaSize(cliffID, rmAreaTilesToFraction(1000), rmAreaTilesToFraction(1000)); // current 800 : 450 1vs1 || 1400 800 ||
		rmSetAreaWarnFailure(cliffID, false);
		rmSetAreaCliffType(cliffID, "andes");
		rmAddAreaToClass(cliffID, rmClassID("classPlateau"));
		rmSetAreaCliffEdge(cliffID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffHeight(cliffID, rmRandInt(4,6), 1.0, 1.0);
		rmAddAreaConstraint(cliffID, cliffAvoidCliff);
		rmAddAreaConstraint(cliffID, cliffConstraint);
		rmAddAreaConstraint(cliffID, avoidNativesMed);
		rmAddAreaConstraint(cliffID, avoidIncaSocket);
		rmAddAreaConstraint(cliffID, cliffAvoidTreeline);
		rmAddAreaConstraint(cliffID, cliffAvoidTreelineShort);


		rmSetAreaCoherence(cliffID, 0.85);
		//rmSetAreaSmoothDistance(cliffID, 10);
		rmSetAreaObeyWorldCircleConstraint(cliffID, false);
		if(rmBuildArea(cliffID)==false)
		{
			// Stop trying once we fail 3 times in a row.
			failCount++;
			if(failCount==10)
				break;
		}
		else
			failCount=0;
	}
	
	
	/*
	==================
	Comments to Cliffs
	==================
	*/
	
	
	/*
	==================================
	Spawn players and startressources
	==================================
	*/	
	
	//spawn point and starting ressources...	
	
	
	//...explorer
	int playerStart = rmCreateStartingUnitsObjectDef(5.0);
    rmSetObjectDefMinDistance(playerStart, 7.0);
    rmSetObjectDefMaxDistance(playerStart, 12.0);
       
	//...gold  
    int goldID = rmCreateObjectDef("starting gold");
    rmAddObjectDefItem(goldID, "mine", 1, 0);
    rmSetObjectDefMinDistance(goldID, 16.0);
    rmSetObjectDefMaxDistance(goldID, 17.0);
	rmAddObjectDefConstraint(goldID, avoidTownCenterSmall);      
		
	//...trees	
    int treeID = rmCreateObjectDef("starting trees");
    rmAddObjectDefItem(treeID, "treeNewEngland", rmRandInt(15,20), 20.0);
    rmSetObjectDefMinDistance(treeID, 12.0);
    rmSetObjectDefMaxDistance(treeID, 18.0);
    rmAddObjectDefConstraint(treeID, avoidTownCenterForest);
    rmAddObjectDefConstraint(treeID, avoidCoinTree);
 
	//...herd
    int foodID = rmCreateObjectDef("starting hunt");
    rmAddObjectDefItem(foodID, "elk", rmRandInt(15,17), 14.0);
    rmSetObjectDefMinDistance(foodID, 10.0);
    rmSetObjectDefMaxDistance(foodID, 11.0);
    rmSetObjectDefCreateHerd(foodID, true);
	rmAddObjectDefConstraint(foodID, forestConstraintShort);
		
	//...treasure	
	int nuggetID = rmCreateObjectDef("nuggets");
	rmAddObjectDefItem(nuggetID, "Nugget", 1, 0.0); 
	rmSetObjectDefMinDistance(nuggetID, 20.0); 
	rmSetObjectDefMaxDistance(nuggetID, 30.0); 
    rmAddObjectDefConstraint(nuggetID, avoidTownCenterClose);      
	rmSetNuggetDifficulty(0,1); 
			
	//...place tc and ressources
    for(i=1; < cNumberNonGaiaPlayers + 1) 
	{
		int id=rmCreateArea("Player"+i);
		rmSetPlayerArea(i, id);
		int startID = rmCreateObjectDef("object"+i);
		rmAddObjectDefItem(startID, "TownCenter", 1, 0);
		rmAddObjectDefConstraint(startID, avoidIncaSocketTC);
		rmAddObjectDefConstraint(startID, avoidSocketTC);
		rmSetObjectDefMinDistance(startID, 0.0);
        rmSetObjectDefMaxDistance(startID, 3.0);
		rmPlaceObjectDefAtLoc(startID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		vector TCLoc = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startID, i));
		rmPlaceObjectDefAtLoc(nuggetID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));	
		rmPlaceObjectDefAtLoc(goldID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));	
        rmPlaceObjectDefAtLoc(treeID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
        rmPlaceObjectDefAtLoc(foodID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));		
        rmPlaceObjectDefAtLoc(playerStart, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		if(ypIsAsian(i) && rmGetNomadStart() == false)
			rmPlaceObjectDefAtLoc(ypMonasteryBuilder(i, 1), i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
	}
	
	


	
	
	
	/*
	=================
	global ressources
	=================
	*/
	
	//...traderoute area...
	//...trees	
	int forestrouteID = -1;
	failCount=0;
	if(cNumberNonGaiaPlayers == 4)//2vs2
	{
		numTries = 15;
	}else // 2 players
		numTries = 12;
	if(cNumberNonGaiaPlayers == 6)//3vs3
	{
		numTries = 30;
		for (i=0; <numTries)
		{   
			forestrouteID = rmCreateArea("forestrouteID"+i);
			rmSetAreaWarnFailure(forestrouteID, false);
			rmSetAreaSize(forestrouteID, rmAreaTilesToFraction(250), rmAreaTilesToFraction(250));
			rmSetAreaForestType(forestrouteID, "new england forest");
			rmSetAreaForestDensity(forestrouteID, 0.25);
			rmSetAreaForestClumpiness(forestrouteID, 0.25);		
			rmSetAreaForestUnderbrush(forestrouteID, 0.6);
			rmSetAreaMinBlobs(forestrouteID, 1);
			rmSetAreaMaxBlobs(forestrouteID, 4);						
			rmSetAreaMinBlobDistance(forestrouteID, 5.0);
			rmSetAreaMaxBlobDistance(forestrouteID, 15.0);
			rmSetAreaCoherence(forestrouteID, 0.4);
			rmSetAreaSmoothDistance(forestrouteID, 10);
			rmAddAreaToClass(forestrouteID, rmClassID("classForest"));
			rmAddAreaConstraint(forestrouteID, avoidTradeRouteSmall);
			rmAddAreaConstraint(forestrouteID, avoidSocket);
			rmAddAreaConstraint(forestrouteID, routeConstraint);

			if(rmBuildArea(forestrouteID)==false)
			{
				// Stop trying once we fail 5 times in a row.
				failCount++;
				if(failCount==10)
					break;
			}
			else failCount=0; 
		}
	}
	else
	{
		for (i=0; <numTries)
		{   
			forestrouteID = rmCreateArea("forestrouteID"+i);
			rmSetAreaWarnFailure(forestrouteID, false);
			rmSetAreaSize(forestrouteID, rmAreaTilesToFraction(400), rmAreaTilesToFraction(400));
			rmSetAreaForestType(forestrouteID, "new england forest");
			rmSetAreaForestDensity(forestrouteID, 0.5);
			rmSetAreaForestClumpiness(forestrouteID, 0.8);		
			rmSetAreaForestUnderbrush(forestrouteID, 0.7);
			rmSetAreaMinBlobs(forestrouteID, 1);
			rmSetAreaMaxBlobs(forestrouteID, 4);						
			rmSetAreaMinBlobDistance(forestrouteID, 5.0);
			rmSetAreaMaxBlobDistance(forestrouteID, 20.0);
			rmSetAreaCoherence(forestrouteID, 0.4);
			rmSetAreaSmoothDistance(forestrouteID, 10);
			rmAddAreaToClass(forestrouteID, rmClassID("classForest"));
			rmAddAreaConstraint(forestrouteID, avoidTradeRouteSmall);
			rmAddAreaConstraint(forestrouteID, avoidSocket);
			rmAddAreaConstraint(forestrouteID, routeConstraint);

			if(rmBuildArea(forestrouteID)==false)
			{
				// Stop trying once we fail 5 times in a row.
				failCount++;
				if(failCount==10)
					break;
			}
			else failCount=0; 
		}
	}
	
	
	
	
	
	//...few mines
	int routeGold = rmCreateObjectDef("route Gold");
	rmAddObjectDefItem(routeGold, "mine", 1, 0.0);
	rmSetObjectDefMinDistance(routeGold, 0.0);
	rmSetObjectDefMaxDistance(routeGold, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(routeGold, avoidCoinMed);
	rmAddObjectDefConstraint(routeGold, avoidSocket);
	rmAddObjectDefConstraint(routeGold, forestConstraintShort);
	rmAddObjectDefConstraint(routeGold, routeConstraint);
	rmPlaceObjectDefAtLoc(routeGold, 0, 0.5, 0.5, cNumberNonGaiaPlayers);
	
	
	
	//...cliff area
	//...trees	
	
	for (j=0; < (3*cNumberNonGaiaPlayers)) 
	{   
		int cliffTrees=rmCreateObjectDef("cliff Trees"+j);
		rmAddObjectDefItem(cliffTrees, "treeNewEngland", rmRandInt(5,6), rmRandFloat(10.0,13.0));
		rmAddObjectDefToClass(cliffTrees, rmClassID("classForest")); 
		rmSetObjectDefMinDistance(cliffTrees, 0);
		rmSetObjectDefMaxDistance(cliffTrees, rmXFractionToMeters(0.45));
		rmAddObjectDefConstraint(cliffTrees, forestConstraint);
		rmAddObjectDefConstraint(cliffTrees, avoidTownCenterSmall);	
		rmAddObjectDefConstraint(cliffTrees, avoidNativesClose);
		rmAddObjectDefConstraint(cliffTrees, avoidPlateau);	
		rmAddObjectDefConstraint(cliffTrees, cliffConstraint);
		rmPlaceObjectDefAtLoc(cliffTrees, 0, 0.5, 0.5, 5*cNumberNonGaiaPlayers);
	}	
	

	
	//...few lamas
	int llamaCount = (2*cNumberNonGaiaPlayers) + 2;
	for (i=0; <llamaCount)
	{
		int llamaID = rmCreateObjectDef("llama herd "+i);
		rmAddObjectDefItem(llamaID, "llama", rmRandInt(1,2), 10);
		rmSetObjectDefMinDistance(llamaID, 0.0);
		rmSetObjectDefMaxDistance(llamaID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(llamaID, avoidLlama);
		rmAddObjectDefConstraint(llamaID, avoidAll);
		rmAddObjectDefConstraint(llamaID, cliffConstraint);
		rmAddObjectDefConstraint(llamaID, avoidPlateau);		
		rmSetObjectDefCreateHerd(llamaID, false);
		rmPlaceObjectDefAtLoc(llamaID, 0, 0.5, 0.5);
	}
	
	
	//...top player area
	//...forest...
	
	
	if(cNumberNonGaiaPlayers == 6)
	{
		numTries = 35;
	}
	else if(cNumberNonGaiaPlayers == 4)
	{
		numTries = 25;
	}
	else numTries = 20;
	failCount = 0;
	for (i=0; <numTries)
	{   
		int foresttopID = rmCreateArea("foresttopID"+i);
		rmSetAreaWarnFailure(foresttopID, false);
		rmSetAreaSize(foresttopID, rmAreaTilesToFraction(300), rmAreaTilesToFraction(300));
		rmSetAreaForestType(foresttopID, "new england forest");
		rmSetAreaForestDensity(foresttopID, 0.7);
		rmSetAreaForestClumpiness(foresttopID, 0.7);		
		rmSetAreaForestUnderbrush(foresttopID, 0.7);
		rmSetAreaMinBlobs(foresttopID, 1);
		rmSetAreaMaxBlobs(foresttopID, 4);						
		rmSetAreaMinBlobDistance(foresttopID, 5.0);
		rmSetAreaMaxBlobDistance(foresttopID, 20.0);
		rmSetAreaCoherence(foresttopID, 0.4);
		rmSetAreaSmoothDistance(foresttopID, 10);
		rmAddAreaToClass(foresttopID, rmClassID("classForest"));
		rmAddAreaConstraint(foresttopID, avoidCoin);
		rmAddAreaConstraint(foresttopID, avoidTradeRouteSmall);
		rmAddAreaConstraint(foresttopID, avoidSocket);
		rmAddAreaConstraint(foresttopID, topConstraint);
		rmAddAreaConstraint(foresttopID, forestConstraint);
		rmAddAreaConstraint(foresttopID, avoidTownCenterForest);
		rmAddAreaConstraint(foresttopID, avoidPlateau);
		rmAddAreaConstraint(foresttopID, avoidNativesClose);
		rmAddAreaConstraint(foresttopID, avoidAll);
		if(rmBuildArea(foresttopID)==false)
		{
			// Stop trying once we fail 5 times in a row.
			failCount++;
			if(failCount==10)
				break;
		}
		else
			failCount=0; 
	}
	
		
	//...mines
	int topGold = rmCreateObjectDef("top Gold");
	rmAddObjectDefItem(topGold, "mine", 1, 0.0);
	rmSetObjectDefMinDistance(topGold, 0.0);
	rmSetObjectDefMaxDistance(topGold, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(topGold, avoidCoinMed);
	rmAddObjectDefConstraint(topGold, avoidPlateau);
	rmAddObjectDefConstraint(topGold, avoidSocket);
	rmAddObjectDefConstraint(topGold, avoidTownCenter);
	rmAddObjectDefConstraint(topGold, forestConstraintShort);
	rmAddObjectDefConstraint(topGold, avoidNativesClose);
	rmAddObjectDefConstraint(topGold, topConstraint);
	rmAddObjectDefConstraint(topGold, worldEdgeConstraintCoin);
	rmPlaceObjectDefAtLoc(topGold, 0, 0.5, 0.5, 2.5 * (cNumberNonGaiaPlayers));
	
	//...hunts		
	int topHunt = rmCreateObjectDef("top Hunts");
	rmAddObjectDefItem(topHunt, "deer", rmRandInt(16,20), 14.0);
	rmSetObjectDefCreateHerd(topHunt, true);
	rmSetObjectDefMinDistance(topHunt, 0);
	rmSetObjectDefMaxDistance(topHunt, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(topHunt, avoidTownCenterMore);
	rmAddObjectDefConstraint(topHunt, avoidHunt);
	rmAddObjectDefConstraint(topHunt, avoidPlateau);	
	rmAddObjectDefConstraint(topHunt, avoidNativesClose);
	rmAddObjectDefConstraint(topHunt, mediumShortAvoidImpassableLand);
	rmAddObjectDefConstraint(topHunt, topConstraint);
	rmAddObjectDefConstraint(topHunt, worldEdgeConstraint);
	rmPlaceObjectDefAtLoc(topHunt, 0, 0.5, 0.5, 3*(cNumberNonGaiaPlayers/2));
	

	
	//...bottom player area...
	//...trees...
	
	
	if(cNumberNonGaiaPlayers == 6)
	{
		numTries = 35;
	}
	else if(cNumberNonGaiaPlayers == 4)
	{
		numTries = 25;
	}
	else numTries = 20;
	failCount = 0;
	for (i=0; <numTries)
	{   
		int forestbottomID = rmCreateArea("forestbottomID"+i);
		rmSetAreaWarnFailure(forestbottomID, false);
		rmSetAreaSize(forestbottomID, rmAreaTilesToFraction(300), rmAreaTilesToFraction(300));
		rmSetAreaForestType(forestbottomID, "new england forest");
		rmSetAreaForestDensity(forestbottomID, 0.7);
		rmSetAreaForestClumpiness(forestbottomID, 0.7);		
		rmSetAreaForestUnderbrush(forestbottomID, 0.7);
		rmSetAreaMinBlobs(forestbottomID, 1);
		rmSetAreaMaxBlobs(forestbottomID, 4);						
		rmSetAreaMinBlobDistance(forestbottomID, 5.0);
		rmSetAreaMaxBlobDistance(forestbottomID, 20.0);
		rmSetAreaCoherence(forestbottomID, 0.4);
		rmSetAreaSmoothDistance(forestbottomID, 10);
		rmAddAreaToClass(forestbottomID, rmClassID("classForest"));
		rmAddAreaConstraint(forestbottomID, avoidTradeRouteSmall);
		rmAddAreaConstraint(forestbottomID, avoidSocket);
		rmAddAreaConstraint(forestbottomID, bottomConstraint);
		rmAddAreaConstraint(forestbottomID, forestConstraint);
		rmAddAreaConstraint(forestbottomID, avoidTownCenterForest);
		rmAddAreaConstraint(forestbottomID, avoidPlateau);
		rmAddAreaConstraint(forestbottomID, avoidNativesClose);
		rmAddAreaConstraint(forestbottomID, avoidCoin);
		rmAddAreaConstraint(forestbottomID, avoidAll);
		if(rmBuildArea(forestbottomID)==false)
		{
			// Stop trying once we fail 5 times in a row.
			failCount++;
			if(failCount==10)
				break;
		}
		else
			failCount=0; 
	}
	
	
	//...mines
	int bottomGold = rmCreateObjectDef("bottom Gold");
	rmAddObjectDefItem(bottomGold, "mine", 1, 0.0);
	rmSetObjectDefMinDistance(bottomGold, 0.0);
	rmSetObjectDefMaxDistance(bottomGold, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(bottomGold, avoidCoinMed);
	rmAddObjectDefConstraint(bottomGold, avoidPlateau);
	rmAddObjectDefConstraint(bottomGold, avoidSocket);
	rmAddObjectDefConstraint(bottomGold, avoidTownCenterForest);
	rmAddObjectDefConstraint(bottomGold, forestConstraintShort);
	rmAddObjectDefConstraint(bottomGold, avoidNativesClose);
	rmAddObjectDefConstraint(bottomGold, bottomConstraint);
	rmAddObjectDefConstraint(bottomGold, worldEdgeConstraintCoin);
	rmPlaceObjectDefAtLoc(bottomGold, 0, 0.5, 0.5, 2.5 * (cNumberNonGaiaPlayers));
	
	//...hunts
	int bottomHunt = rmCreateObjectDef("bottom Hunts");
	rmAddObjectDefItem(bottomHunt, "deer", rmRandInt(16,20), 14.0);
	rmSetObjectDefCreateHerd(bottomHunt, true);
	rmSetObjectDefMinDistance(bottomHunt, 0);
	rmSetObjectDefMaxDistance(bottomHunt, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(bottomHunt, avoidTownCenterMore);
	rmAddObjectDefConstraint(bottomHunt, avoidHunt);
	rmAddObjectDefConstraint(bottomHunt, avoidPlateau);	
	rmAddObjectDefConstraint(bottomHunt, avoidNativesClose);
	rmAddObjectDefConstraint(bottomHunt, mediumShortAvoidImpassableLand);
	rmAddObjectDefConstraint(bottomHunt, bottomConstraint);
	rmAddObjectDefConstraint(bottomHunt, worldEdgeConstraint);
	rmPlaceObjectDefAtLoc(bottomHunt, 0, 0.5, 0.5, 3*(cNumberNonGaiaPlayers/2));
	
	//treasures
	int spawnTreasure = rmCreateObjectDef("nugget2"); 
	rmAddObjectDefItem(spawnTreasure, "Nugget", 1, 0.0); 
	rmSetObjectDefMinDistance(spawnTreasure, 0.0); 
	rmSetObjectDefMaxDistance(spawnTreasure, rmXFractionToMeters(0.5)); 
	rmAddObjectDefConstraint(spawnTreasure, avoidNugget); 
	rmAddObjectDefConstraint(spawnTreasure, avoidTownCenter);
	rmAddObjectDefConstraint(spawnTreasure, forestConstraintShort);
	rmAddObjectDefConstraint(spawnTreasure, avoidTradeRouteSmall);
	rmAddObjectDefConstraint(spawnTreasure, avoidSocket); 
	rmAddObjectDefConstraint(spawnTreasure, avoidPlateau);	
	rmAddObjectDefConstraint(spawnTreasure, avoidNativesClose);
	rmSetNuggetDifficulty(1,1); 
	rmPlaceObjectDefAtLoc(spawnTreasure, 0, 0.5, 0.5, 6*cNumberNonGaiaPlayers);  
	
	
	/*
	================================
	Trigger and River reveal tryouts 
	================================
	*/
	
	/*
	int revealArea = rmCreateArea("revealArea");
	rmSetAreaLocation(revealArea, 0.5, 0.5);
	rmSetAreaSize(revealArea, 0.00015, 0.00015);
	rmBuildArea(revealArea);
	//Trigger
	for(j=1; <= cNumberNonGaiaPlayers) 
	{	
		rmCreateTrigger("RevealTrigger"+j);
	}
	
	rmSwitchToTrigger(rmTriggerID("RevealTrigger1"));
	//for(i=1; <= cNumberNonGaiaPlayers)
	//{
	rmAddTriggerEffect("Revealer : Create");
	rmSetTriggerEffectParamInt("PlayerID",1);
	rmSetTriggerEffectParam("RevealerName","default");
	rmSetTriggerEffectParam("RevealerLoc", revealArea);
	rmSetTriggerEffectParamFloat("RevealerLOS", 20.0);
	rmSetTriggerEffectParam("BlackmapOnly", false);
	//}
	rmSetTriggerPriority(4);
	rmSetTriggerActive(true);
	rmSetTriggerRunImmediately(true);
	rmSetTriggerLoop(false);
	*/
	
	/*
	int mainRiver = -1;
	mainRiver = rmRiverCreate(-1, "Seville", 5, 14, 12, 14);
	rmRiverSetShallowRadius(mainRiver, 8);
	rmRiverSetConnections(mainRiver, 0.5, 0.5, 0.2, 0.2);
	rmRiverAddShallow(mainRiver, 0.1);
	rmRiverBuild(mainRiver);
	rmRiverReveal(mainRiver, 2); 
	*/
	
	
	
}